  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP

goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

	
	rem call :READPARAMS
	
	set bat_detectfile_temp=%~1
	set bat_detectfile_filename=%~nx1
	set bat_detectfile_name=%~n1
	set bat_detectfile_dir=%~dp1::
	set bat_detectfile_dir=!bat_detectfile_dir:\::=!
	set bat_detectfile_dir=!bat_detectfile_dir:::=!

	call :DISPLAYCAMERALIST
	
	set bat_returncode=0
	call :READFILE "!bat_temp_detectfile!"
goto :DONE





	rem Loop to read the detect file.
	rem The goal is to extract from the detect file:
	rem  bat_ffdir, bat_caldir, bat_calfilename, bat_camera
:READFILE
!bat_pushlog! [CALL !bat_batchfile!:READFILE] "!bat_detectfile_temp!" [%*]
	set bat_retval=success

	rem !bat_log! if not exist "!bat_detectfile_temp!" 
	if not exist "!bat_detectfile_temp!" (
		!bat_echolog! '    ERROR 1 - Detect file "%~1" not found...
	)
	
	if not exist "!bat_detectfile_temp!" (
		!bat_log! '    [:READFILE] detect file "!bat_detectfile_temp!" does not exist
		!bat_log! '  ERROR 2 - cannot continue without an FTPdetectinfo file.
		!bat_log!
		!bat_log! '  The files have already been moved... you will need to move 
		!bat_log! '  them back and start over after resolving the problems.
		!bat_log!
		!bat_log! '  [:READFILE] ERROR - "!bat_readfile!" does not exist
		set bat_retval=failed
		goto :READFILE_END
	)
	
	
	set bat_calfilename=
	set bat_calfilename_prev=
	if exist "!bat_detectfile_dir!\CalFileList.log" (
		del "!bat_detectfile_dir!\CalFileList.log"
	)
	
	set bat_cameralist=
	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	!bat_echolog!
	!bat_echolog! This next step could take a long time if the meteor count is
	!bat_echolog! greater than 1,000.  Over that number, it gets exponentially
	!bat_echolog! longer to process. 


	if exist "junk.txt" (del /q "junk.txt")
	!bat_log! find /i ".txt" "!bat_detectfile_temp!"][sort}"junk.txt"
	          find /i ".txt" "!bat_detectfile_temp!"|sort>"junk.txt"

	!bat_echolog!
	set bat_temp=
	for /f "usebackq tokens=1-3 delims=:" %%a in (`find /i /c ".txt" "junk.txt"`) do (
		set bat_temp=%%b
	)
	!bat_echolog! There are !bat_temp! entries in the detect file, please wait... 
	set bat_temp=
	!bat_echolog!
	
	!bat_pushecho! [!time!]

	set /a bat_camerainstance=0
	rem !bat_pushecho! for /f "usebackq tokens=*" ..x in ^(`type "!bat_GCFC_tempfile!"`^) do ^(
	for                /f "usebackq tokens=*" %%x in  (`type "!bat_GCFC_tempfile!"`) do (
			set /a bat_linecount=0
			rem !bat_pushecho! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i "cal%%x_" "junk.txt"`^) do ^(
			for                /f "usebackq tokens=* skip=2" %%a in  (`find /i "cal%%x_" "junk.txt"`) do (
				set bat_temp=%%a
				set /a bat_linecount+=1
				set bat_calfilename=%%a
				set bat_camera_temp=!bat_temp:~3,3!
				
				rem echo !bat_calfilename! !bat_linecount!, !bat_camerainstance!
				
				if !bat_linecount! equ 1 (
					set /a bat_camerainstance+=1
					!bat_echolog! '  1. ADDING: "!bat_calfilename!" TO: "!bat_detectfile_dir!\CalFileList.log"
					rem set bat_calfilename_prev=!bat_calfilename!
					set bat_cameralist2=0!bat_camera_temp!

					if !bat_camerainstance! equ 1 (
						echo !bat_calfilename!>"!bat_detectfile_dir!\CalFileList.log"
					) else (
						echo !bat_calfilename!>>"!bat_detectfile_dir!\CalFileList.log"
					)
				)
			)
				!echolog! !bat_calfilename!
			rem !bat_popecho! ^)
	)
	!bat_popecho! [!time!]
	!bat_echolog!


%bat_COMMENT_BEGIN%
rem	!bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`find /v ".txt" "!bat_detectfile_temp!"][sort`^) do ...
rem	for               /f "usebackq tokens=* skip=2" %%a in  (`find /v ".txt" "!bat_detectfile_temp!"^|sort`) do 
	!bat_pushlog! for /f "usebackq tokens=* skip=4" ..a in ^(`find /v "" "junk.txt"`^) do ^(
	              for /f "usebackq tokens=* skip=4" %%a in  (`find /v "" "junk.txt"`) do (
		set bat_temp=%%a
		set /a bat_linecount+=1
		set bat_calfilename=%%a
		set bat_camera_temp=!bat_temp:~3,3!

		if !bat_linecount! equ 1 (
			!bat_log! '  1. ADDING: "!bat_calfilename!" TO: "!bat_detectfile_dir!\CalFileList.log"
			set bat_calfilename_prev=!bat_calfilename!
			set bat_cameralist2=0!bat_camera_temp!

			echo !bat_calfilename!>"!bat_detectfile_dir!\CalFileList.log"
		) else (
			call :CHECK_CALFILELIST "!bat_calfilename!"
			if not defined bat_calfilelist_found (
				!bat_log! '  2. ADDING: "!bat_calfilename!" TO: "!bat_detectfile_dir!\CalFileList.log"
				set bat_calfilename_prev=!bat_calfilename!
				set bat_cameralist2=!bat_cameralist2!0!bat_camera_temp!

				echo !bat_calfilename!}}"!bat_detectfile_dir!\CalFileList.log"
				echo !bat_calfilename!>>"!bat_detectfile_dir!\CalFileList.log"
			)
		)
	)
	!bat_popecho! [!time!]
%BAT_COMMENT_END%

	if !bat_linecount! equ 0 (
		!bat_log!
		!bat_log! '  ERROR - Failed to process the detect file: !bat_detectfile_temp!
		!bat_log! '  them back and start over after resolving the problems.
		!bat_log!
		!bat_log! '  ABORTING
		!bat_log!
		!bat_log! '  [This program could do that in a future update]
		!bat_log! '  [:READFILE] ERROR - ABORTING - Failed to process "!bat_detectfile_temp!"
		set bat_retval=failed
	) else (
		set bat_retval=success
	)

:READFILE_END
!bat_poplog! [RETURN !bat_batchfile!:READFILE] [!bat_retval!, bat_cameralist=!bat_cameralist!]
!bat_log!
!bat_return!










	rem Check "CalFileList.log" to see if %~1 already exists in the list
	rem Returns: bat_calfilelist_found=true if found, otherwise, it is undefined
:CHECK_CALFILELIST [in]  "!bat_calfilename!"
               rem [out] bat_calfilelist_found
rem echo [CALL !bat_batchfile!:CHECK_CALFILELIST] [%*]
	set bat_calfilelist_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_detectfile_dir!\CalFileList.log"`) do (
		if /i "%~1"  equ "%%x" (
			set bat_calfilelist_found=true
		)
	)
:CHECK_CALFILELIST_END
rem echo [RETURN !bat_batchfile!:CHECK_CALFILELIST] [%~1, bat_calfilelist_found=!bat_calfilelist_found!]
!bat_return!










	rem Displays the list of cameras.  Depends on GCFC.log file
	rem already being populated with the sorted list of cameras.
:DISPLAYCAMERALIST
!bat_pushlog! [CALL !bat_batchfile!:DISPLAYCAMERALIST] %*
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

		rem Display the list of cameras...
	!bat_log! CAM1 CAM2 CAM3 CAM4
	set bat_cameralist=
	for /f "usebackq tokens=1-4" %%a in ('!bat_CAPTURE.cameralist!') do (
		!bat_log! %%a, %%b, %%c, %%d
		if /i "%%a" neq "" (
			set bat_cameralist=0%%a
		)
		if /i "%%b" neq "" (
			set bat_cameralist=!bat_cameralist!0%%b
		)
		if /i "%%c" neq "" (
			set bat_cameralist=!bat_cameralist!0%%c
		)
		if /i "%%d" neq "" (
			set bat_cameralist=!bat_cameralist!0%%d
		)
	)
:DISPLAYCAMERALIST_END
!bat_poplog! [RETURN !bat_batchfile!:DISPLAYCAMERALIST] [!bat_cameralist!]
!bat_log!
!bat_return!










:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS] %*
	!bat_echolog! call "!bat_exedir!\ReadParams.bat"
				  CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!









:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "!bat_detectfile!"
	echo.
	echo.
exit /b 9



:DONE
!bat_poplog! :DONE with %~f0 %*
!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
rem dir "!bat_detectfile_dir!\CalFileList.log"
rem type "!bat_detectfile_dir!\CalFileList.log"

	ENDLOCAL & IF "%BAT_RETVAL%" NEQ "" (
		SET bat_retval=%bat_retval%
		SET bat_camera_list=%bat_cameralist2%
	) ELSE ( echo.%bat_retval%)
exit /b 0