 @echo off
	setlocal enableextensions enabledelayedexpansion

:SETUP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP



	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_camera=%~1
	set bat_duration=%~2
	set bat_targetlocation=%~3
	set bat_savetargetlocation=%~3

	
	
    call :SETCAPTUREEXE

goto :MAIN


:MAIN
	!bat_echolog! goto :MAIN %*
	rem call :CURDATETIME %*
	call :PRECAPTURE %*
	call :LAUNCHCAPTURE %*

	call :GETCAPTUREDIR %*
	if "!bat_retval!" neq "failed" (
		set bat_runautocams=!bat_retval!
		
		rem Perform multi-tasked Reprocess
		call :MULTISCAN
		call :WAITFORMULTISCAN
		call :GETARCHIVEDDIR %*
		call :MERGE
		call :GETDETECTFILE %*
		call :COPYARCHIVED %*

		call :READCONFIG
		call :SAVECONFIG

		!bat_echolog! '    AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
		                   AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
	)

:MAIN_END
goto :DONE


				!bat_echolog! call :MAIN %*
				rem call :CURDATETIME %*
				call :PRECAPTURE %*
				call :LAUNCHCAPTURE %*

				set bat_runautocams=
				call :GETCAPTUREDIR %*
				if "!bat_retval!" neq "failed" (
					set bat_runautocams=!bat_retval!
					call :GETARCHIVEDDIR %*
					call :GETDETECTFILE %*
					call :WAITCAPTUREDETECT %*
					call :COPYARCHIVED %*

					call :POSTCAPTURE %*
					if /i "!bat_retval!" neq "postcapture success" (goto :DONE)

					!bat_echolog! '    AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
									   AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
				)





						:CURDATETIME
						!bat_echolog! call :CURDATETIME %*
							set ftp_wmdy=%date%

							set ftp_hhmmssdd=%time%

							set ftp_year=%ftp_wmdy:~-4%
							set ftp_mo=%ftp_wmdy:~4,2%
							set ftp_mo2=%ftp_mo%
							if %ftp_mo% LSS 10 (
								set ftp_mo2=!ftp_mo:~-1!
							)
							set ftp_da=%ftp_wmdy:~7,2%
							set ftp_da2=%ftp_da%
							if %ftp_da% LSS 10 (
								set ftp_da2=!ftp_da:~-1!
							)

							set ftp_hr=%ftp_hhmmssdd:~0,2%
							set ftp_mi=%ftp_hhmmssdd:~3,2%
							set ftp_se=%ftp_hhmmssdd:~6,5%

							call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
							rem set /a ftp_jd=%ftp_jd%-1
							call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2

						%bat_echolog% return-:CURDATETIME [%ftp_jd%]
						!bat_return



rem start /min sndrec32 /play /close %windir%\media\ding.wav




:PRECAPTURE
	%bat_echolog% call :PRECAPTURE %*
		set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	
		rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
		rem ordered ascending by date. The last one will be the one created by the 
		rem FTP_CaptureAndDetect.exe program.
		set bat_precaptureddir=
		!bat_echolog! '    for /f "usebackq tokens=*"  a in ^(`dir "!bat_targetsearchspec!" /ad /b`^) do...
		for                    /f "usebackq tokens=*" %%a in (`dir "!bat_targetsearchspec!" /ad /b`) do (
			if /i "%%~nxa" neq "movies" (
				if /i "%%~nxa" neq "displayJPEGS" (
					if /i "%%~nxa" neq "gefdat" (
								 set bat_precaptureddir=!bat_targetsearchspec!\%%~nxa
					)
				)
			)
		)
		
		if not defined bat_precaptureddir (set bat_precaptureddir= )
		
		
		set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
		set bat_precaptureddirarch=
		!bat_echolog! '     for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
		for                     /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
			if /i "%%~nxa" neq "movies" (
				if /i "%%~nxa" neq "displayJPEGS" (
					if /i "%%~nxa" neq "gefdat" (
								 set bat_precaptureddirarch=!bat_targetsearchspec!\%%~a
					)
				)
			)
		)
		
		if not defined bat_precaptureddirarch (set bat_precaptureddirarch= )
		

:PRECAPTURE_END
!bat_echolog! return-:PRECAPTURE [bat_precaptureddir="!bat_precaptureddir!", bat_precaptureddirarch="!bat_precaptureddirarch!"] %*
!bat_return!





:LAUNCHCAPTURE
	!bat_echolog! call :LAUNCHCAPTURE %*
	!bat_echolog!
	!bat_echolog! '    Killing any existing FTP_CaptureAndDetect.exe processes that might be running...
	!bat_echolog! '    [%date% %time%] - calling process -k !bat_captureexe!
	call process -k !bat_captureexe!

	call :COPYEXE

	!bat_echolog!
	!bat_echolog! '    Starting !bat_captureexe!...
	!bat_echolog! '    [%date% %time%] "!bat_captureexe! start" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!
	            title "[%date% %time%]  !bat_captureexe! start" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!

	!bat_echolog! '    set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!
	                   set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!

	rem Determine if an input file is needed to answer the input question in case
	rem there are multiple video inputs
	set bat_entervideodevice=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\entervideodevice*.inp" /a-d /b`) do (
		set bat_entervideodevice=%%a
	)

	if not defined bat_entervideodevice (
		!bat_echolog! '    !bat_launchcommand!
						   !bat_launchcommand!
	) else (
	     !bat_echolog! '    !bat_launchcommand!^<"!bat_exedir!\!bat_entervideodevice!"
	                        !bat_launchcommand!<"!bat_exedir!\!bat_entervideodevice!"
	)& rem if not defined bat_entervideodevice

:LAUNCHCAPTURE2
	!bat_echolog! ________________________________________________________________________
	!bat_echolog! ________________________________________________________________________
	!bat_echolog! ________________________________________________________________________
	!bat_echolog! [%date% %time%] "END !bat_captureexe!" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!

	
:LAUNCHCAPTURE_END
!bat_echolog! return-:LAUNCHCAPTURE
%bat_return%





:GETCAPTUREDIR [in] %* 
	!bat_echolog! call :GETCAPTUREDIR %*
	rem [out] bat_retval
	rem [out] bat_captureddir
	rem [out] bat_captureddate

	set bat_retval=failed
	
	rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
	rem created.  It looks at all the subdirs of the CaptureFiles dir in date order.  The last 
	rem one in the list should be the most recent FTP_CaptureAndDetect directory.

	rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  Careful, there is a chance that it didn't 
	rem create a directory at all and you'd be choosing the wrong dir. Compare with 
	rem bat_precaptureddir to protect against that. 

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	set bat_targetsearchdir=
	set bat_captureddir=
	set bat_captureddirname=
	set bat_capturedbasedir=
	set bat_captureddate=
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem Example: bat_captureddir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					set bat_captureddir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_captureddirname=2012_01_18_01_00_13
					set bat_captureddirname=%%~nxa

					rem Example: bat_targetsearchdir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					set bat_targetsearchdir=!bat_targetsearchspec!\%%~a

					rem example: bat_capturedbasedir=C:\CAMS\CapturedFiles
					set bat_capturedbasedir=%%~dpa::
					set bat_capturedbasedir=!bat_capturedbasedir:\::=!
					set bat_capturedbasedir=!bat_capturedbasedir:::=!
				)
			)
		)
	)

	!bat_echolog! '    if not defined bat_captureddir ^(
	if not defined bat_captureddir (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new directory. Interpreting that as a
		!bat_echolog! '    capture failure or manual abort. 
	)
	
	!bat_echolog! '    if /i "!bat_captureddir!" equ "!bat_precaptureddir!" ...
	if                    /i "!bat_captureddir!" equ "!bat_precaptureddir!" (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new directory. Interpreting that as a
		!bat_echolog! '    capture failure. 
	) else (
		set bat_retval=!bat_captureddir!
		!bat_echolog!
		!bat_echolog! '    bat_captureddir=!bat_captureddir!
		!bat_echolog! '    bat_captureddirname=!bat_captureddirname!
		!bat_echolog! '    bat_targetsearchdir=!bat_targetsearchdir!


		rem Example: bat_captureddate=2012_01_18
		set bat_captureddate=!bat_captureddirname:~0,10!

		set bat_cap>>"!bat_logfile!"
	)
	
:GETCAPTUREDIR_END
!bat_echolog! return-:GETCAPTUREDIR [!bat_retval!, bat_captureddir=!bat_captureddir!, bat_captureddate=!bat_captureddate!]
%bat_return%




:MULTISCAN
	!bat_echolog! call :MULTISCAN
rem set bat_targetsearchspec=!bat_targetsearchspec!\2011_12_22_01_31_3?
	set bat_targetsearchspec

	set bat_targetcount=0
	if exist "!bat_captureddir!\*.bin" (
		!bat_echolog! '    for /f "usebackq tokens=*" %%b in ^(`dir "!bat_captureddir!\*.bin" /a-d /b^|find /i /c ".bin"`^) do ^(
		for                    /f "usebackq tokens=*" %%b in  (`dir "!bat_captureddir!\*.bin" /a-d /b^|find /i /c ".bin"`) do (
			set /a bat_targetcount=%%~b
		)
	) else (
		!bat_echolog! '    ERROR - no .BIN files found in "!bat_captureddir!"
	)

	!bat_echolog! '    [File Count=!bat_targetcount!]    !bat_captureddir!
	!bat_echolog!
	
	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	call :READCONFIG
	call :SAVECONFIG

:MAKERERUNFILE
	set bat_rerunfile=!bat_captureddir!\rerun_makeCaseListing.bat
	echo.>"!bat_rerunfile!"
	echo @echo off>>""!bat_rerunfile!""
	echo setlocal enableextensions enabledelayedexpansion>>""!bat_rerunfile!""
	for /f "usebackq tokens=*" %%a in (`set`) do (
		echo set %%~a>>""!bat_rerunfile!""
	)
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!">>""!bat_rerunfile!""
	

	!bat_echolog! '    call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!" autonomous
	                   call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!" autonomous

:MULTISCAN_END
%bat_return%




:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo :WAITFORMULTISCAN Waiting 60 seconds for makeCaseListing.bat to finish
	start /w wait 60

	set bat_archivedsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles\!bat_captureddate!*.*
	set bat_archivedsearchspec
	
	!bat_echolog! '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedsearchspec!" /ad /s/b`) do (
		set bat_archiveddir=%%~nxa
		set bat_archivedfilesdir=%%~nxa
		!bat_echolog! '    bat_archiveddir=!bat_archiveddir!
	)

	!bat_echolog! '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`) do (
		echo call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
		echo.
		echo     FINISHED with: "%%a"
	)

:WAITFORMULTISCAN_END
%bat_return%





:MERGE
	!bat_echolog! '    call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archiveddir!"
	                   call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archiveddir!"
%bat_return%




:GETARCHIVEDDIR [out] bat_archiveddir
	!bat_echolog! call :GETARCHIVEDDIR %*

	rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
	rem created for ArchivedFiles.  

	rem This FOR loop will complete with the newest directory with the specified date
	rem as the prefix.  Even if there are multiple directories with the same date, the 
	rem newest one be contained in resulting value of bat_archiveddir.

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  CAREFUL, there is a chance that
	rem there is no matching ArchivedFiles dir. 

	set bat_targetsearchdir=
	set bat_archiveddir=
	set bat_archiveddirname=
	set bat_archivedbasedir=
	set bat_archiveddate=
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od^|find /i "!bat_captureddate!"`^) do...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od^|find /i "!bat_captureddate!"`) do (
	if /i "%%~nxa" neq "movies" (
		if /i "%%~nxa" neq "displayJPEGS" (
			if /i "%%~nxa" neq "gefdat" (
					rem Example: bat_archiveddir=C:\CAMS\CapturedArchivedFiles\2012_01_18_01_00_13
					set bat_archiveddir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_archiveddirname=2012_01_18_01_00_13
					set bat_archiveddirname=%%~nxa

					rem Example: bat_targetsearchdir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
					set bat_targetsearchdir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_archivedbasedir=C:\CAMS\ArchivedFiles
					set bat_archivedbasedir=!bat_targetsearchspec!
				)
			)
		)
	)

	!bat_echolog! '    if not defined bat_archiveddir ^(
	if                    not defined bat_archiveddir (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new ArchivedFiles directory.
		!bat_echolog! '            Interpreting that as a capture failure or manual abort. 
	)
	
	!bat_echolog! '    if /i "!bat_archiveddir!" equ "!bat_precaptureddirarch!" ^(
	if                    /i "!bat_archiveddir!" equ "!bat_precaptureddirarch!" (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new ArchivedFiles directory.
		!bat_echolog! '            Interpreting that as a capture failure or manual abort. 
	) else (
		set bat_retval=!bat_archiveddir!
		rem Example: bat_archiveddate=2012_01_18
		set bat_archiveddate=!bat_archiveddirname:~0,10!

		!bat_echolog!
		!bat_echolog! '    bat_targetsearchdir=!bat_targetsearchdir!
		!bat_echolog! '    bat_archiveddir=!bat_archiveddir!
		!bat_echolog! '    bat_archiveddirname=!bat_archiveddirname!
		!bat_echolog! '    bat_archiveddate=!bat_archiveddate!
	)
	
	set bat_archived

:GETARCHIVEDDIR_END
!bat_echolog! return-:GETARCHIVEDDIR [!bat_archiveddir!]
%bat_return%






:GETDETECTFILE
	!bat_echolog! call :GETDETECTFILE %*

	set bat_detectfile=!bat_archiveddir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_detectfile!" (
		set bat_detectfile=!bat_archiveddir!\FTPdetectinfo.txt
	)
	
	for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfile!" /b /a-d /od`) do (
		set bat_detectfile=!bat_archiveddir!\%%~nxa
		set bat_detectfile3=%%~na
		set bat_detectfile4=%%~nxa
	)

:GETDETECTFILE_END
!bat_echolog! return-:GETDETECTFILE [!bat_detectfile!]
%bat_return%





:WAITCAPTUREDETECT
echo :WAITCAPTUREDETECT %*
	echo     WaitForFile rw "!bat_detectfile!"
	         WaitForFile rw "!bat_detectfile!"
	echo.
	echo     "!bat_detectfile!" is ready to use...
	echo.
!bat_echolog! return-:WAITCAPTUREDETECT
%bat_return%






:COPYARCHIVED
!bat_echolog! call :COPYARCHIVED %*
	echo     copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"
	         copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"
	set bat_returncode=!errorlevel!

rem	echo     move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"
rem	         move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"

rem	set bat_detectfile=!bat_archiveddir!\FTPdetectinfo.txt
rem	set bat_detectfile3=FTPdetectinfo
rem	set bat_detectfile4=FTPdetectinfo.txt
!bat_echolog! return-:COPYARCHIVED [!bat_returncode!]
%bat_return%








:POSTCAPTURE
!bat_echolog! call :POSTCAPTURE %*
	set bat_retval=postcapture success

	if not exist "!bat_detectfile!" (
		!bat_echolog! '    "!bat_logfile!"
		!bat_echolog!
		!bat_echolog! '    ERROR - detect file "!bat_detectfile!" not found...
		!bat_echolog!
		dir "!bat_archiveddir!\ftpdetect*.*" /s/b /a-d /od>>"!bat_logfile!"
		dir "!bat_archiveddir!\ftpdetect*.*" /s/b /a-d /od
		set bat_retval=postcapture failed
		goto :POSTCAPTURE_END
	)

	set bat_capturedcount=0
	if exist "!bat_captureddir!\*.bin" (
		!bat_echolog! '    for /f "usebackq tokens=*" %%b in ^(`dir "!bat_captureddir!\*.bin" /a-d /s/b^|find /i /c ".bin"`^) do ^(
		for                    /f "usebackq tokens=*" %%b in  (`dir "!bat_captureddir!\*.bin" /a-d /s/b^|find /i /c ".bin"`) do (
			set /a bat_capturedcount=%%~b
		)
	)
	!bat_echolog! '    [File count=!bat_capturedcount!]    !bat_captureddir!
	!bat_echolog!

	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!

	call :READCONFIG
	call :SAVECONFIG

:POSTCAPTURE_END
!bat_echolog! return-:POSTCAPTURE [!bat_retval!, !bat_captureddir!]
!bat_return!









							:CAMSMENU
								call :SAVECONFIG
								echo start CamsMenu.bat>>"!bat_logfile!"
								echo start CamsMenu.bat
									 start CamsMenu.bat
							%bat_return%


							:POSTMULTISCAN
								echo call PostMultiScanCalibration.bat "!bat_archiveddir!">>"!bat_logfile!"
								echo call PostMultiScanCalibration.bat "!bat_archiveddir!"
									 call PostMultiScanCalibration.bat "!bat_archiveddir!"
							%bat_return%






:READCONFIG
!bat_echolog! call :READCONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	if defined bat_autonomous (
		set bat_configfile=!bat_exedir!\AutoCams.bat.ini
		!bat_echolog! 
	)
	
	rem echo [CAMSMENU]^>"!bat_configfile!"
	rem call readini "!bat_configfile!" "CAMSMENU" "bat_targetlocation"
	rem echo bat_targetlocation=!bat_targetlocation!^>^>"!bat_configfile!"
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_camera"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_camera"
		set bat_camera_config=!RetVal1!
	rem echo bat_captureddate=!bat_captureddate!^>^>"!bat_configfile!"
	rem echo bat_capturedfilesdir=!bat_capturedfilesdir!^>^>"!bat_configfile!"
	rem echo bat_archivedfilesdir=!bat_archivedfilesdir!^>^>"!bat_configfile!"
	rem echo bat_capturedcount=!bat_capturedcount!^>^>"!bat_configfile!"
	rem echo bat_archivedcount=!bat_archivedcount!^>^>"!bat_configfile!"
	rem echo bat_latestcal=!bat_latestcal!^>^>"!bat_configfile!"
	rem echo bat_submissionfilesdir=!bat_submissionfilesdir!^>^>"!bat_configfile!"
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftppassword"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftppassword"
		set bat_ftppassword=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpsite"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpsite"
		set bat_ftpsite=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpuser"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpuser"
		set bat_ftpuser=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpdir"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpdir"
		set bat_ftpdir=!RetVal1!
!bat_echolog! return-:READCONFIG [!bat_capturedfilesdir!]
%bat_return%


:SAVECONFIG
!bat_echolog! call :SAVECONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	if defined bat_autonomous (
		set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	)

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"

	set bat_capturedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_captureddir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_capturedcount=%%~a
	)
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	set bat_archivedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_archivedcount=%%~a
	)
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=>>"!bat_configfile!"
	echo bat_submissionfilesdir=>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
!bat_echolog! return-:SAVECONFIG [!bat_capturedfilesdir!]
%bat_return%



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0





:SETCAPTUREEXE
	!bat_echolog! call :SETCAPTUREEXE %*
rem	echo if exist "!bat_exedir!\FTP_Capture.bat.ini" ....
	if      exist "!bat_exedir!\FTP_Capture.bat.ini" (
		set bat_captureexesrc=FTP_Capture.exe
		set bat_captureexe=FTP_Capture_!bat_camera!.exe
		set bat_capturebat=FTP_Capture.bat
		set bat_CD_flag=
		!bat_echolog! '    "!bat_exedir!\FTP_Capture.bat.ini" exists so
		!bat_echolog! '    using FTP_Capture instead of FTP_CapturedAndDetect.
	) else (
		set bat_captureexesrc=FTP_CaptureAndDetect.exe
		set bat_captureexe=FTP_CaptureAndDetect_!bat_camera!.exe
		set bat_capturebat=CaptureAndDetect.bat
	)

:SETCAPTUREEXE_END
	!bat_echolog! return-:SETCAPTUREEXE [src=!bat_captureexesrc!, dest=!bat_captureexe!]
!bat_return!



:COPYEXE
	!bat_echolog! call :COPYEXE %*
	!bat_echolog! '    copy /y "!bat_exedir!\!bat_captureexesrc!" "!bat_exedir!\!bat_captureexe!"
	                   copy /y "!bat_exedir!\!bat_captureexesrc!" "!bat_exedir!\!bat_captureexe!"
:COPYEXE_END 
	!bat_echolog! return-:COPYEXE [!bat_captureexe!]
!bat_return!









:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%






:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     %~n0 can be run by double-clicking on the program from 
    echo     Windows or from a command line.
    echo.
    echo     Starting it from Windows, it will run it in interactive mode 
    echo     where it will prompt the user for the camera number and the 
    echo     duration of the capture in hours.  
    echo.
    echo     If the duration entered is zero, then the user is prompted to 
    echo     manually start and stop the capture process.  If the duration 
    echo     is greater than zero, the program automatically starts the 
    echo     capture and stops after the designated time has elapsed. 
    echo.
    echo     If you run it from a command shell or batch script, you 
    echo     can specify the camera number and duration as command-line 
    echo     arguments.  If the command-line arguments don't provide all 
    echo     the necessary parameters, the missing parameters will be 
    echo     prompted for.
    echo.    
    echo     Usage: %~nx0 [cameranumber] [duration] ["targetdirectory"] [/?]
    echo.
    echo     Examples:
    echo         FTP_Capture
    echo                                          The user is prompted for 
    echo                                          camera number, duration, 
    echo                                          and base target dir.
    echo.
    echo         FTP_Capture 299                  The user is prompted for 
    echo                                          capture duration and base 
    echo                                          target dir.
    echo.
    echo         FTP_Capture 299 0.0              The user is prompted for 
    echo                                          for the base target dir and
    echo                                          prompted to start and stop. 
    echo.
    echo         FTP_Capture 299 9.5              The user is prompted for 
    echo                                          the base target dir. 
    echo.
    echo         FTP_Capture 213 8.5 "h:"   The capture for camera 299
    echo                                          starts and runs for 9 hrs  
    echo                                          and 30 mins and saves the
    echo                                          data to a directory like:
    echo                      D:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05
    echo.
    echo     Note: Directory names should be surrounded by quotes.
    echo.
    echo     A folder is created for saving the FF files based on the date and 
    echo     universal time (UTC) at the start of the capture.  The higher level 
    echo     directory is always user specified and the \CAMs\CapturedFiles\ is 
    echo     appended along with the start date and time.  For example, a 
    echo     capture that starts on Aug 14, 2011, 5:11:05 UTC and the target 
    echo     directory specified was "C:", the target directory would be created 
    echo     as C:\CAMS\CapturedFiles\2011_08_14_05_11_05.  If the target dir
    echo     of "D:\2011" is specified, the target directory would be created as:
    echo     C:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05.  
    echo.
EXIT /b 9
    
goto :DONE


:DONE
echo END OF %~nx0  ******  [%date% %time%]>>"!bat_logfile!"
exit /b 0
rem exit
