  @echo off
setlocal enabledelayedexpansion enableextensions

	rem NEEDS:
	rem       - 13. If submit.email.bat fails to create a Submit dir, then abort.

:CHECKHELP


	echo.%*|find /i "/?">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:


	
:SETUP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	set bat_ftp_dest_dir=!bat_exedir!\Temp
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_exedir!\Cal
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log


	rem call :READPARAMS
	call :READCONFIG&	rem Note: ReadConfig calls this...	call :GETCONFIRMEDCOUNT

	set bat_returncode=0

	!bat_logexeclog! type "!bat_paramsfile!"
	!bat_logexeclog! type "!bat_configfile!"
	!bat_logexeclog! set bat_

	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	
	call :PARSEARGS %*

	goto :MAIN
	
goto :MAIN




:MAIN
	call :DOWNLOADFTP
:MAIN_END
goto :DONE
!bat_return!

	
:PARSEARGS
	echo.%*|find /i "autonomous"
	if !errorlevel! equ 0 (set bat_autonomous=autonomous)

!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*

:PARSEARGS_END
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [!bat_getdirname!, !bat_mainspec!]
!bat_log!
!bat_return!






	rem 17. Upload Zip via FTP ************************************
:DOWNLOADFTP
!bat_pushlog! [CALL !bat_batchfile!:DOWNLOADFTP] %*
	set bat_retval=failed

		rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
		rem and the question won't be asked again.
	if /i "!bat_ftppassword!" equ "" (
		!bat_echolog!
		!bat_echolog!
		set bat_choice=
		!bat_log! set /P bat_choice=Enter your email address as the anonymous FTP password: 
		set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: 
		set bat_ftppassword=!bat_choice!
		!bat_log! set bat_ftppassword=!bat_ftppassword!
		call :SAVECONFIG
	)

	!bat_logexeclog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt

		rem Handle the case where the FTP file has already been downloaded. 
		rem No sense in downloaded over the top of an existing file.  
		rem So, we need to list all the existing 
		rem zip files on the server (in ascending date order), check each
		rem against whether it exists locally, then download the remaining ones.
	!bat_logexeclog! set bat_zipfile=????_??_??_*.zip
	!bat_logexeclog! set bat_zip=!bat_zipfile!

	call :FTPTRANSFER
	
	!bat_logexeclog! set bat_zipfile=CAMS_Svl_FTPdetectinfo_????_??_??*.zip
	!bat_logexeclog! set bat_zip=!bat_zipfile!
	call :FTPTRANSFER

:DOWNLOADFTP_END
!bat_poplog! [RETURN !bat_batchfile!:DOWNLOADFTP] [!bat_retval!, !bat_returncode!, "!bat_zipfile!" !bat_recent_error_msg!]
	if not defined bat_autonomous (pause)
!bat_log!
!bat_return!









	rem Check for existing files on the server and download only those
	rem that don't match file names locally. 
:FTPTRANSFER
!bat_pushlog! [CALL !bat_batchfile!:FTPTRANSFER
	!bat_logexeclog! set bat_retval=failed

		rem The downloaded files go to this dir.
	if not exist "!bat_exedir!\Temp!" (
		!bat_logexeclog! md "!bat_exedir!\Temp!"
	)


		REM Create the ftp command file for listing the existing
		REM files that match the spec.
	!bat_logexeclog! set bat_ftpfile2=!bat_ftpfile:~0,-4!_2.txt
	if exist "!bat_ftpfile2!" (
		!bat_logexeclog! del /q "!bat_ftpfile2!"
	)
	
	!bat_echolog! "!bat_ftpfile2!"
	!bat_echolog!

	!bat_echolog! Now download a list of files using the "ls" ftp command file "!bat_ftpfile!"...
	!bat_pushecho!
	!bat_log! '    Note: Building the .ftp.temp_2.txt" file...
	
		echo user !bat_ftpuser!>"!bat_ftpfile!"
		echo !bat_ftppassword!>>"!bat_ftpfile!"
		echo bin>>"!bat_ftpfile!"
		echo cd !bat_ftpdir!>>"!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo ls "!bat_zipfile!">>!bat_ftpfile!"
		echo quit>>"!bat_ftpfile!"
		

			rem I had to come up with a workaround for a silly problem where the 
			rem creation of the listing file has 0D 0D 0A instead of 0D 0A.
			rem Therefore, I had to use a delimted file...
		!bat_pushecho! for /f "usebackq tokens=* skip=1" ..a in ^(`call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!][find /i ".zip"`^) do ^(
		for                /f "usebackq tokens=* skip=1" %%a in  (`call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!^|find /i ".zip"`) do (
			set bat_temp=%%a
			set bat_temp=!bat_temp:~0,-1!
			echo.!bat_temp!^^!0 >>"ftp.temp_2.txt"
		)
		!bat_popecho! ^)
		
		if not exist "ftp.temp_2.txt" (
			!bat_echolog! No matching files on server: "!bat_zipfile!"
			goto :FTPTRANSFER_END
		)

		if exist "ftp.temp_3.txt" (
			!bat_logexeclog! del /y "ftp.temp_3.txt"
		)

		!bat_pushecho! for /f "usebackq tokens=1 delims=!" ..a in ^("ftp.temp_2.txt"^) do ^(
		for                /f "usebackq tokens=1 delims=!" %%a in ("ftp.temp_2.txt") do (
			echo.%%a>>"ftp.temp_3.txt"
		)
		!bat_popecho! ^)
		
		!bat_logexeclog! move /y "ftp.temp_3.txt" "ftp.temp_2.txt"

		!bat_pushecho! for /f "usebackq" ..a in ^("ftp.temp_2.txt"^) do ^(
		for                /f "usebackq" %%a in ("ftp.temp_2.txt") do (
			!bat_echolog! %%a
		)
		!bat_popecho! ^)

	!bat_popecho!

rem !bat_pause! CHECK THE ZIP FILES AND THE ZIP DIR
	!bat_echolog! Now download the files that don't exist locally to ".\Temp" and test them...
	!bat_pushecho!
		set /a bat_count=0
		for /f "usebackq tokens=*" %%a in (`type "!bat_ftpfile2!"`) do (
			if not exist "!bat_exedir!\Temp\%%a" (
				set /a bat_count+=1
				!bat_pushecho! Downloading "!bat_exedir!\Temp\%%a"...
					echo user !bat_ftpuser!>"!bat_ftpfile!"
					echo !bat_ftppassword!>>"!bat_ftpfile!"
					echo bin>>"!bat_ftpfile!"
					echo cd !bat_ftpdir!>>"!bat_ftpfile!"
					echo literal pasv>>"!bat_ftpfile!"
					echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
					echo literal pasv>>"!bat_ftpfile!"
					echo get "%%a">>!bat_ftpfile!"
					echo quit>>"!bat_ftpfile!"

					!bat_logexec! type "!bat_ftpfile!"

					!bat_echolog! '..............................................

					!bat_logexec! call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
					set bat_returncode=!bat_logexec_returncode!

					!bat_echolog!
					!bat_echolog! '    FTP exit code=!bat_returncode!
					!bat_echolog!

					call :CHECK_GET "!bat_exedir!\Temp\%%a" "%%a"
				!bat_pop!
			) else (
				!bat_echolog! Already exists: "!bat_exedir!\Temp\%%a"
				
				rem call :CHECK_GET "!bat_exedir!\Temp\%%a" "%%a"
				if /i "!bat_retval!" equ "failed" (
					rem 
				)
			)
			
			!bat_echolog!
			!bat_echolog! Done with %%a
			!bat_echolog!
rem !bat_pause! CHECK THE TEMP DIR [type "!bat_exedir!\Temp\!bat_zipfile!]
		)

	                   
	!bat_popecho!
rem !bat_pause! CHECK THE TEMP DIR [type "!bat_exedir!\Temp\!bat_zipfile!]
goto :FTPTRANSFER_END	

:FTPTRANSFER_END
!bat_poplog! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
!bat_return!





:CHECK_GET "!bat_exedir!\Temp\!bat_zip!" "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:CHECK_GET] %*
	!bat_logexeclog! set bat_checkget_zip=%~1
	!bat_logexeclog! set bat_checkget_zipfile=%~nx1
	
	if not exist "!bat_checkget_zip!" (
		set bat_recent_error_msg=17.ERROR - Failed FTP download of "!bat_checkget_zipfile!" - can't find it in "!bat_exedir!\Temp".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	)

	if not exist "!bat_exedir!\Temp\Zip" (
		md "!bat_exedir!\Temp\Zip"
	)

	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
		!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
	)
	
	!bat_logexeclog! md "!bat_exedir!\Temp\Zip"
rem !bat_pause! Check if this dir exists: "!bat_exedir!\Temp\Zip"
	!bat_logexeclog! copy /y "!bat_checkget_zip!" "!bat_exedir!\Temp\Zip"
rem !bat_pause! Check if this file exists: "!bat_exedir!\Temp\Zip\!bat_checkget_zipfile!"


	call :FTP_TESTZIP "!bat_exedir!\Temp\Zip\!bat_checkget_zipfile!"
	if /i "!bat_returncode!" neq "0" (
		del /q /f "!bat_exedir!\Temp\Zip\!bat_checkget_zip!"
		goto :CHECK_GET_END
	)


	!bat_log!

	set bat_retval=success
	set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! '    !bat_recent_error_msg!
	!bat_echolog!
	!bat_echolog!


:CHECK_GET_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_GET] []
!bat_return!






:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

	!bat_echolog! 'Test the zip file before uploading to ensure that it's good.
	!bat_echolog! 'The test involves:
	!bat_echolog! '  - The zip file must exist;
	!bat_echolog! '  - The hash code must not be the empty zip file hash
	!bat_echolog! '    If so, the zip file will be deleted.
	!bat_echolog! '  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
	!bat_echolog! '    is cleaned out before unzipping]
	!bat_echolog! '  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
	!bat_echolog! '  - If there are no other errors, the 

	if not exist "%~1" (
		set bat_returncode=98
		set bat_recent_error_msg=17.ERROR - Not found: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

	call :FTPHASH "%~1"
	if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
		set bat_returncode=99
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_logexec! del /q "%~1"
		goto :FTP_TESTZIP_END
	) else (
		!bat_echolog! '    not a blank zip file...
	)

%BAT_COMMENT_BEGIN%	
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
		!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
	)
%BAT_COMMENT_END%

	!bat_log! // Unzip the file to "..\Temp\Zip" and check for errorlevel

rem !bat_pause! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
	set bat_returncode=!bat_logexec_returncode!
	!bat_echolog! bat_returncode=!bat_returncode!
rem !bat_pause! move /y "%~1" "!bat_exedir!\Temp"

	!bat_log! // Cleanup after unzipping...
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_logexeclog! move /y "%~1" "!bat_exedir!\Temp"
rem !bat_pause! del /s /q "!bat_exedir!\Temp\Zip"
		!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
rem !bat_pause! rd /s /q "!bat_exedir!\Temp\Zip"
		!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
rem !bat_pause!
	)

	!bat_log! // Comparing the hash codes...
	if /i !bat_returncode! equ 0 (
		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - Zip file is OK and ready to upload: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
	) else (
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Corrupt zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
!bat_return!







	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)
		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
	)

	if exist "!bat_exedir!\Logs\md5.output.log" (
		!bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
	)

:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!













:GETCALFILEINFO
!bat_pushlog! [CALL !bat_batchfile!:GETCALFILEINFO] %*
	call GetCalfileInfo.bat "!bat_calfilename!"
	set bat_returncode=!errorlevel!
!bat_poplog! [!bat_returncode!]
!bat_log!
!bat_return!






















	rem 48. Save Configuration ************************************
:SAVECONFIG
!bat_pushlog! [CALL !bat_batchfile!:SAVECONFIG] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
	echo bat_recent_error_msg=!bat_recent_error_msg!>>"!bat_configfile!"
:SAVECONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:SAVECONFIG] []
!bat_log!
!bat_return!





:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_retval=failed
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_push!
	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		set bat_retval=success
		set bat_temp=%%x
							rem if /i "%%x" neq "[CAMSMENU]" (
							rem      set %%x
							rem )

		if /i "!bat_temp!" neq "" (
			if /i "!bat_temp:~0,1!" neq " " (
				if /i "!bat_temp:~0,1!" neq "	" (
					if /i "!bat_temp:~0,2!" neq "//" (
						rem It's not a single-line comment "//"

						if /i "!bat_temp:~0,3!" neq "rem" (
							rem It's not a single line comment "rem"

							if /i "!bat_temp:~0,4!" neq "rem " (
								rem It's not a comment "rem "

								if /i "!bat_temp:~0,1!" equ "[" (
									rem It's a [section]
									set bat_temp=!bat_temp:~1,99!
									set bat_inisection=bat_!bat_temp:~0,-1!
								) else (
									rem It's a bat_key=value
									if "!bat_temp:~0,4!" equ "bat_" (
									rem !bat_log! '    set !bat_temp!
												   set !bat_temp!
									) else (
											rem It's a key=value
											set !bat_inisection!.!bat_temp!
									)
								)
							)
						)
					)
				)
			)
		)
	)
	!bat_pop!

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!

%bat_COMMENT_BEGIN%
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	!bat_echolog! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
	              call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

	call :GETDETECTFILE  "bat_detectfile" "bat_archivedfilesdir"
	if defined bat_detectfile (
		if exist "!bat_detectfile!" (
			if not exist "!bat_archivedfilesdir!\CalFileList.log" (
				call :CREATECALFILELIST "!bat_detectfile!"
			)
		)
	)

	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount  "!bat_archivedfilesdir!"

	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"
%bat_COMMENT_END%

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [AutoCams.bat.ini=!bat_retval!, "!bat_capturedfilesdir!"]
!bat_log!
!bat_return!




:READCONFIGVAR
!bat_pushlog! [CALL !bat_batchfile!:READCONFIGVAR] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	set bat_tempvar=%~1

	!bat_push!
	for /f "usebackq tokens=* skip=2" %%x in (`find /i "!bat_tempvar!" "!bat_configfile!"`) do (
		!bat_log! set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)
	!bat_pop!

	
!bat_poplog! [RETURN !bat_batchfile!:READCONFIGVAR] [!bat_capturedfilesdir!]
	set bat_tempvar=
!bat_log!
!bat_return!



	rem 49. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
		color 07
	)
!bat_log!
!bat_return!





	








:VARIABLES
!bat_push!
	call "!bat_exedir!\show_bat_vars.bat"
!bat_pop!
	if not defined bat_autonomous (pause)
!bat_log!
!bat_return!






:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_pushecho! [CALL !bat_batchfile!:FIXDETECTPATHS] [%*]
	set bat_retval=0

	if /i "%~1" equ "" (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	)
	
	if /i {%2} equ {} (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	)

	!bat_logexec! call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!bat_logexec_returncode!
	if !bat_retval! lss 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_popecho! [RETURN !bat_batchfile!:FIXDETECTPATHS] [!bat_recent_error_msg!]
!bat_echolog!
!bat_return!

















	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed:
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!












:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.Usage: %~nx0
	echo.
	echo.Downloads the zip files from the ftp server for all files that
	echo.aren't already downloaded. 
	echo.
	echo.It works by first using the FTP "ls" command to list all the files 
	echo.matching the "????_??_??_*.zip" filespec. Then it iterates through
	echo.that list of files, looking for the same file in the ".\Temp" dir.
	echo.
	echo.
	echo.There could be an option to be able to specify a filespec, which might reduce
	echo.the traffic. Post to the seticams if this is needed...
	echo.
	echo.
exit /b 9


:DONE
!bat_pop!
	!bat_popecho!
	!bat_echolog! [!date! !time!] !bat_batchfile!:DONE with %0 %* [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!