  @echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

    set bat_tempfile=%~0.temp.txt


    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
	if "%~1" equ "" goto :HELP

	rem bat_cpucount
	call :GETCPUCOUNT
	
	call :GETWINDOWSVER
	
	call :GETARGS %*
	call :CHECKALREADYPROCESSED %*

	!bat_logexeclog! set bat_

	call :CREATECASEFILES %*
	call :GETFILECOUNT %*
	call :PARSEDATE %*
	call :DAYOFWEEK %*
	call :GETSEARCHDIR %*

	call :MAIN %*
goto :DONE






:GETARGS
!bat_pushecho! [CALL !bat_batchfile!:GETARGS] %*

	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!
	set bat_batchfile=%~nx0

	set bat_targetlocation=%~1
	set bat_reprocessoptions=%~2
	set bat_autonomous=%~2

	set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_temp=%~1

	rem echo.!bat_temp!^|find /i "^:"
	echo.!bat_temp!|find /i ":">nul:
	if !errorlevel! equ 0 (
		rem They specified the fullpath, such as:
		rem	   c:\CAMS\CapturedFiles\2011_10_21_##_##_##
		rem	   f:\x\y\z\CAMS\CapturedFiles\2011_10_21_##_##_##
		rem so keep bat_targetlocation as-is and the drive letter
		rem is the first 2 chars of the argument
		!bat_echolog! Found ":" so using: "f:\x\y\z\CAMS\CapturedFiles\yyyy_mm_dd_##_##_##"
		
		set bat_targetdrive=!bat_targetlocation:~0,2!
		
		rem It would be good to be able to use a share, but that may
		rem entail having to map a drive letter to the share.
	) else (
		set bat_targetdrive=!bat_exedrive!

		rem echo.!bat_temp!^|find /i "\cams\"
		echo.!bat_temp!|find /i "\cams\">nul:
		if !errorlevel! equ 0 (
			rem They specified the some other relative path without
			rem a drive letter, such as:
			rem	  \CAMS\CapturedFiles\2011_10_21_##_##_##
			rem	  ..\CAMS\CapturedFiles\2011_10_21_##_##_##
			rem	  \x\y\z\CAMS\CapturedFiles\2011_10_21_##_##_##
			rem So we need to determine the drive letter.  In this
			rem case, the drive letter is 
			!bat_echolog! Found "\cams\" so using: "\x\y\z\CAMS\CapturedFiles\yyyy_mm_dd_##_##_##"
			
			if "!bat_temp:~0,3!" equ "..\" (
				set bat_targetlocation=!bat_exedrive!\!bat_targetlocation:~3,255!
			) else (
				if "!bat_temp:~0,1!" equ "\" (
					set bat_targetlocation=!bat_exedrive!\!bat_targetlocation:~1,255!
				)
			)
			
		) else (
			rem echo.!bat_temp!^|find /i "CapturedFiles\"
			echo.!bat_temp!|find /i "CapturedFiles\">nul:
			if !errorlevel! equ 0 (
				rem They specified relative:
				rem   CaptureFiles\2011_10_21_##_##_##
				rem   .\CapturedFiles\2011_10_21_##_##_##

				set bat_targetlocation=!bat_targetlocation:.\CapturedFiles\=CapturedFiles\!
				set bat_targetlocation=!bat_exedir!\!bat_targetlocation!
			) else (
				rem probably just the date/time subdir name
				rem	  2011_10_21_##_##_##
				set bat_targetlocation=!bat_exedir!\CapturedFiles\!bat_targetlocation!
			)
		)
	)

:GETARGS_END
!bat_popecho! [RETURN !bat_batchfile!:GETARGS_END] [bat_targetlocation=!bat_targetlocation!]
!bat_echolog!
!bat_return!






:CHECKALREADYPROCESSED
!bat_pushecho! [CALL !bat_batchfile!:CHECKALREADYPROCESSED] %* [bat_targetlocation=!bat_targetlocation!]
	rem This section checks if there is already a directory named after
	rem the date/time of the first FF file in the CapturedFiles dir.
	rem If there is one, it will stop to ask if is ok to continue or
	rem quit.
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\*.bin" /b /a-d /o-n`) do (
		set bat_firstfile=%%~nxa
		set bat_firstfilefull=!bat_targetlocation!\%%~a
		set bat_capturedfilesdir=!bat_targetlocation!
	)
	
	for /f "usebackq tokens=*" %%a in ('"!bat_capturedfilesdir!"') do (
		set bat_basedir=%%~dpa::
		set bat_basedir=!bat_basedir:\::=!
		set bat_basedir=!bat_basedir:::=!
	)
	for /f "usebackq tokens=*" %%a in ('"!bat_basedir!"') do (
		set bat_basedir=%%~dpa::
		set bat_basedir=!bat_basedir:\::=!
		set bat_basedir=!bat_basedir:::=!
	)
	
	set bat_file1=!bat_firstfile:~6,4!
	set bat_file2=!bat_firstfile:~10,2!
	set bat_file3=!bat_firstfile:~12,2!
	set bat_file4=!bat_firstfile:~15,2!
	set bat_file5=!bat_firstfile:~17,2!
	set bat_file6=!bat_firstfile:~19,2!
	set bat_archdatedir=!bat_file1!_!bat_file2!_!bat_file3!_!bat_file4!_!bat_file5!_!bat_file6!
	
	set bat_archivedfilesdir=!bat_basedir!\ArchivedFiles\!bat_archdatedir!

	if exist "!bat_archivedfilesdir!" (
			!bat_echolog!
			!bat_echolog! '    WARNING - Already exists.  
			!bat_echolog! '        You may have already performed the FTP_Reprocess procedure. 
			!bat_echolog! '        "!bat_archivedfilesdir!"
		if exist "!bat_archivedfilesdir!\FTPdetectinfo_0*.txt" (
			for /f "usebackq tokens=1,2 delims== skip=2" %%a in (`find /i "Meteor Count" "C:\CAMS\ArchivedFiles\2011_12_22_01_31_45\FTPdetectinfo.txt"`) do (
				set bat_meteorcount=%%b
			)
			!bat_echolog! "!bat_archivedfilesdir!\FTPdetectinfo.txt"   [Meteor Count=!bat_meteorcount!]
		)
		echo.
:CHECKALREADYPROCESSED2
		if not defined bat_autonomous (
			set /p bat_choice=Are you sure you want to continue? Y/N 
			if /i "!bat_choice!" equ "n" (goto :DONE)
			if /i "!bat_choice!" neq "y" (goto :CHECKALREADYPROCESSED2)
		)
	)
:CHECKALREADYPROCESSED_END
!bat_popecho! [RETURN !bat_batchfile!:CHECKALREADYPROCESSED] [bat_archivedfilesdir=!bat_archivedfilesdir!]
!bat_echolog!
!bat_return!







:CREATECASEFILES
!bat_pushecho! [CALL !bat_batchfile!:CREATECASEFILES] %*
	set bat_temp=!bat_targetlocation!
	for /f "tokens=*" %%a in ("!bat_temp!") do (
		set bat_dirname=%%~nxa
		set bat_dirdate=!bat_dirname:~0,10!
	)
	!bat_echolog! bat_dirname=!bat_dirname!
	!bat_echolog! bat_dirdate=!bat_dirdate!

:CREATECASEFILES_END
!bat_popecho! [RETURN !bat_batchfile!:CREATECASEFILES] [bat_dirname=!bat_dirname!]
!bat_echolog!
!bat_return!










:GETFILECOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETFILECOUNT] %*
	if not exist "!bat_targetlocation!\*.bin" (
		!bat_echolog!
		!bat_echolog! ERROR - There are no FF*.bin files in the specified location:
		!bat_echolog! '        "!bat_targetlocation!"
		goto :DONE
	)

	set bat_filecount=0
	for /f "usebackq tokens=*" %%a in (`dir /b "!bat_targetlocation!\*.bin"^|find /c /i ".bin"`) do (
		set bat_filecount=%%a
	)
	
	if !bat_filecount! equ 0 (
		!bat_echolog!
		!bat_echolog! ERROR - There are no FF*.bin files in the specified location:
		!bat_echolog! '        "!bat_targetlocation!"
		goto :DONE
	) else (
		if !bat_filecount! lss 2500 (
			!bat_echolog! NOTICE - There are less than 6 hours of data in the specified directory. 
			!bat_echolog! '        "!bat_targetlocation!"  [Files=!bat_filecount!]
			!bat_echolog!
		)
	)

	set /a bat_filespercase=!bat_filecount!/!bat_cpucount!

:GETFILECOUNT_END
!bat_popecho! [RETURN !bat_batchfile!:GETFILECOUNT] [bat_filecount=!bat_filecount!, bat_filespercase=!bat_filespercase!]
!bat_echolog!
!bat_return!






:PARSEDATE
!bat_pushecho! [CALL !bat_batchfile!:PARSEDATE] %*
	set ftp_wmdy=!bat_dirdate!
:PARSEDATE2

	rem YEAR
	set ftp_year=!ftp_wmdy:~0,4!
	
	rem MONTH
	set ftp_mo=!ftp_wmdy:~5,2!
	set ftp_mo2=!ftp_mo!
	if !ftp_mo! LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	
	rem DAY
	set ftp_da=!ftp_wmdy:~8,2!
	set ftp_da2=!ftp_da!
	if !ftp_da! LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	call :date2jdate bat_JD !ftp_year! !ftp_mo2! !ftp_da2!

	call :jdate2date !bat_jd! ftp_year ftp_mo2 ftp_da2
:PARSEDATE_END
!bat_popecho! [RETURN !bat_batchfile!:PARSEDATE] [bat_JD=!bat_JD!, !ftp_year! !ftp_mo2! !ftp_da2!]
!bat_echolog!
!bat_return!






:DAYOFWEEK
!bat_pushecho! [CALL !bat_batchfile!:DAYOFWEEK] %*
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd
	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)
:DAYOFWEEK_END
!bat_popecho! [RETURN !bat_batchfile!:DAYOFWEEK] [bat_weekday=!bat_weekday!]
!bat_echolog!
!bat_return!





:GETSEARCHDIR
!bat_pushecho! [CALL !bat_batchfile!:GETSEARCHDIR] %*
	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
:GETSEARCHDIR_END
!bat_popecho! [RETURN !bat_batchfile!:GETSEARCHDIR] [!ftp_searchdir!]
!bat_echolog!
!bat_return!




:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] %*
!bat_push!

	set bat_returncode=1

	set bat_lastffname=.
	set /a bat_loopcount=0
	set /a bat_filecountstop=0
	set /a bat_case=0

			!bat_echolog!
			!bat_echolog! Windows Vers:	!bat_winver!
			!bat_echolog!
			!bat_echolog! Day of week:	!bat_weekday!
			!bat_echolog! Folder date:	!bat_dirdate!
			!bat_echolog! Folder name:	!bat_dirname!
			!bat_echolog! Drive:		!bat_targetdrive!
			!bat_echolog! CAMS dir:		!bat_exedir!
			!bat_echolog! Cal dir:		!bat_exedir!\Cal
			!bat_echolog! Directory: 		!bat_targetlocation!
			!bat_echolog! Total Files:	        !bat_filecount!
			!bat_echolog! Number of CPUs:	!bat_cpucount!
			!bat_echolog! Files per case:	!bat_filespercase!	^(files per CPU^)
			!bat_echolog!

	!bat_pushecho! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\*.bin" /b /a-d /od`^) do ...
	!bat_pushecho!
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\*.bin" /b /a-d /od`) do (
		set /a bat_loopcount+=1
		set /a bat_casecount+=1
		
		TITLE MakeCaseListing.bat [!bat_casecount!][!bat_loopcount!] "%%a"

		if !bat_loopcount! GTR !bat_filecountstop! (
			set /a bat_case+=1

			set /a bat_filecountstop+=bat_filespercase
			set /a bat_casecount=1

			rem This block prevents the problem when the bat_cpucount doesn't
			rem divide evenly into the 
			if !bat_case! equ 1 (
				set /a bat_filecountstop+=bat_cpucount
			)

			set bat_temp=000!bat_case!
			set bat_temp=!bat_temp:~-3!
			set bat_caselisting=FFdirectorylisting_!bat_temp!.txt
			     del !bat_targetlocation!\!bat_caselisting! 2>nul:

			set bat_firstcasefile=%%a
			!bat_pop!
			!bat_echolog! CASE !bat_case! - !bat_targetlocation!\!bat_caselisting!...
			!bat_pushecho!
		)
		
		set bat_outputstring=%%a

		echo !bat_outputstring!>>"!bat_targetlocation!\!bat_caselisting!"

		if !bat_loopcount! GEQ !bat_filecountstop! (
			set bat_casetitle=FTP_Reprocess !bat_case! !bat_casecount! First:!bat_firstcasefile:~15,6!  Last:!bat_outputstring:~15,6!

			!bat_echolog! First file in case !bat_case!:	!bat_firstcasefile!
			!bat_echolog! Last file in case !bat_case!:	!bat_outputstring!
			!bat_echolog! Total files in case !bat_case!: !bat_casecount!

			!bat_echolog! copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe"
			              copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe" 1>2>nul:

			call :SETAFFINITY !bat_case!
			if !bat_winver! GEQ 6.0 (
				!bat_echolog! start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
					          start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  

			) else (
				!bat_echolog! start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
					          start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe !bat_case! "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  

				start /w wait 3

				!bat_echolog! call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask!
				              call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask! 1>2>nul:
			)
			!bat_echolog! start /w wait 10
			!bat_echolog!

			start /w wait 10
		)
	)
	!bat_echolog!

	set bat_casetitle=FTP_Reprocess !bat_case! !bat_casecount! First:!bat_firstcasefile:~15,6!  Last:!bat_outputstring:~15,6!

	!bat_echolog! First file in case !bat_case!:	!bat_firstcasefile!
	!bat_echolog! Last file in case !bat_case!:	!bat_outputstring!
	!bat_echolog! Total files in case !bat_case!: !bat_casecount!
	!bat_echolog!
	!bat_echolog! copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe"
		          copy /y "ftp_reprocess.exe" "FTP_Reprocess_!bat_case!.exe" 1>2>nul:
	call :SETAFFINITY !bat_case!
	!bat_popecho! ^) // for...
	!bat_echolog!
	
	if !bat_winver! GEQ 6.0 (
		!bat_echolog! start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case! !bat_reprocessoptions!
			          start "!bat_casetitle!" /low /affinity !bat_affinity! ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
	) else (
		!bat_echolog! start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case! !bat_reprocessoptions!
			          start "!bat_casetitle!" /low  ftp_reprocess_!bat_case!.exe 1 "!bat_targetlocation!" "!bat_exedir!\Cal" !bat_case!  
		start /w wait  1
		!bat_echolog! call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask!
		              call process -a ftp_reprocess_!bat_case!.exe !bat_affinitymask! 1>2>nul:
	)
	
	set bat_returncode=0

	!bat_echolog!

:MAIN_END
!bat_pop!
!bat_pop!
!bat_popecho! [END !bat_batchfile!:MAIN_END] [!date! !time! - exit /b !bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
exit /b !bat_returncode!



goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=!MM:~-2!
	set DD=!DD:~-2!
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0


:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b




:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
goto :EOF





:CALCREQDISK
	set bat_diskspacememo=OK
	call :CHECKDISKSPACE
	set /a bat_estCapFiles=!bat_durtotalseconds/8
	set /a bat_reqdisk=!bat_durtotalsecs!/8*1229/1024
	set /a bat_estSizeMB=!bat_reqdisk!
	set bat_freeMB=!bat_targetfreespace!
	
	set bat_sizediff=!bat_estSizeMB!-!bat_freeMB!

	if !bat_estSizeMB! gtr !bat_freeMB! (
		set bat_diskspacememo=********* DISK SPACE WARNING! ************
	)
goto :EOF




:CHECKDISKSPACE
	set bat_targetdrive=!bat_targetlocation:~0,2!
	
	rem Note: We have to do it this way because WMIC outputs unicode and
	rem FINDSTR is not compatible with unicode strings.
	wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-2* skip=1" %%a in (`type "!bat_tempfile!"^|findstr /r /c:","`) do (
		set bat_free=%%b
		set bat_size=%%c
		if "!bat_free!" neq "" (
			set bat_freeMB=!bat_free:~0,-6!
			set bat_targetfreespace=!bat_freeMB!
		)
	)
	
	if exist "!bat_tempfile!" (del "!bat_tempfile!")
!bat_return!


	wmic logicaldisk where "name='!bat_targetdrive!'" get freespace /format:csv>"!bat_tempfile!"
	for /f "usebackq tokens=1-2 delims=," %%a in (`type "!bat_tempfile!"^|findstr /r /c:"%computername%"`) do (
		rem echo %%a, %%b
		set bat_targetfreespace=%%b
		set bat_freeMB=%%b
	)
	if exist "!bat_tempfile!" (del "!bat_tempfile!")








:GETCPUCOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETCPUCOUNT] %*
	set /a bat_cpucount=!NUMBER_OF_PROCESSORS!
	if !bat_cpucount! gtr !bat_DETECT.maxdetectionthreads! (
		set bat_cpucount=!bat_DETECT.maxdetectionthreads!
	)
:GETCPUCOUNT_END
!bat_popecho! [RETURN !bat_batchfile!:GETCPUCOUNT] [bat_cpucount=!bat_cpucount!]
!bat_echolog!
!bat_return!





:SETAFFINITY
!bat_pushecho! [CALL !bat_batchfile!:SETAFFINITY] %*
	rem Usage: call :SETAFFINITY count
	set /a bat_affinity=1
	set bat_temp=10000000000000000000000000000000
	
	rem logical shift. e.g. 1"<<=(3-1)" yields 4; 1"<<=(1-1)" yields 1
	set /a "bat_affinity=1<<(%~1-1)"
	set bat_affinitymask=!bat_temp:~0,%~1!
:SETAFFINITY_END
!bat_popecho! [RETURN !bat_batchfile!:SETAFFINITY] [bat_affinitymask=!bat_affinitymask!]
!bat_echolog!
!bat_return!







Note: If this is XP, then the Process.exe command has to be used using and 
      the bat_affinitymask variable is used.
      Operating System Version Number 
		Operating System						Version Number			Other Information 
		Windows 1.0 							1.04   
		Windows 2.0 							2.11   
		Windows 3.0 							3   
		Windows NT 3.1 							3.10.528   
		Windows for Workgroups 3.11 			3.11   
		Windows NT Workstation 3.5 				3.5.807   
		Windows NT Workstation 3.51 			3.51.1057   
		Windows 95 								4.0.950   
		Windows NT Workstation 4.0 				4.0.1381   
		Windows 98 								4.1.1998   
		Windows 98 Second Edition 				4.1.2222   
		Windows Me 								4.90.3000   
		Windows 2000 Professional 				5.0.2195   
		Windows XP 								5.1.2600 				Current SP3 
		Windows XP Professional x64 Edition 	5.2.3790   
		Windows Vista 							6.0.6000 				Current Version changed to 6.0.6002 with SP2 
		Windows 7 								6.1.7600 				RTM 

      if !bat_winver! LEQ 6.0.6000
	process -a ftp_reprocess_1.exe !bat_affinitymask!


:GETWINDOWSVER
!bat_pushecho! [CALL !bat_batchfile!:GETWINDOWSVER] %*
	wmic os get version /format:csv>"!bat_tempfile!"
	rem type "!bat_tempfile!"
	for /f "usebackq tokens=1-3 skip=2 delims=," %%a in (`type "!bat_tempfile!"`) do (
		if "%%b" gtr "!" (
			set bat_winver=%%b
		)
	)
	
	if exist "!bat_tempfile!" (del "!bat_tempfile!")
:GETWINDOWSVER_END
!bat_popecho! [RETURN !bat_batchfile!:GETWINDOWSVER] [bat_winver=!bat_winver!]
!bat_echolog!
!bat_return!












:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 "sourcedirectory" [/?]
    echo.
    echo     Creates the case/instance files for running FTP_Reprocess.exe in 
    echo     multi-tasking mode. A case/instance file will be created for each
    echo     CPU in the specified CapturedFiles subdir with the following format:
    echo         FFdirectorylisting_00#.txt
    echo.
    echo     Then, it launches FTP_Reprocess.exe with the priority set to LOW and
    echo     the processor affinity set to 1:1, 2:2, 3:4, 4:8, 5:16, 6:32, 7:64, 8:128
    echo.
    echo     WARNING - The path must be in all upper case.
    echo.
    echo     Examples: %~nx0 "2011_11_10_01_38_20"
    echo               %~nx0 "CapturedFiles\2011_11_10_01_38_20"
    echo               %~nx0 ".\CapturedFiles\2011_11_10_01_38_20"
    echo               %~nx0 "C:\CAMS\CapturedFiles\2011_11_10_01_38_20"
    echo.
    echo     Note: Requires the following additional utilities:
    echo              - Process.exe
    echo              - Wait.exe
    echo              - wmic.exe
    echo              - find.exe
    echo              - FindStr.exe
    echo.
EXIT /b 9
    
goto :DONE


:DONE
!bat_echolog! %date% %time% DONE !bat_batchfile! [!bat_returncode!]
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog!
echo Waiting...&start /w wait 10
exit /b !bat_returncode!
