   @echo off
setlocal enabledelayedexpansion enableextensions

	rem NEEDS:
	rem       - 13. If submit.email.bat fails to create a Submit dir, then abort.

:CHECKHELP

	echo.%*|find /i "/?">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if !errorlevel! equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:


	
:SETUP

		rem If running it autonomous mode (being called from the Capture script)
		rem wait a few seconds to as not to mingle the full log entries.
	echo.%*|find /i "autonomous">nul:
	if !errorlevel! equ 0 (
		start /w wait 6
	)
	
	set bat_camerahint=+

rem	set bat_indent_log_debug=REM 
rem	rem set bat_indent_log_debug=
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"
	set bat_pushstring=

	call "!bat_exedir!\ReadParams.bat"

	set bat_color_on=toggle on

	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		!bat_echolog! '     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_exedir!\Cal


	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if !errorlevel! equ 0 (
		set bat_autonomous=autonomous
		set bat_precapturedfilesdir=%~1
		set bat_capturedfilesdir=%~1
		set bat_archivedfilesdir=%~2
		set bat_camera=%~3

	)
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! !date! !time! - Version !bat_vers! %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushlog!

	set bat_returncode=0

	set bat_hasrun_post=false
	set bat_hasrun_reprocess=false
	set bat_hasrun_calupdate=false
	set bat_hasrun_cal=false
	set bat_hasrun_confirm=false
	set bat_hasrun_submission=false
	set bat_hasrun_zip=false

	rem call :READPARAMS
	call :READCONFIG

	if defined bat_capturedfilesdir (
		!bat_logexeclog! set bat_capturedfilesdir
		!bat_logexeclog! set bat_captureddatetime=!bat_capturedfilesdir:~-19!
		!bat_logexeclog! set bat_capturedtime=!bat_capturedfilesdir:~-8!
	)


	if defined bat_submissionfilesdir (
		!bat_log! [a] call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs\!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!" aaaaa
		              call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs\!bat_captureddatetime!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!" bbbbbbb
	) else (
		!bat_log! [b] call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs" "!bat_exedir!\Logs\!bat_captureddatetime!"
		              call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs" "!bat_exedir!\Logs\!bat_captureddatetime!"
		)
	)
	

rem Note: ReadConfig calls this...	call :GETCONFIRMEDCOUNT

	!bat_logexeclog! type "!bat_paramsfile!"
	!bat_logexeclog! type "!bat_configfile!"
	!bat_logexeclog! set bat_

	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if !errorlevel! equ 0 (
		set bat_autonomous=autonomous
		set bat_precapturedfilesdir=%~1
		set bat_capturedfilesdir=%~1
		set bat_archivedfilesdir=%~2
		set bat_camera=%~3
	)
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	

	call :PARSEARGS %*

	!bat_log! ---------bat_archivedfilesdir=!bat_archivedfilesdir!

	if defined bat_capturedfilesdir (
		set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
		!bat_log! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
		          call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

		call :GETCAMERAFROMCAPTURED
		call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
		if defined bat_detectfile (
			if exist "!bat_detectfile!" (
				if not exist "!bat_archivedfilesdir!\CalFileList.log" (
					call :CREATECALFILELIST "!bat_detectfile!"
				)
				call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
				call :GETCONFIRMEDCOUNT
			)
		)
	)


	if not exist "!bat_mainspec!\!bat_getdirname!" (
		!bat_echolog! '     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		!bat_log! '     bat_mainspec=!bat_mainspec!
	)
	
	if defined bat_autonomous (
		call :AUTOCAMS
		call :SAVECONFIG
		!bat_echolog!
		!bat_echolog! Done with %0 %*
		!bat_echolog!
		EXIT
	) else (
		goto :MENU
	)

goto :MENU

	
:PARSEARGS
!bat_pushlog! [CALL !bat_batchfile!:PARSEARGS] %*
!bat_log! '     !bat_batchfile!:PARSEARGS %1, %~dp1, %~nx1
	if defined bat_autonomous (
		set bat_getdirname=%~nx2
		set bat_arg1=%~2
	) else (
		set bat_getdirname=%~nx1
		set bat_arg1=%~1
	)
	
	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_mainfilter=^|find /i "!bat_getdirname!"
	
	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			!bat_log! '     Format: x:\CAMS\ArchivedFiles\date_time
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			rem set bat_startdrive=!bat_arg1:~0,2!
			rem set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			!bat_log! '     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			echo.%~1|find /i /c "ArchivedFiles\"
			set bat_returncode=!errorlevel!
			!bat_log! bat_returncode=!bat_returncode!
			if !bat_returncode! equ 0 (
				!bat_log! '     Format: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				!bat_log! '     Format: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)

:PARSEARGS_END
	!bat_log! ' bat_mainfilter=!bat_mainfilter!
!bat_poplog! [RETURN !bat_batchfile!:PARSEARGS] [!bat_getdirname!, !bat_mainspec!]
!bat_log!
!bat_return!



REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================

:MENU
!bat_pop!
!bat_pop!
!bat_pop!
!bat_push!
!bat_log!
!bat_log! goto :MENU %*
	call :CLEARSCREEN
	color !bat_color!


	if not defined bat_captureddate (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
		call :FORMATDATE bat_dateinput !bat_captureddate!
		
		if not defined bat_capturedtime (
			if defined bat_capturedfilesdir (
				set bat_capturedtime=!bat_capturedfilesdir:~-8!
			)
		)
		
	)
	
	if not defined bat_archivedtime (
		if defined bat_archivedfilesdir (
			set bat_archivedtime=!bat_archivedfilesdir:~-8!
		)
	)

	if defined bat_latestcal (
		set bat_temp1=!bat_latestcal:~7,4!_!bat_latestcal:~11,2!_!bat_latestcal:~13,2!
		set bat_temp2=!bat_detectcal:~7,4!_!bat_detectcal:~11,2!_!bat_detectcal:~13,2!
		!bat_log! bat_temp1=!bat_temp1!, bat_temp2=!bat_temp2!, bat_captureddate=!bat_captureddate!
		
		if /i "!bat_temp2!" equ "!bat_captureddate!" (
			if /i "!bat_detectcal!" equ "!bat_latestcal!" (
				set bat_latestcal_test=GOOD - Cal files in detect file and Latest Cal file MATCH each other and captured date
				!bat_log! bat_latestcal_test=!bat_latestcal_test!
			) else (
				set bat_latestcal_test=PASS - Cal files in detect file match captured date but NOT the Latest Cal file
				!bat_log! bat_latestcal_test=!bat_latestcal_test!
			)
		) else (
			set bat_latestcal_test=DIFFERENT - Cal date [!bat_temp2!] different than captured date [!bat_captureddate!]
			!bat_log! bat_latestcal_test=!bat_latestcal_test!
		)
	)

	if defined bat_latestcal (
		if /i "!bat_latestcal!" equ "!bat_confirmedcal!" (
			set bat_detectfilecaldifference=!bat_confirmedcal! - SAME
		) else (
			set bat_detectfilecaldifference=Need to apply cal to Confirmed
		)
	)
	
	if not defined bat_camera_list (
		set bat_camera_list=!bat_CAPTURE.cameralist!
	)


	TITLE %~dpnx0 - CAMS MENU
	echo  !bat_titlebar!
	echo.
	echo  1.  Choose target location     !bat_targetlocation!
	echo  2.  Enter Camera               !bat_camera!        Camera list: !bat_camera_list!
	echo  3.  Enter Captured Date        !bat_captureddate!	  Time: !bat_capturedtime!
	echo  3s.   Choose date from SubmissionFiles
	echo.
	echo  4.  Choose CapturedFiles       [Files=!bat_capturedcount!]	"!bat_capturedfilesdir!" 
	echo  5.  Choose ArchivedFiles       [F/Det=!bat_archivedcount!/!bat_archivedmeteorcount!]	"!bat_archivedfilesdir!"
	echo                        !bat_archivedtime! [detect=!bat_detectfile!]
	echo  6.  Check Skipped Frames and dropped frames
	echo Calibration Options for :
	echo  7a. [Obsolete] Cal Update		based on: "!bat_archivedfilesdir!"
	echo  7b. Auto Calibration Update 	based on:"!bat_capturedfilesdir!"
	echo  7c. Auto Cal with prompts	based on: "!bat_capturedfilesdir!"
	echo  7d. Manual Calibration		based on: whatever file you choose
	echo.
	echo  9.  Apply Cal to Archived      Detect Cal: !bat_detectcal!
	echo                                 Latest Cal: !bat_latestcal!
	echo                          !bat_latestcal_test!
	echo 10.  FTP_Confirmation           [Count: !bat_confirmedmeteorcount!]	"!bat_confirmedfilesdir!"
	echo                                 [detect=!bat_detectfileconf!]
	echo 11.    Edit comments.txt file   
	echo 12.    Apply Cal to Confirmed   Confirmed Cal: !bat_confirmedcal!     !bat_detectfilecaldifference!
	echo.
	echo Submission dir functions:       ["!bat_submissionfilesdir!"]
	echo 13.  Package Working dirs into SubmissionFiles dirs
	echo 14.    Choose Submission dir    
	echo 15.    Move SubmissionFiles dirs to working dirs 
	echo 16.  Zip Submitted dir          !bat_zipfile!
	echo 17.  Upload Zip via FTP (Submit)
	rem echo 18.  Report on Submission
	echo.
	echo  A.  Autonomous mode       FA.         Fix Detect Paths Archived   [FixDetectPaths.bat]
	echo  R.  Reset                 FC.         Fix Detect Paths Confirmed  [FixDetectPaths.bat]
	echo  U.  Utility Menu          ClearError. Clear recent error message
	echo  Q.  Quit                  ZipLogs.    Zip the logs files
	echo.
	echo  Last error msg: !bat_recent_error_msg!
	echo.
	
	rem DD. ftpdailydownload.bat
	rem Debug.   Debug mode [echoes each log entry to the display]

	
	set bat_choice=none
	set /P bat_choice=Enter choice: 
	!bat_log! set /P bat_choice=Enter choice: "!bat_choice!"
	!bat_echolog!
	if /i "!bat_choice!" equ "q" goto :DONE
	!bat_log! MENU::bat_choice=!bat_choice!
	!bat_log!
	!bat_log!

	if /i "!bat_choice!" equ "debug" (
		if /i "!bat_indent_log_debug!" equ "REM " (
			!bat_echolog! Toggling debugging to ON
			set bat_indent_log_debug=
		) else (
			!bat_echolog! Toggling debugging to OFF
			set bat_indent_log_debug=REM 
		)
		goto :MENU
	)
	
	call :READPARAMS

	if /i "!bat_choice!" equ "r" (
		CALL :RESET
	)



	if /i "!bat_choice!" equ "u" goto :UTILSMENU
	if /i "!bat_choice!" equ "30" goto :UTILSMENU
	
	if /i "!bat_choice!" equ "1"  call :CHOOSETARGETDRIVE&goto :MENU
	if /i "!bat_choice!" equ "2"  call :CHOOSECAMERA&goto :MENU
	if /i "!bat_choice!" equ "3"  call :CHOOSEDATE&goto :MENU
	if /i "!bat_choice!" equ "3s"  (
		set bat_choice=s
		call :CHOOSEDATESUB&goto :MENU
	)
	
	if /i "!bat_choice!" equ "4"  call :CHOOSECAP&goto :MENU
	if /i "!bat_choice!" equ "5"   call :CHOOSEARCH&goto :MENU
	if /i "!bat_choice!" equ "5a"  call :DETECTFILE_GET&goto :MENU
	if /i "!bat_choice!" equ "6"  call :SKIPPEDFRAMES&GOTO :MENU
	
	if /i "!bat_choice!" equ "7a"  call :CALUPDATE&goto :MENU
	if /i "!bat_choice!" equ "7b"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "7c"  call :CALUPDATEAUTOPROMPT&goto :MENU
	if /i "!bat_choice!" equ "7d"  call :CAL&goto :MENU
	if /i "!bat_choice!" equ "9"  call :APPLY&goto :MENU
	if /i "!bat_choice!" equ "10" call :CONFIRM&goto :MENU
	if /i "!bat_choice!" equ "11" call :EDITCOMMENTS&goto :MENU
	if /i "!bat_choice!" equ "12" call :APPLYCONFIRMED&goto :MENU
	if /i "!bat_choice!" equ "13" call :SUBMIT&goto :MENU
	if /i "!bat_choice!" equ "14" call :choosesubmission&goto :MENU
	if /i "!bat_choice!" equ "15" call :RESTORESUBMIT&goto :MENU
	if /i "!bat_choice!" equ "16" call :MAKEZIP&goto :MENU
	if /i "!bat_choice!" equ "17" call :UPLOADFTP&goto :MENU
	if /i "!bat_choice!" equ "18" call :EMAILTEXT&goto :MENU
	
	if /i "!bat_choice!" equ "31" call :CMDPROMPT&goto :MENU
	if /i "!bat_choice!" equ "32" call :CHECKBINFILESIZE&goto :MENU
	if /i "!bat_choice!" equ "33" call :CHECKBINCLEANUP&goto :MENU
	if /i "!bat_choice!" equ "34" call :CHECKFREESPACE&goto :MENU
	if /i "!bat_choice!" equ "35" call :LISTDRIVES&goto :MENU
	if /i "!bat_choice!" equ "36" call :VALIDATECAL&goto :MENU
	if /i "!bat_choice!" equ "37" call :METEORCOUNTPRE&goto :MENU
	if /i "!bat_choice!" equ "38" call :METEORCOUNTSUBMITTED&goto :MENU
	if /i "!bat_choice!" equ "38a" call :METEORCOUNTSUBMITTED2&goto :MENU
	if /i "!bat_choice!" equ "38b" call :METEORCOUNTSUBMISSION&goto :MENU
	if /i "!bat_choice!" equ "39" call :GETFFDIRLIST&goto :MENU
	if /i "!bat_choice!" equ "40" call :GETCAPTURED&goto :MENU
	if /i "!bat_choice!" equ "41" call :GETARCHIVED&goto :MENU
	if /i "!bat_choice!" equ "42" call :GETTWILIGHT&GOTO :MENU
	if /i "!bat_choice!" equ "43" call :LAUNCHCAPTURE&GOTO :MENU
	if /i "!bat_choice!" equ "44"  call :REPROCESSMULTI&goto :MENU
	if /i "!bat_choice!" equ "44b" call :MERGECASE&goto :MENU
	if /i "!bat_choice!" equ "45"  call :REPROCESS&goto :MENU
	if /i "!bat_choice!" equ "45b" call :POSTMULTI "!bat_captureddate!"&goto :MENU
	if /i "!bat_choice!" equ "47" call :DAYOFWEEK&goto :MENU
	if /i "!bat_choice!" equ "48" call :SAVECONFIG&goto :MENU
	if /i "!bat_choice!" equ "49" call :NIGHTMODE&goto :MENU

	if /i "!bat_choice!" equ "50" call :LISTFAILED&goto :MENU
	if /i "!bat_choice!" equ "51" call :LISTUNZIPPED&goto :MENU
	if /i "!bat_choice!" equ "52" call :LISTUNTRANSMITTED&goto :MENU

	if /i "!bat_choice!" equ "53" call :METEORMOVIES&					goto :MENU
	if /i "!bat_choice!" equ "54" call :COINCIDENCE&					goto :MENU

	if /i "!bat_choice!" equ "55" call :CAMERALIVEVIEWER&				goto :MENU
	if /i "!bat_choice!" equ "56" call :SINGLEFFMOVIE&					goto :MENU
	if /i "!bat_choice!" equ "57" call :CAMERAMOVIES&					goto :MENU
	if /i "!bat_choice!" equ "58" call :MOSAIC&							goto :MENU
	if /i "!bat_choice!" equ "59" call :ADJUSTFFTIMESTAMP&				goto :MENU
	if /i "!bat_choice!" equ "60" call :CALSUMMARY&						goto :MENU
	
	if /i "!bat_choice!" equ "61" call :MAKEARCHIVEDATEZIP&				goto :MENU
	if /i "!bat_choice!" equ "62" call :SPLITDUALCAPTURE&				goto :MENU
	
	if /i "!bat_choice!" equ "69" call :THUMBNAILSa&					goto :MENU
	if /i "!bat_choice!" equ "70" call :THUMBNAILS&						goto :MENU
	if /i "!bat_choice!" equ "71" call :PRESCREEN&						goto :MENU
	if /i "!bat_choice!" equ "72" call :SPFF_SINGLEFILEVIEWER&			goto :MENU	
	if /i "!bat_choice!" equ "73" call :SPFF_SINGLEVIEWER_CHOICE&		goto :MENU

	rem Hidden extras
	if /i "!bat_choice!" equ "v"  call :VARIABLES&goto :MENU
	if /i "!bat_choice!" equ "a"  call :AUTO&goto :MENU
	if /i "!bat_choice!" equ "cls" cls&:goto :MENU
	if /i "!bat_choice!" equ "fa" call :FIXDETECTPATHS "!bat_archivedfilesdir!" !bat_detectfile!&goto :MENU
	if /i "!bat_choice!" equ "fc" call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!&goto :MENU
	if /i "!bat_choice!" equ "clearerror" call :CLEARERROR&goto :MENU
	if /i "!bat_choice!" equ "edit" call :EDITAUTOCAMS&goto :MENU
	if /i "!bat_choice!" equ "ziplogs" call :ZIPLOGS&goto :MENU
	if /i "!bat_choice!" equ "dd"  call :DAILYDOWNLOAD&goto :MENU


	if /i "!bat_choice!" equ "del logs" (
		del /q "!bat_exedir!\Logs\*.log"
		goto :MENU
	)
	
	if /i "!bat_choice!" equ "?" set bat_&!bat_pause!&goto :MENU

	echo.!bat_choice!|find /i "notepad "
	if !errorlevel! equ 0 (
		!bat_echo! %cd%
		start "" !bat_choice!
	)
	
goto :MENU




	rem R. Reset ******************************************
:RESET
!bat_pushecho! [CALL :RESET]
	set bat_archdirname=
	set bat_archivedcount=
	set bat_archivedfilesdir=
	set bat_archiveddate=
	set bat_archivedtime=
	set bat_archivedmeteorcount=
	set bat_camera_list=
	set bat_cameralist=
	set bat_camera_temp=
	set bat_capdirname=
	set bat_capturedcount=
	set bat_captureddate=
	set bat_captureddatetime=
	set bat_capturedfilesdir=
	set bat_GCFC_tempfile=
	set bat_capturedtime=
	set bat_captureexe=
	set bat_confirmedcal=
	set bat_confirmeddetect=
	set bat_confirmedfilesdir=
	set bat_confirmedmeteorcount=
	rem set bat_counter=
	set bat_dateinput=

		rem bat_detectcal is the current cal matching the camera in the detect file.
	set bat_detectcal=
	set bat_detectfile=
	set bat_detectfile1=
	set bat_detectfile2=
	set bat_detectfile3=
	set bat_detectfile4=
	set bat_detectfilecaldifference=
	set bat_detectfileconf=
		rem bat_latestcal is the latest cal matching the camera in the Cal dir
	set bat_dirname=
	set bat_echolog_temp=
	set bat_found=

	set bat_hash=
	set bat_hash_after=
	set bat_hash_before=

	set bat_hasrun_cal=false
	set bat_hasrun_calupdate=false
	set bat_hasrun_confirm=false
	set bat_hasrun_post=false
	set bat_hasrun_reprocess=false
	set bat_hasrun_submission=false
	set bat_hasrun_zip=false

	set bat_latestcal=
	set bat_latestcal_test=
	rem set bat_logdir=
	set bat_mainfilter=
	set bat_mainspec=
	set bat_prevcamera=
	set bat_recent_error_msg=
	set bat_retval=
	set bat_retval1=
	set bat_retval2=
	set bat_retval3=
	set bat_submissiondate=
	set bat_submissiondirname=
	set bat_submissionfilesdir=
	set bat_temp1=
	set bat_temp2=
	set bat_temp3=
	set bat_tempcamera=
	set bat_tempcameralist=
	
	set bat_tempdest=
	set bat_tempdest1=
	set bat_tempdir=
	set bat_tempdirname=
	set bat_tempfilesdir=
	set bat_tempsrc=
	set bat_tempsrc1=

	set bat_zip=
	set bat_zipfile=
	set bat_zipsrc=
	set bat_recent_error_msg=
	set bat_temp=

	!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs" "!bat_exedir!\Logs"
	          call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs" "!bat_exedir!\Logs"

	call :SAVECONFIG
!bat_popecho! [RETURN :RESET]
!bat_echolog!
!bat_return!


:CLEARERROR
	set bat_recent_error_msg=
!bat_log!
!bat_return!



	rem a. AutoCams  ***************************
:AUTO
!bat_pushlog! [CALL !bat_batchfile!:AUTO] %*
	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog! ' ERROR - Unable to perform autonomous process because the working
		!bat_echolog! '         set has already been packaged for submission.
		!bat_echolog!
		!bat_echolog! If you really want to do this, perform the Option 15 option first.
		!bat_echolog!
		goto :AUTO_END
	)

	!bat_log! '    "!bat_exedir!\autocams.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
	               "!bat_exedir!\autocams.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous

!bat_echolog! YOU SHOULD NEVER GET THIS FAR [AutoCams.bat:AUTO]
exit /b 1

:AUTO_END
!bat_poplog! [RETURN !bat_batchfile!:AUTO] [!bat_capturedfilesdir!]
pause
!bat_log!
!bat_return!



	rem This routine performs the following steps:
	rem 	AUTOCAMS.autonomouslevel=cal
	rem 	AUTOCAMS.autonomouslevel=apply
	rem 	AUTOCAMS.autonomouslevel=applyconfirmed
	rem 	AUTOCAMS.autonomouslevel=submit
	rem 	AUTOCAMS.autonomouslevel=zip
	rem 	AUTOCAMS.autonomouslevel=ftp
:AUTOCAMS
!bat_pushecho! [CALL !bat_batchfile!:AUTOCAMS] %*

	set bat_recent_error_msg=

	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		echo.
		set bat_recent_error_msg=ERROR - "!bat_archivedfilesdir!" is missing ArchivedFiles dir name
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		goto :AUTOCAMS_END
	)

	:AZ_FIXDETECTPATHS
		!bat_pushecho! !bat_batchfile!:AUTOCAMS:AZ_FIXDETECTPATHS %*
		!bat_log! call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
		          call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
		set bat_retval=!errorlevel!&	rem 101 FF count replace in 100's digit, CAL in 1s
		if !bat_retval! lss 0 (
			set bat_returncode=!bat_retval!
			set bat_recent_error_msg=ERROR - AZ_FIXDETECTPATHS - Unable to patch paths in detect file
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
			!bat_popecho!
			goto :AUTOCAMS_END
		) else (
			set bat_recent_error_msg=SUCCESS - AZ_FIXDETECTPATHS - "!bat_archivedfilesdir!"
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
			!bat_popecho!
		)


	:AZ_CALAUTO
		!bat_pushecho! !bat_batchfile!:AZ_CALAUTO %*
		rem   7b. FTP_MeteorCal_AutoUpdate
		call :CALUPDATEAUTO
		call :SAVECONFIG
		if "!bat_returncode!" neq "0" (
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			!bat_popecho!
			goto :AUTOCAMS_END
		)
			!bat_popecho!

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "cal" (goto :AUTOCAMS_END)

	:AZ_APPLYAUTO
		!bat_pushecho! !bat_batchfile!:AZ_APPLYAUTO %*
		rem   9.  FTP_ApplyCal2detectinfo
		call :APPLYAUTO
		call :SAVECONFIG
		if !bat_returncode! neq 0 (
			set bat_recent_error_msg=ERROR - 9.a. ApplyAuto failed
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
			!bat_popecho!
			goto :AUTOCAMS_END
		)
			!bat_popecho!

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "apply" (goto :AUTOCAMS_END)

	:AZ_FIXDETECTPATHSCONF
		!bat_pushecho! !bat_batchfile!:AZ_FIXDETECTPATHSCONF %*
		if not exist "!bat_detectfileconf!" (
			set bat_recent_error_msg=WARNING - :AZ_FIXDETECTPATHSCONF - bat_detectfileconf=!bat_detectfileconf!
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		) else (
			call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!
			if !bat_retval! lss 0 (
				set bat_recent_error_msg=WARNING - :AZ_FIXDETECTPATHSCONF - Unable to patch paths in detect file [call !bat_batchfile!:FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!]
				!bat_echolog!
				!bat_echolog!
				!bat_echolog! '    !bat_recent_error_msg!
				!bat_echolog!
				!bat_echolog!
				!bat_popecho!
			)
			call :SAVECONFIG
		)
			!bat_popecho!

	:AZ_APPLYCONFIRMED
		!bat_pushecho! !bat_batchfile!:AZ_APPLYCONFIRMED %*
		rem   9.  FTP_ApplyCal2detectinfo
		call :APPLYCONFIRMED
		if !bat_returncode! equ 0 (
			set bat_recent_error_msg=NOTICE AZ_APPLYCONFIRMED [%*]- Apply Confirmed failed
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			!bat_popecho!
		)
		call :SAVECONFIG
			!bat_popecho!

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "applyconfirmed" (goto :AUTOCAMS_END)


	:AC_SUBMITAUTO
		!bat_pushecho! !bat_batchfile!:AC_SUBMITAUTO %*
		rem  13.  Submission
		call :SUBMITAUTO
		call :SAVECONFIG
		!bat_log! bat_returncode=!bat_returncode!
		if /i "!bat_returncode!" neq "0" (
			set bat_recent_error_msg=ERROR - Failed 13.a. Submission [!bat_capturedfilesdir!]
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			!bat_popecho!
			goto :AUTOCAMS_END
		) else (
			set bat_recent_error_msg=SUCCESS - 13.a. Submission [!bat_capturedfilesdir!]
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		)
			!bat_popecho!


		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "submit" (goto :AUTOCAMS_END)

	:AC_MAKEZIPAUTO
		!bat_pushecho! !bat_batchfile!:AC_MAKEZIPAUTO %*
		rem  16.  Make Transmit Zip
		call :MAKEZIPAUTO
		call :SAVECONFIG
		if /i "!bat_retval!" neq "success" (
			!bat_popecho!
			goto :AUTOCAMS_END
		)
			!bat_popecho!

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "zip" (goto :AUTOCAMS_END)

	:AC_FTPAUTO
		!bat_pushecho! !bat_batchfile!:AC_FTPAUTO %*
		rem  17.  Upload Zip
		set bat_retval=
		call :UPLOADFTPAUTO
		call :SAVECONFIG
		if /i "!bat_retval!" neq "success" (
			!bat_popecho!
			goto :AUTOCAMS_END
		)
			!bat_popecho!

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "ftp" (goto :AUTOCAMS_END)

:AUTOCAMS_END
!bat_popecho! [RETURN !bat_batchfile!:AUTOCAMS] %*

	!bat_echolog! .........Waiting !bat_AUTOCAMS.completewait! seconds
	if defined bat_submissionfilesdir (
		copy /y "!bat_logfile!" "!bat_submissionfilesdir!\!bat_camera!\Logs\AutoCams2.bat.log"
	) else (
		copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"
	)
	start /w wait !bat_AUTOCAMS.completewait!
!bat_echolog!
!bat_return!



	rem 1. Choose Target Drive  ***************************
:CHOOSETARGETDRIVE
!bat_pushlog! [CALL !bat_batchfile!:CHOOSETARGETDRIVE %*
	call "!bat_exedir!\ListDrives.bat"
	!bat_echo!
	!bat_echo!
	!bat_echo! Idealy, the target location is specified as a drive:
	!bat_echo! There are cases where the target location is a drive and path
	!bat_echo! instead.  In that case, enter the Drive and Path without including
	!bat_echo! the CAMS part.
	!bat_echo!
	set bat_choice=
	!bat_log! set /P bat_choice=.!bat_pushstring!Enter target location [!bat_targetdrive!]: 
	set /P bat_choice=.!bat_pushstring!Enter target location [!bat_targetdrive!]: 
	!bat_log! bat_choice="!bat_choice!"
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_location!)
	set bat_choice=!bat_choice!\\
	set bat_choice=!bat_choice:\\\=!
	set bat_choice=!bat_choice:\\=!

		rem Convert "C:\CAMS" to "C:"
	if /i "!bat_choice:~-5!" equ "\CAMS" (
		set bat_choice=!bat_choice:~-5!
	)


	!bat_log! if /i "!bat_choice:~0,2!\CAMS" neq "!bat_exedir!" ...
	if           /i "!bat_choice:~0,2!\CAMS" neq "!bat_exedir!" (
		if exist "!bat_choice!\CAMS\AutoCams.bat" (
			!bat_push!
			!bat_logexeclog! dir "!bat_choice!\CAMS\AutoCams.bat" /b
			!bat_pop!
		) else (
			!bat_echolog! '  ERROR - Not exist: "!bat_choice!\CAMS\AutoCams.bat"
			goto :CHOOSETARGETDRIVE_END
		)

		if exist "!bat_choice!\CAMS\AutoCams.bat" (
			!bat_push!
			!bat_echo! Location entered:  [!bat_choice!]	
			!bat_echolog! CALL :RESET
			              call :RESET
			set bat_targetdrive=!bat_choice:~0,2!
			set bat_targetlocation=!bat_choice!
			if /i "!bat_exedrive!" equ "!bat_targetdrive!" (
				call :SAVECONFIG
			)
			!bat_echolog! Switching to the target location's AutoCams:  "!bat_choice!\CAMS\AutoCams.bat"

			rem RUN THE AUTOCAMS ON THE TARGET DIR
			cd /d "!bat_choice!\CAMS"
            "!bat_choice!\CAMS\AutoCams.bat"
            
			!bat_echolog! '  ERROR - YOU SHOULD NEVER GET HERE... [!bat_choice!]	
			!bat_pop!
		) else (
			!bat_push!
			!bat_echo! [!bat_choice!]
			!bat_push!
				!bat_echolog! '  ERROR - The cams executables and scripts are not found
				!bat_echolog! '          in the new location. You will need to copy them
				!bat_echolog! '          to the new location before being able to switch to:
				!bat_echolog! '          "!bat_choice!"
			!bat_pop!
			!bat_pop!
		)
	) else (
		call :RESET
		set bat_targetdrive=!bat_choice:~0,2!
		set bat_targetlocation=!bat_choice!
		!bat_echolog! '     [!bat_choice!]	

		call :SAVECONFIG
	)
:CHOOSETARGETDRIVE_END
!bat_poplog! [RETURN !bat_batchfile!:CHOOSETARGETDRIVE] [bat_targetdrive=!bat_targetdrive!, bat_targetlocation=!bat_targetlocation!]
!bat_log!
!bat_return!
	


	rem obsolete subroutine
:ENTERCAMERA
	!bat_log! set /p bat_camera=.!bat_pushstring!Enter Camera number: 
	set /p bat_camera=.!bat_pushstring!Enter Camera number: 
	!bat_log! bat_camera=!bat_camera!
	call :SAVECONFIG

!bat_log!
!bat_return!



	rem 2. Enter Camera ***********************************
:CHOOSECAMERA
!bat_pushlog! call !bat_batchfile.CHOOSECAMERA %*
	if not exist "!bat_targetlocation!\CAMS\Cal\CameraSites.txt" (
		echo ERROR - Not Found: "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
		echo.
	)
	set bat_choice=
	          set /P bat_choice=.!bat_pushstring!Enter your camera number: 
	!bat_log! set /P bat_choice=.!bat_pushstring!Enter your camera number: !bat_choice!

	if "!bat_choice!" equ "" goto :CAMERA_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_camera!)
	
	set bat_temp=!bat_choice!      
	set bat_temp=!bat_temp:~0,6!
	
	find /i "!bat_temp!!bat_camerahint!" "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
	set bat_returncode=!errorlevel!

	for /f "usebackq tokens=*" %%a in (`find /i "!bat_temp!!bat_camerahint!" "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"`) do (
		!bat_echo! %%a
	)

	if !bat_returncode! neq 0 (
		!bat_echo! ERROR - Camera Not Found: !bat_choice! in "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
		!bat_echo!
		pause
		goto :CAMERA_END
	)

	!bat_echo!
	set bat_choice2=
	!bat_log! set /P bat_choice2=.!bat_pushstring!Do you see your camera in this list? Y/N 
	          set /P bat_choice2=.!bat_pushstring!Do you see your camera in this list? Y/N 
	!bat_log! bat_choice2=!bat_choice2!
	if /i "!bat_choice2!" neq "y" goto :CAMERA_END

	set bat_camera=!bat_choice!

	if defined bat_capturedfilesdir (
		set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
		!bat_echolog! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
					  call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

		call :GETCAMERAFROMCAPTURED
		call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
		if defined bat_detectfile (
			if exist "!bat_detectfile!" (
				if not exist "!bat_archivedfilesdir!\CalFileList.log" (
					call :CREATECALFILELIST "!bat_detectfile!"
				)
				call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
				call :GETCONFIRMEDCOUNT
			)
		)
	)

	call :SAVECONFIG

:CAMERA_END
!bat_poplog! [RETURN !bat_batchfile!:CHOOSECAMERA] [!bat_camera!]
!bat_log!
!bat_return!


	rem Not yet implemented ***************************************
:CHOOSESTATION
!bat_pushlog! call :CHOOSESTATION %*
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_temp!" goto :CHOOSESTATION2
		if "!bat_temp!" neq "!bat_siteabbrev!" (
			set bat_counter+=1
			set bat_siteabbrev=%%f
			set bat_temp=!bat_siteabbrev!
			echo %%f  %%g
		)
		
:CHOOSESTATION2		
	)
	
	set bat_choice=
	          set /P bat_choice=.!bat_pushstring!Enter your site abbreviation (2 characters): 
	!bat_log! set /P bat_choice=.!bat_pushstring!Enter your site abbreviation (2 characters): !bat_choice!
	
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_choice!" (
			set bat_counter+=1
			echo %%a  %%b  %%c  %%d  %%e  %%f  %%g
		)
	)
	
	set bat_choice=
	          set /P bat_choice=.!bat_pushstring!Enter your camera number: 
	!bat_log! set /P bat_choice=.!bat_pushstring!Enter your camera number: !bat_choice!
	!bat_logexeclog! set bat_camera=!bat_choice!
:CHOOSESTATION_END
!bat_poplog! [RETURN !bat_batchfile!:CHOOSESTATION] [!bat_camera!]
!bat_log!
!bat_return!



	rem 3. Enter Captured Date  ***********************************
:CHOOSEDATE
!bat_pushlog! [CALL !bat_batchfile!:CHOOSEDATE
	!bat_echo!
	!bat_echo!   Here is a list of CaptureFiles directories:
	!bat_echo!
	set bat_found=false
	set /a bat_counter=0
	set bat_usesubmissiondir=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem echo     !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set /a bat_counter+=1
					set bat_temp=%%~nxa
					set bat_tempcameralist=
					set bat_prevcamera=


%bat_COMMENT_BEGIN%
					REM Need to figure out a way to speed this up
					for /f "usebackq tokens=*" %%b in (`dir "!bat_targetlocation!\CAMS\CapturedFiles\!bat_temp!\FF*.bin" /a-d /b /on`) do (
						set bat_temp2=%%~nxb
						set bat_tempcamera=!bat_temp2:~2,3!
						if /i "!bat_tempcamera!" neq "!bat_prevcamera!" (
							set bat_prevcamera=!bat_tempcamera!
							set bat_tempcameralist=!bat_tempcameralist! !bat_tempcamera!
						)
					)
%bat_COMMENT_END%
					!bat_echo! !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa   !bat_tempcameralist!
				)
			)
		)
	)

	set bat_choice=
	echo.
	echo     Enter either of the following:
	echo       - The number matching the date to process
	echo       - [S] to pick from the SubmissionFiles directories
	echo       - A date using the following format: [mm/dd/yyyy]
	echo       - Or Enter to go back to the menu
	          set /P bat_choice=.!bat_pushstring! 
	!bat_log! set /P bat_choice=.!bat_pushstring!   !bat_choice!

	if /i "!bat_choice!" equ "" (
		!bat_echo! Aborting with "!bat_choice!"
		goto :CHOOSEDATE_END
	)
	!bat_log! !bat_batchfile!:CHOOSEDATE bat_choice=!bat_choice!

:CHOOSEDATESUB
	!bat_log! [!bat_batchfile!:CHOOSEDATE::CHOOSEDATESUB]
	set bat_found=false
	rem ==================================
	if /i "!bat_choice!" NEQ "s" (
		rem You get here when the user enters a date in the format:
		rem   10/21/2012 [american format: mm/dd/yyyy]
		
		!bat_echo!

		rem Check for any "/" in the choice string to indicate manual entry of a date
		echo.!bat_choice!|find /i "/">nul:
		if !errorlevel! equ 0 (
			rem A manual date entry was made
			goto :CHOOSEDATE2
		)

		rem You get here if the user selected an entry from the CapturedFiles listing
		if !bat_counter! equ 0 (
			rem You get here when bat_counter=0.  The bat_counter variable is the number of
			rem items listed in the CapturedFiles listing. 
			set bat_choice=
			          set /P bat_choice=.!bat_pushstring!No CapturedFiles directories found matching "!bat_targetlocation!\CAMS\CapturedFiles". Enter any key to go back to the menu. 
			!bat_log! set /P bat_choice=.!bat_pushstring!No CapturedFiles directories found matching "!bat_targetlocation!\CAMS\CapturedFiles". Enter any key to go back to the menu. !bat_choice!
			goto :CHOOSEDATE_END
		)

		
		!bat_echo! Falls through to listing of ...\CapturedFiles matching the selected date: 
		set bat_found=false
		set /a bat_counter=0
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles" /b /ad /on`) do (
			if /i "%%~nxa" neq "movies" (
				if /i "%%~nxa" neq "displayJPEGS" (
					if /i "%%~nxa" neq "gefdat" (
						set /a bat_counter+=1
						if "!bat_counter!" equ "!bat_choice!" (
							call :RESET
							set bat_found=true
							set bat_temp=%%a
							set bat_capturedtime=!bat_temp:~11,8!
							set bat_captureddate=!bat_temp:~0,10!
							set bat_dirname=%%a
							set bat_tempfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
							
							!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs" "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
									  call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs" "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
						)
					)
				)
			)
		)

		if /i "!bat_found!" equ "false" goto :CHOOSEDATE_END
		
		goto :CHOOSEDATE3

	) else (
		rem 3s. Choose date from SubmissionFiles

		!bat_pushlog! [CALL !bat_batchfile!:CHOOSEDATE::CHOOSEDATESUB]
		if /i "!bat_choice!" equ "s" (
			!bat_echolog! Scanning SubmissionFiles directory...
			set bat_usesubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles"

			set /a bat_counter=0
			!bat_pushlog! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`^) do ...
			for      /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`) do (
				set /a bat_counter+=1
				!bat_echolog! !bat_counter!. %%a
			)
			!bat_poplog!

			!bat_echo!
			if !bat_counter! equ 0 (
				set bat_choice=
				          set /P bat_choice=.!bat_pushstring!No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. 
				!bat_log! set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. !bat_choice!
				goto :CHOOSEDATE_END
			)

			set bat_choice=
			          set /P bat_choice=.!bat_pushstring!Select the SubmissionFiles directory to work with: 
			!bat_log! set /P bat_choice=.!bat_pushstring!Select the SubmissionFiles directory to work with: !bat_choice!

			if "!bat_choice!" equ "" goto :CHOOSEDATE_END

			set /a bat_counter=0
			set bat_found=false
			!bat_echo! Listing of SubmissionFiles: 
			for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`) do (
				set /a bat_counter+=1
				if "!bat_counter!" equ "!bat_choice!" (
					!bat_echo! "!bat_choice!"
					call :RESET
					set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\%%a
					set bat_found=true
					set bat_dirname=%%~nxa
					set bat_submissiondirname=%%~nxa
					set bat_Submissiondate=!bat_dirname:~0,10!
					set bat_captureddate=!bat_Submissiondate!
					set bat_capturedtime=!bat_dirname:~11,8!
					
					!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
							  call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
				)
			)

			if "!bat_found!" neq "" (
				goto :CHOOSESUBMISSION1
			) else (
				goto :CHOOSEDATE_END
			)
		)& end if /i "!bat_choice!" equ "s"...
	)& end ELSE [if /i "!bat_choice!" NEQ "s"]

:CHOOSEDATE2
	!bat_log! [!bat_batchfile!:CHOOSEDATE::CHOOSEDATE2]
	rem You can get here with bat_choice containing:
	rem   - A manually entered date [mm/dd/yyyy]
	rem

	echo "!bat_choice!"
	call :RESET
	
	rem Parse a manually entered date
	for /f "delims=/ tokens=1-3" %%a in ("!bat_choice!") do (
		set bat_yyyy=20%%c
		set bat_yyyy=!bat_yyyy:~-4!
		set bat_mm=0%%a
		set bat_mm=!bat_mm:~-2!
		set bat_dd=0%%b
		set bat_dd=!bat_dd:~-2!
	)

	set bat_captureddate=!bat_yyyy!_!bat_mm!_!bat_dd!
	!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
	          call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
:CHOOSEDATE3
	!bat_log! [!bat_batchfile!:CHOOSEDATE::CHOOSEDATE3]
	set bat_capturedfilesdir=
	set bat_archivedfilesdir=
	set bat_GCFC_tempfile=
	set bat_latestcal=
	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	call :SAVECONFIG
	
	set bat_capturedfilesdir=!bat_tempfilesdir!
	set bat_capdirname=!bat_tempdirnme!
	set bat_found=true
	set bat_GCFC_tempatefile=!bat_capturedfilesdir!\GCFC.log
	!bat_echo!
	!bat_echo! Automatically selecting !bat_capturedfilesdir! because the dir should match exactly...
	
	call :CHOOSECAP2

	rem call :CHOOSECAP
	call :CHOOSEARCH
:CHOOSEDATE_END
	set bat_yyyy=
	set bat_mm=
	set bat_dd=
	set bat_choice=
	set bat_found=
	set bat_counter=
	set bat_usesubmissiondir=
	set bat_temp=
	set bat_tempcameralist=
	set bat_prevcamera=
!bat_poplog! [RETURN !bat_batchfile!:CHOOSEDATE] [!bat_captureddate!]
!bat_log!
!bat_return!


:CLEARSCREEN
	for /l %%A in (1,1,50) do (echo.)
!bat_log!
!bat_return!



	rem 4. Choose CapturedFiles directory *******************
:CHOOSECAP
	rem Choose Captured directory
	echo.
	set /a bat_counter=0

	set bat_finddate=
	if "!bat_captureddate!" neq "" (
		set bat_finddate=\!bat_captureddate!*
	)

	if /i "!bat_submissionfilesdir!" neq "" (
		goto :CHOOSECAP2
	)

	!bat_pushecho! Listing of CapturedFiles:
	!bat_echo!

	rem echo for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`^) do ^(
	for          /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					rem echo      !bat_counter!. !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set bat_tempfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set bat_tempdirname=%%~nxa

					set bat_temp=%%~nxa
					set bat_tempcameralist=
					set bat_prevcamera=
					for /f "usebackq tokens=*" %%b in (`dir "!bat_targetlocation!\CAMS\CapturedFiles\!bat_temp!\FF*.bin" /a-d /b /on`) do (
						set bat_temp2=%%~nxb
						set bat_tempcamera=!bat_temp2:~2,3!
						if /i "!bat_tempcamera!" neq "!bat_prevcamera!" (
							set bat_prevcamera=!bat_tempcamera!
							set bat_tempcameralist=!bat_tempcameralist! !bat_tempcamera!
						)
					)
					!bat_echo! !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa   !bat_tempcameralist!

				)
			)
		)
	)
	!bat_popecho!
	
	if !bat_counter! equ 0 (
		          set /P bat_choice=.!bat_pushstring!No CapturedFiles directories found matching !bat_captureddate!
		!bat_log! set /P bat_choice=.!bat_pushstring!No CapturedFiles directories found matching !bat_captureddate!!bat_choice!
		goto :CHOOSECAP_END
	)
	

	if !bat_counter! equ 1 (
		set bat_capturedfilesdir=!bat_tempfilesdir!
		set bat_dirname=!bat_tempdirname!
		set bat_capdirname=!bat_tempdirname!
		set bat_found=true
		set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
		!bat_echo!
		!bat_echo! Automatically selecting !bat_capturedfilesdir! because there is only one choice. 
		goto :CHOOSECAP2
	)

	set bat_choice=
	          set /P bat_choice=.!bat_pushstring!Select the CapturedFiles directory to work with ^([CR] to skip this step^): 
	!bat_log! set /P bat_choice=.!bat_pushstring!Select the CapturedFiles directory to work with ^([CR] to skip this step^): !bat_choice!
	if "!bat_choice!" equ "" goto :CHOOSECAP_END

	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	set /a bat_counter=0
	set bat_found=false
	set bat_dirname= 

	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_capturedfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
						set bat_dirname=%%~nxa
						set bat_capdirname=%%~nxa
						set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
						set bat_found=true
					)
				)
			)
		)
	)
	if /i !bat_found! equ false goto :CHOOSECAP

:CHOOSECAP2
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
		set bat_capturedtime=!bat_dirname:~11,8!
		
		!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
				  call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
	)
	
	rem set bat_captureddate=
	set bat_archivedfilesdir=
	set bat_archdirname=
	set bat_archivedate=
	set bat_submissiondirname=
	set bat_submissiondate=

	!bat_pushecho! Reading the new directories, please wait... [!time!]
	rem call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"

	if defined bat_capturedfilesdir (
		set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
		!bat_echolog! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
					  call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

		call :GETCAMERAFROMCAPTURED
		call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
		if defined bat_detectfile (
			if exist "!bat_detectfile!" (
				rem if not exist "!bat_archivedfilesdir!\CalFileList.log" (
					call :CREATECALFILELIST "!bat_detectfile!"
				rem )
				call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
				call :GETCONFIRMEDCOUNT
			)
		)
	)
	!bat_popecho!

	call :SAVECONFIG
:CHOOSECAP_END
!bat_log!
!bat_return!



:GETCAMERAFROMCAPTURED
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMCAPTURED] %*

	if exist "!bat_GCFC_tempfile!" (
		call "!bat_exedir!\GetCameraList.bat" "!bat_GCFC_tempfile!"
		call :GETCAPTUREDCOUNT "!bat_capturedfilesdir!"
		goto :GETCAMERAFROMCAPTURED_END
	) else (
		call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
		call :GETCAPTUREDCOUNT "!bat_capturedfilesdir!"
		goto :GETCAMERAFROMCAPTURED_END
	)

	set /a bat_capturedcount=0
	set bat_camera_temp=
	set bat_camera_prev=
	set bat_camera_list=
	set /a bat_camera_count=0
	
	if not defined bat_capturedfilesdir (
		goto :GETCAMERAFROMCAPTURED_END
	)

	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d /o-n`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d /o-n`) do (
		set /a bat_capturedcount+=1
		set bat_temp=%%~nxa
		
		set bat_camera_temp=!bat_temp:~2,3!

		if /i "!bat_camera_prev!" neq "!bat_camera_temp!" (
			if not defined bat_camera_list (
				!bat_log! a        set bat_camera_list=0!bat_camera_temp!
				set bat_camera_list=0!bat_camera_temp!
				set bat_camera_prev=!bat_camera_temp!
				set /a bat_camera_count+=1
				echo !bat_camera_temp!>>"!bat_GCFC_tempfile!"
			) else (
				call :CHECK_GCFC "!bat_camera_temp!"
				if not defined bat_GCFC_found (
					!bat_log! c        set bat_camera_list=!bat_camera_list!0!bat_camera_temp!
					set bat_camera_list=!bat_camera_list!0!bat_camera_temp!
					set bat_camera_prev=!bat_camera_temp!
					set /a bat_camera_count+=1
					echo !bat_camera_temp!>>"!bat_GCFC_tempfile!"
				)
			)

			rem if not defined bat_camera (
			rem 	set bat_camera=!bat_camera_temp!
			rem 	!bat_log! b    set bat_camera=!bat_camera_temp!
			rem )
		)
	)
	!bat_poplog!
	
	set bat_camera_list=
	!bat_log! Sorting camera list in "!bat_GCFC_tempfile!" - before...
	!bat_logexeclog! type "!bat_GCFC_tempfile!"

	!bat_log!
	!bat_logexeclog! sort "!bat_GCFC_tempfile!" /output "!bat_GCFC_tempfile!"
	!bat_log!
	!bat_log! Sorting camera list in "!bat_GCFC_tempfile!" - after...
	!bat_logexeclog! type "!bat_GCFC_tempfile!"
	
:GETCAMERAFROMCAPTURED_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMCAPTURED] [bat_camera=!bat_camera!, bat_camera_list=!bat_camera_list!, bat_capturedcount=!bat_capturedcount!]
!bat_log!
!bat_return!


:CHECK_GCFC
!bat_pushlog! !bat_batchfile!:CHECK_GCFC [%*]
	set bat_GCFC_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_GCFC_tempfile!">nul: 2>&1`) do (
		if /i "%~1" equ "%%~x" (
			set bat_GCFC_found=true
		)
	)
:CHECK_GCFC_END
!bat_poplog! [RETURN !bat_batchfile!:CHECK_GCFC] [%~1, bat_GCFC_found=!bat_GCFC_found!]
!bat_log!
!bat_return!


:GETCAPTUREDCOUNT [in] "!bat_capturedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETCAPTUREDCOUNT] %*

	for /f "usebackq tokens=1" %%a in (`dir "%~1\FF*.bin"^|find /i " File(s)"`) do (
		set bat_capturedcount=%%a
	)

:GETCAPTUREDCOUNT_END
!bat_poplog! [RETURN !bat_batchfile!:GETCAPTUREDCOUNT] [bat_capturedcount=!bat_capturedcount!]
!bat_log!
!bat_return!



	rem 5. Choose ArchivedFiles directory ***********************
:CHOOSEarch
!bat_pushlog! [CALL !bat_batchfile!:CHOOSEarch] %*

	set /a bat_counter=0
	set bat_finddate=
	
	if "!bat_captureddate!" neq "" (
		set bat_finddate=\!bat_captureddate!*
	)

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_temparch=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!\!bat_camera!\ArchivedFiles!bat_finddate!
		set bat_temparchbase=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!\!bat_camera!\ArchivedFiles
	) else (
		set bat_temparch=!bat_targetlocation!\CAMS\ArchivedFiles!bat_finddate!
		set bat_temparchbase=!bat_targetlocation!\CAMS\ArchivedFiles
	)
	!bat_echolog! bat_temparch=!bat_temparch!


	rem Choose Archived Directory
	echo.
	echo    Listing of ArchivedFiles:
	echo.
	set bat_founddirname=
	set /a bat_counter=0
	set bat_temp=
	set bat_tempdirname=
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_temparch!" /b /ad /on`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_temparch!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					rem echo      !bat_counter!. !bat_targetlocation!\CAMS\ArchivedFiles\%%~nxa

					if /i "!bat_tempdirname!" neq "!bat_dirname!" (
						set bat_temp=%%~nxa
						set bat_tempdirname=%%~nxa
					
						rem set bat_tempfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\%%~nxa
						set bat_tempfilesdir=!bat_temparchbase!\!bat_temp!



						set bat_tempcameralist=
						set bat_prevcamera=
						for /f "usebackq tokens=*" %%b in (`dir "!bat_tempfilesdir!\FF*.bin" /a-d /b /on`) do (
							set bat_temp2=%%~nxb
							set bat_tempcamera=!bat_temp2:~2,3!
							if /i "!bat_tempcamera!" neq "!bat_prevcamera!" (
								set bat_prevcamera=!bat_tempcamera!
								set bat_tempcameralist=!bat_tempcameralist! !bat_tempcamera!
							)
						)
						
						echo     !bat_counter!.  !bat_temparchbase!\%%~nxa   !bat_tempcameralist!
					) else (
						rem Item found... don't do any more work.
					)
				)
			)
		)
	)
	echo.

	if !bat_counter! equ 0 (
		if not defined bat_autonomous (
			          set /P bat_choice=.!bat_pushstring!No ArchivedFiles directories found matching !bat_captureddate!
			!bat_log! set /P bat_choice=.!bat_pushstring!No ArchivedFiles directories found matching !bat_captureddate!!bat_choice!
			goto :CHOOSESEARCH_END
		)
	)

	if /i "!bat_tempdirname!" equ "!bat_dirname!" (
		set bat_archivedfilesdir=!bat_tempfilesdir!
		set bat_dirname=!bat_tempdirname!
		set bat_archdirname=!bat_tempdirname!
	    set bat_archiveddate=!bat_dirname:~0,10!
	    set bat_archivedtime=!bat_dirname:~11,8!
		set bat_found=true
		!bat_echolog!
		!bat_echolog! '    Automatically selecting !bat_archivedfilesdir! because there is only one choice
		goto :CHOOSEarch2
	)

	
	set bat_choice=
	          set /P bat_choice=.!bat_pushstring!Select the ArchivedFiles directory to work with ^([CR] to skip this step^) : 
	!bat_log! set /P bat_choice=.!bat_pushstring!Select the ArchivedFiles directory to work with ^([CR] to skip this step^) : !bat_choice!
	if "!bat_choice!" equ "" goto :CHOOSESEARCH_END

	set /a bat_counter=0
	set bat_found=false
	for /f "usebackq tokens=*" %%a in (`dir "!bat_temparch!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_archivedfilesdir=!bat_temparchbase!\%%a
						set bat_found=true
						set bat_dirname=%%~nxa
						set bat_archdirname=%%~nxa
						set bat_archiveddate=!bat_dirname:~0,10!
						set bat_archivedtime=!bat_dirname:~11,8!
					)
				)
			)
		)
	)
	if /i !bat_found! equ false goto :CHOOSEARCH

:CHOOSEarch2
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
		set bat_capturedtime=!bat_dirname:~11,8!
		
		!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
				  call "!bat_exedir!\RedirectLogs.bat" "!bat_exedir!\Logs"  "!bat_exedir!\Logs\!bat_captureddate!_!bat_capturedtime!"
	)
	!bat_echolog! '    Getting file count, please wait... [!time!]
	rem call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"

	call :GETCAMERAFROMARCHIVED

	call :GETDETECTFILE  "bat_detectfile" "bat_archivedfilesdir"

	if not exist "!bat_detectfile!" (
		!bat_echolog! '    ERROR - can't file detect file in "!bat_archivedfilesdir!"
		goto :CHOOSESEARCH_END
	)

	if defined bat_detectfile (
		if exist "!bat_detectfile!" (
			rem if not exist "!bat_archivedfilesdir!\CalFileList.log" (
				call :CREATECALFILELIST "!bat_detectfile!"
			rem )
		)
	)

	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"

	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_confirmedfilesdir!" "!bat_detectfileconf!"
	call :SAVECONFIG

:CHOOSEarch_END
!bat_poplog! [RETURN !bat_batchfile!:CHOOSEarch] [!bat_archivedfilesdir!]
!bat_log!
!bat_return!


	rem CAREFUL - There could be multiple cameras
:GETCAMERAFROMARCHIVED
!bat_pushlog! [CALL !bat_batchfile!:GETCAMERAFROMARCHIVED] %*
	set bat_camera_temp=
	set /a bat_archivedcount=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		if /i "!bat_camera!" equ "!bat_temp:~2,3!" (
			set bat_camera_temp=!bat_temp:~2,3!
		)
	)
	
	if !bat_archivedcount! neq 0 (
		if not defined bat_camera_temp (
			!bat_echolog! '    WARNING - No FF*.bin files matching the specified camera [!bat_camera!]
		)
	)
!bat_poplog! [RETURN !bat_batchfile!:GETCAMERAFROMARCHIVED] [bat_camera=!bat_camera!, bat_archivedcount=!bat_archivedcount! files]
!bat_log!
!bat_return!


:GETMETEORCOUNTARCHIVED [in] bat_archivedmeteorcount "!bat_archivedfilesdir!"
!bat_pushlog! [CALL !bat_batchfile!:GETMETEORCOUNTARCHIVED] %*
	set bat_temp=%~1
	!bat_log! argv[1]="%~1"

	if /i "!bat_temp!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_temp=%~2
	!bat_log! bat_argv[2]="%~2"
	if /i "!bat_temp!" equ "" (
		!bat_log! '    ERROR - !bat_batchfile!:GETMETEORCOUNTARCHIVED - 2nd argument is missing.
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_temp=%~2
	set bat_temp2=%~nx2
	if not defined bat_capturedtime (
		if defined bat_capturedfilesdir (
				rem Parse the bat_capturedfilesdir and extract the time segment
			for /f "usebackq tokens=*" %%x in (`echo "!bat_capturedfilesdir!"`) do (
				set bat_temp3=%%~nxx
				set bat_capturedtime=!bat_temp3:~11,8!
			)
		) else (
			!bat_echolog! '    ERROR !bat_batchfile!:GETMETEORCOUNTARCHIVED - bat_capturedfilesdir isn't defined yet.
			goto :GETMETEORCOUNTARCHIVED_END
		)
	)

	if not defined bat_detectfile (
		!bat_echolog! '    Not defined: bat_detectfile, setting to "!bat_detectfile!"
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set %~1=
	set bat_latestcal=

	if /i "%~2" equ "" (
		!bat_echolog! '    WARNING - !bat_batchfile!:GETMETEORCOUNTARCHIVED - No ArchivedFiles directory
		goto :GETMETEORCOUNTARCHIVED_END
	)

	if not defined bat_detectfile (
		call :FINDDETECT "bat_detectfile" "bat_archivedfilesdir"
	)

	
	set /a %~1=0
	rem !bat_log! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_detectfile!"`^) do ...
	rem for           /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfile!"`) do (
	!bat_log! for /f "usebackq tokens=1-3 skip=1 delims=:" ..a in ^(`find /i /c ".txt" "!bat_detectfile!"`^) do ...
	for           /f "usebackq tokens=1-3 skip=1 delims=:" %%a in  (`find /i /c ".txt" "!bat_detectfile!"`) do (
		rem set /a %~1+=1
		set bat_temp=%%c
		set bat_temp=!bat_temp:~1,20!
		set /a %~1=!bat_temp!
		set bat_temp=
	)

	call :GETLATESTCAL "!bat_captureddate!"

%bat_COMMENT_BEGIN%

	set bat_latestcal=
	set bat_tempdatecaptured=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!
	!bat_log! for /f "usebackq tokens=*" ..X in ^(`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /od`^) do...
	for           /f "usebackq tokens=*" %%X in  (`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /od`) do (
		set bat_tempdatedir=%%X
		set bat_tempdatedir=!bat_tempdatedir:~7,8!
		if "!bat_tempdatedir!" LEQ "!bat_tempdatecaptured!" (
			set bat_latestcal=%%X
		)
	)
%bat_COMMENT_END%

	!bat_logexec! type "!bat_archivedfilesdir!\CalFileList.log"

	!bat_pushlog! Perform ValidateCal.bat for each file in: "!bat_archivedfilesdir!\CalFileList.log"...
	for /f "usebackq tokens=*" %%X in (`type "!bat_archivedfilesdir!\CalFileList.log"`) do (
		set bat_temp=%%X
		if /i "!bat_temp:~3,3!" equ "!bat_camera!" (
			set bat_detectcal=%%X
		)
		
		!bat_echolog! Validating Cal files..."%%X"
		!bat_log! call "!bat_exedir!\ValidateCal.bat" /cal "%%X"
		          call "!bat_exedir!\ValidateCal.bat" /cal "%%X"
	)
	!bat_pop!
!bat_log! /////////////  bat_latestcal=!bat_latestcal!, bat_detectcal=!bat_detectcal!

:GETMETEORCOUNTARCHIVED_END
!bat_poplog! [RETURN !bat_batchfile!:GETMETEORCOUNTARCHIVED] [bat_archivedmeteorcount=!bat_archivedmeteorcount!, bat_latestcal=!bat_latestcal!, bat_detectcal=!bat_detectcal!]
!bat_log!
!bat_return!



	rem 5a. GetDetectFile ******************************************
	rem     Sets the 'bat_detectfile' variable.  Works the same
	rem     as GETDETECTFILE. 
:DETECTFILE_GET
	call :FINDDETECT "bat_detectfile" "bat_archivedfilesdir"
:DETECTFILE_GET_END
!bat_log!
!bat_return!




:FINDDETECT [in] "bat_detectfile" "bat_archivedfilesdir"
!bat_pushlog! [CALL !bat_batchfile!:FINDDETECT] %*
	call :GETDETECTFILE "%~1" "%~2"

:FINDDETECT_END
!bat_poplog! [RETURN !bat_batchfile!:FINDDETECT] [%~1=!%~1!]
!bat_log!
!bat_return!





	rem Calls the GetDetectFile.bat script, passing along the two arguments passed.
	rem [out] The first parameter is used as the target variable where the discovered
	rem       detect file in the source dir [specified in the 2nd argument] is stored.
	rem [in]  The source directory.  Typically, either bat_archivedfilesdir
	rem       or bat_confirmedfilesdir.  Could also be directories in the
	rem       SubmissionFiles dir.
:GETDETECTFILE [out] "bat_detectfile" [in] "bat_archivedfilesdir"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE] %*

	!bat_logexeclog! call "!bat_exedir!\GetDetectFile.bat" "%~1" "%~2"

	if not defined %~1 (
		!bat_log! '    ERROR - Unable to locate detect file [%~1].
		goto :GETDETECTFILE_END
	) else (
		call :GETDETECTFILE_PARSE "!%~1!"
	)

	if not exist "!%~1!" (
		!bat_log! '    ERROR - Unable to locate detect file [%~1].
		goto :GETDETECTFILE_END
	)

:GETDETECTFILE_END
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE] [%~1=!%~1!]
!bat_log!
!bat_return!


	rem Take the specified detect fiel and produce four variables out of it as follows:
	rem   bat_detectfile1    full detectfile name
	rem   bat_detectfile3    Just the filename w/o extent
	rem   bat_detectfile4    The filename w/ extent
:GETDETECTFILE_PARSE [in] "!bat_detectfile!"
!bat_pushlog! [CALL !bat_batchfile!:GETDETECTFILE_PARSE] %*
	set bat_detectfile1=%~1
	set bat_detectfile3=%~n1
	set bat_detectfile4=%~nx1
!bat_poplog! [RETURN !bat_batchfile!:GETDETECTFILE_PARSE] [!bat_detectfile1!, 
!bat_log! '                                        !bat_detectfile3!,
!bat_log! '                                        !bat_detectfile4!]
!bat_log!
!bat_return!



	rem Creates the "CalFileList.log" in the ArchivedFiles dir.  The file
	rem contains a list of all the Cal files found in the detect file
	rem [one for each camera in the detect file]. 
:CREATECALFILELIST
!bat_pushlog! [CALL !bat_batchfile!:CREATECALFILELIST] %*
	!bat_log! call "!bat_exedir!\CreateCalFileList.bat" "!bat_detectfile!"
	          call "!bat_exedir!\CreateCalFileList.bat" "!bat_detectfile!"

:CREATECALFILELIST_END
!bat_poplog! [RETURN !bat_batchfile!:CREATECALFILELIST] [!bat_camera_list!]
!bat_log!
!bat_return!




	rem Sets the bat_latestcal variable to the newest Cal file in the Cal dir
	rem that is the same or newer than the captured date.  This is later compared 
	rem with the date of the file currently being used in the detect file
	rem [which we call 'bat_detectcal']. 
:GETLATESTCAL [in]
!bat_pushlog! [CALL !bat_batchfile!:GETLATESTCAL] %*

	set bat_latestcal=
	if defined bat_captureddate (
		set bat_tempdatecaptured=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

		if not exist "!bat_caldir!\CAL!bat_camera!_*.txt" (
			!bat_echolog! '    ERROR - Not Exist - "!bat_caldir!\CAL!bat_camera!_*.txt"
			goto :GETLATESTCAL_END
		)
		
		!bat_log! for /f "usebackq tokens=*" ..X in ^(`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /od`^) do...
		for           /f "usebackq tokens=*" %%X in  (`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /od`) do (
			set bat_tempdatedir=%%X
			set bat_tempdatedir=!bat_tempdatedir:~7,8!
			if "!bat_tempdatedir!" LEQ "!bat_tempdatecaptured!" (
				set bat_latestcal=%%X
			)
		)
	)

:GETLATESTCAL_END
!bat_poplog! [RETURN !bat_batchfile!:GETLATESTCAL] [bat_latestcal=!bat_latestcal!]
set bat_tempdatedir=
set bat_tempdatecaptured=
!bat_log!
!bat_return!






	rem 6. SkippedFrames ******************************************
	rem    Lists the skipped frames and produces a summary.  The summary is 
	rem    saved in the current bat_logfile. 
:SKIPPEDFRAMES
	if /i "%~1" equ "" (set bat_args=) else (set bat_args=/v /ok) 
	!bat_echolog! call "!bat_exedir!\skippedFrames.bat" /camera !bat_camera! "!bat_capturedfilesdir!"
	              call "!bat_exedir!\SkippedFrames.bat" /camera !bat_camera! "!bat_capturedfilesdir!"

:SKIPPEDFRAMES_END
	if /i "%~1" equ "" (pause)
!bat_log!
!bat_return!





	rem 7a. Cal Update ********************************************
:CALUPDATE
!bat_pushlog! [CALL !bat_batchfile!:CALUPDATE] %*
	set bat_returncode=1
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		          set /p bat_choice=.!bat_pushstring!You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=.!bat_pushstring!You probably don't want to do this - you have already run Submission: !bat_choice!
		goto :CALUPDATE_END
	)
	
	echo.
	echo Typically, you would calibrate using the ArchivedFiles dir, however,
	echo there may be times when the Meteor Count is low and you'd need to 
	echo calibrate using the CapturedFiles dir.  
	echo.
	echo Instructions: When asked to "Navigate to FF Folder for Reprocessing", 
	echo navigate to either the "!bat_archivedfilesdir" or 
	echo "!bat_capturedfilesdir!" and click OK.  
	echo.
	echo Press "1" until the "Mean O-C" value is less than 1.00. Then look at the 
	echo "Number of calstars used".  If the number is less than 100, you can run 
	echo the FTP_MeteorCal_Update again with the same or later time until the 
	echo "Mean O-C" value is less than 1.00 with the "Number of calstars used" 
	echo greater than 99.  If that method fails, run FTP_MeteorCal to perform a
	echo manual calibration.  Then verify your manual calibration using 
	echo FTP_MeteorCal_Update using the Mean O-C and calstars targets.
	echo.
	echo Write down the date/time of the FF file used for calibration. The 
	echo best time to do this is just before hitting "c". 
	echo.
	echo.
	          set /P bat_choice=.!bat_pushstring!Press Enter to continue 
	!bat_log! set /P bat_choice=.!bat_pushstring!Press Enter to continue !bat_choice!

	!bat_echolog! call !bat_exedir!\FTP_MeteorCal_Update.exe "!bat_caldir!" "!bat_archivedfilesdir!"
	              call !bat_exedir!\FTP_MeteorCal_Update.exe "!bat_caldir!" "!bat_archivedfilesdir!"
	set bat_returncode_save=!errorlevel!
	pause

	call :CREATECALFILELIST "!bat_detectfile!"
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"

	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	set bat_recent_error_msg=Recent process operation: 7a.
	echo.

:CALUPDATE_END
!bat_poplog! [RETURN !bat_batchfile!:CALUPDATE] [bat_returncode=!bat_returncode_save!]
pause
!bat_log!
set bat_returncode_save=
!bat_return!





	rem 7b. Cal Auto Update ********************************************
:CALUPDATEAUTO
!bat_pushlog! [CALL !bat_batchfile!:CALUPDATEAUTO] %* [AUTOCAL... bat_archivedmeteorcount=!bat_archivedmeteorcount!]

set bat_returncode=0
set bat_retval=success



	set bat_returncode=0
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog!
		!bat_echolog! '    You probably don't want to do this - you have already run Submission: 
		if not defined bat_autonomous (
			          set /p bat_choice=[Enter] to quit, 
			!bat_log! set /p bat_choice=[Enter] to quit, !bat_choice!
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=[!bat_returncode!]
			goto :CALUPDATEAUTO_END
		)
	)
	
	rem Should be something like:
	rem   call :autocalupdate.bat 100 1.00 "!bat_caldir!" "!bat_capturedfilesdir!"
	rem
	rem And then check the autocal log for success/failure


	if /i "!bat_archivedmeteorcount!" equ "0" (
		!bat_push!
			set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - Meteor Count is 0. Nothing to calibrate.
			!bat_echolog! !bat_recent_error_msg!

			set bat_retval=failed
			set bat_returncode=1
		!bat_pop!
		goto :CALUPDATEAUTO_END
	) else (
		!bat_push!
			rem Call AutoCal.bat to perform the autocal procedure.  Returns errorlevel...
			!bat_log! call "!bat_exedir!\AutoCal.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! !bat_autonomous!
			          call "!bat_exedir!\AutoCal.bat" "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! !bat_autonomous!
			set bat_returncode=!errorlevel!

			!bat_echolog! Return code from FTP_MeteorCal_AutoUpdate.exe is: !bat_returncode!
			set bat_retval=executed
		!bat_pop!
	)
	
	!bat_echolog!
	!bat_echolog! "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
	!bat_echolog!
	
	set bat_calfilelist.created=

	!bat_pushecho! Validate the AutoCalUpdate.log file for each camera...
	set bat_camera_temp=
	for /f "usebackq tokens=1-12 skip=2" %%a in (`find /i "camera " "!bat_capturedfilesdir!\AutoCalUpdate.log"`) do (
		set bat_autocal_success=0

		if /i "%%a" neq "Auto-Calibrating" (
			!bat_echolog! %%a %%b %%c %%d, %%e %%f %%g %%h %%i

			if /i "%%a" equ "camera" (
				set bat_autocal_camera=%%b
				set bat_autocal_success=%%c
				set bat_autocal_nstars=%%d
				set bat_autocal_oc=%%e
				set bat_autocal_fffile=%%f
				set bat_autocal_calfile=%%g

				if !bat_autocal_oc! GTR !bat_caloc! (
					set bat_autocal_success=1
					set bat_returncode=1
					set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - ERROR   O-C !bat_autocal_oc! GTR !bat_caloc!
					!bat_push!
						!bat_echolog!
						!bat_echolog! !bat_recent_error_msg!
						!bat_echolog!
						!bat_echolog! Camera:	!bat_autocal_camera!
						!bat_echolog! Success:	FAILED
						!bat_echolog! nStars:	!bat_autocal_nstars!
						!bat_echolog! O-C:	!bat_autocal_oc!
						!bat_echolog! FF file:	!bat_autocal_fffile!
						!bat_echolog! calfile:	!bat_autocal_calfile!
						!bat_echolog!
					!bat_pop!

					rem Delete the cal file if the O-C value is too high, even though
					rem the .exe program thinks it's ok. 
					if "!bat_autocal_calfile!" neq "" (
						if exist "!bat_caldir!\!bat_autocal_calfile!" (
							!bat_logexec! del "!bat_caldir!\!bat_autocal_calfile!"
						)
					)

					!bat_echolog! '    !bat_recent_error_msg!
				)& rem !bat_autocal_oc! GTR !bat_caloc!
	
				if /i "!bat_autocal_success!" neq "0" (
					set bat_returncode=1
					!bat_echolog! '    set bat_returncode=[!bat_returncode!]
					set bat_recent_error_msg=ERROR - 7b.a. Auto Calibration failed
					!bat_echolog! '    !bat_recent_error_msg!
				) else (
					!bat_push!
						!bat_echolog!
						!bat_echolog! Camera:	!bat_autocal_camera!
						!bat_echolog! Success:	SUCCESS
						!bat_echolog! nStars:	!bat_autocal_nstars!
						!bat_echolog! O-C:		!bat_autocal_oc!
						!bat_echolog! FF file:	!bat_autocal_fffile!
						!bat_echolog! calfile:	!bat_autocal_calfile!
						!bat_echolog!
					!bat_pop!
					set bat_recent_error_msg=SUCCESS - 7b. Auto Calibration successful [!bat_autocal_calfile!, !bat_autocal_nstars!, !bat_autocal_oc!]
					!bat_echolog! '    !bat_recent_error_msg!
					
					if not defined bat_calfilelist.created (
						call :CREATECALFILELIST "!bat_detectfile!"
						call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
						call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
						set bat_calfilelist.create=true
					)

				)
	
				!bat_echolog!
			)
		)
	)
	!bat_popecho! End of validation...
	

:CALUPDATEAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:CALUPDATEAUTO] [!bat_retval!, !bat_returncode!]
set bat_calfilelist.created=
if not defined bat_autonomous (pause)
!bat_log!
!bat_return!









	rem 7c. Cal Auto Update with prompt ********************************************
:CALUPDATEAUTOPROMPT
!bat_pushlog! [CALL !bat_batchfile!:CALUPDATEAUTOPROMPT] %*

	set bat_retval=
	set bat_returncode=
	set bat_savedefaultnstars=!bat_calnstars!
	set bat_savedefaultoc=!bat_caloc!
:CALUPDATEAUTOPROMPT2
	
	set bat_choice=
	          set /p bat_choice=Enter the minimum number of Cal Stars [!bat_calnstars!]: 
	!bat_log! set /p bat_choice=Enter the minimum number of Cal Stars [!bat_calnstars!]: !bat_choice!
	if /i "!bat_choice!" equ "q" goto :CALUPDATEAUTOPROMPT_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_calnstars!)
	
	if /i !bat_choice! lss 6 (
		!bat_echolog!
		!bat_echolog! '     ERROR - 7c. Minimum number of Cal stars supported is 6 
		!bat_echolog!
		goto :CALUPDATEAUTOPROMPT2
	)
	set /a bat_calnstars=!bat_choice!
	
	set bat_choice=
	          set /p bat_choice=Enter the minimum Main )-C [!bat_caloc!]: 
	!bat_log! set /p bat_choice=Enter the minimum Main )-C [!bat_caloc!]: !bat_choice!
	if /i "!bat_choice!" equ "q" goto :CALUPDATEAUTOPROMPT_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_caloc!)
	call :CALUPDATEAUTO
	set bat_calnstars=!bat_savedefaultnstars!
	set bat_caloc=!bat_savedefaultoc!
	set bat_recent_error_msg=Recent process operation: 7c.

:CALUPDATEAUTOPROMPT_END
!bat_poplog! [RETURN !bat_batchfile!:CALUPDATEAUTOPROMPT] [!bat_retval!, !bat_returncode!]
pause
!bat_log!
!bat_return!





	rem 7d. Manual Calibration ********************************************
:CAL
!bat_pushlog! [CALL !bat_batchfile!:CAL] %*

	set bat_cal.camera.save=!bat_camera!
	
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set bat_choice=
		          set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=You probably don't want to do this - you have already run Submission: !bat_choice!
		goto :CAL_END
	)

	set bat_cal_instructionfile=!bat_exedir!\temp_cal_instructions.txt
	set bat_retval=failed
	set bat_recent_error_msg=ERROR - 7d. The calibration was aborted
	set bat_fov=
	set bat_ranew=
	set bat_retval2=
	set bat_retval1=
	set bat_cal_FF_time=

		rem Get the cal file from the current FTPdetectinfo.txt file
	set bat_temp=!bat_detectfile!
	if not exist "!bat_archivedfilesdir!" (
		!bat_echolog! '    ERROR - 7d. - ArchivedFiles dir does not exist for: "!bat_archivedfilesdir!".
		!bat_echolog!
		          set /p bat_choice=Press Enter to continue or [Q]uit: 
		!bat_log! set /p bat_choice=Press Enter to continue or [Q]uit: !bat_choice!
		if /i "!bat_choice!" equ "q" goto :CAL_END
		goto :CAL_END
	)

	
	if not exist "!bat_detectfile!" (
		!bat_echolog! '    ERROR - 7d. Detect file does not exist [!bat_detectfile!]
		!bat_echolog!
		rem goto :CAL_END
	)

	if bat_CAPTURE.number.of.cameras neq 1 (
			rem Ask for the Camera number
		set bat_cal.camera=
		set bat_choice=
				  set /p bat_choice=Enter the target camera to manually calibrate: 
		!bat_log! set /p bat_choice=Enter the target camera to manually calibrate: !bat_choice!
		
		if "!bat_choice!" equ "" (goto :CAL_END)
		
		!bat_logexec! set bat_camera=!bat_choice!
	)

	set bat_detectcalfile=
	set bat_detectcalfilename=
	set bat_returncode=1
	!bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i "CAL!bat_camera!_" "!bat_temp!"`^) do ^(
	for               /f "usebackq tokens=* skip=2" %%a in  (`find /i "CAL!bat_camera!_" "!bat_temp!"`) do (
		set bat_detectcalfile=!bat_caldir!\%%~a
		set bat_detectcalfilename=%%~a
		set bat_returncode=0
	)
	!bat_poplog! ^)
	
	if "!bat_returncode!" neq "0" (
		!bat_echolog! '     ERROR - Unable to locate "CAL!bat_camera!_" in the detect file.
		!bat_echolog!
		!bat_echolog! '             bat_detetcalfile=!bat_detectcalfile!
		!bat_echolog! '             bat_detectcalfilename=!bat_detectcalfilename!
	)

		rem bat_prevcalfile is the most recently created cal file in the directory used
		rem for calculating the new RA/DEC values.  It's supposed to skip the dates
		rem that are beyond the captured date.
	set bat_cal_ff_time=
	set bat_prevcalfile=
	set bat_prevcalfilename=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /a-d /on`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /a-d /on`) do (
		set bat_temp=%%a
		set bat_caldate=!bat_temp:~7,8!
		set bat_caltime=!bat_temp:~16,10!
		set bat_caldatetime=!bat_temp:~7,18!

		set bat_tempCapturedDate=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

		if "!bat_caldate!" LEQ "!bat_tempCapturedDate!" (
			set bat_prevcalfile=!bat_caldir!\%%~a
			set bat_prevcalfilename=%%~a
		)
	)
	!bat_poplog! ^)


	!bat_pushlog! Saving temp data to "!bat_cal_instructionfile!":
			echo.>"!bat_cal_instructionfile!"
			echo.  The captured date is:        !bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!>>"!bat_cal_instructionfile!"
			echo.  The most recent applicable Cal file is: !bat_prevcalfilename!>>"!bat_cal_instructionfile!"
			echo.  The detect file is using Cal: !bat_detectcalfilename!>>"!bat_cal_instructionfile!"
			echo.     ^("!bat_temp!"^)>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"

			!bat_logexec! find /v "" "!bat_cal_instructionfile!"

	if exist "!bat_detectcalfile!" (
		set bat_retval1=
		set bat_retval2=
		!bat_echolog! call "!bat_exedir!\ValidateCal.bat" /cal "!bat_detectcalfile!"
					  call "!bat_exedir!\ValidateCal.bat" /cal "!bat_detectcalfile!"
		
	) else (
		!bat_echolog! '    ERROR - Cal file in detect file not found: "!bat_detectcalfile!"
		!bat_echolog! '            Using previous cal file instead  : "!bat_prevcalfile!"
		!bat_echolog!
		
		!bat_logexeclog! set bat_detectcalfile=!bat_prevcalfile!

		!bat_echolog! call "!bat_exedir!\ValidateCal.bat" /cal "!bat_prevcalfile!"
					  call "!bat_exedir!\ValidateCal.bat" /cal "!bat_prevcalfile!"
	)

	!bat_echo!
	!bat_echo! '   RA=!bat_retval1!, DEC=!bat_retval2!, time=!bat_retval3!
	
	rem Get FOV from bat_detectcalfile
	call :CAL_GETFOV  "!bat_detectcalfile!"
	call :CAL_GETAZ   "!bat_detectcalfile!"
	call :CAL_GETALT  "!bat_detectcalfile!"
	
	!bat_echo! '   FOV=!bat_cal.fov! AZ=!bat_cal.az! ALT=!bat_cal.alt!
	!bat_echo!
			echo.>>"!bat_cal_instructionfile!"
			echo  "!bat_detectcalfile!"
			echo    time=!bat_retval3!, RA=!bat_retval1!, DEC=!bat_retval2!, >>"!bat_cal_instructionfile!"
			echo    FOV=!bat_cal.fov! AZ=!bat_cal.az! ALT=!bat_cal.alt!>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
	
:CAL_TIMESTAMP
	echo.
	echo.
	echo.
	set bat_choice=
	echo Enter the timestamp of the FF you intend to use for calibration ^(in hhmmss format^) 
	          set /p bat_choice=[press [Enter] to skip, [P]review, or [Q]uit]: 
	!bat_log! set /p bat_choice=[press [Enter] to skip, [P]review, or [Q]uit]: !bat_choice!

	if /i "!bat_choice!" equ "q" goto :CAL_END
	
	if /i "!bat_choice!" equ "P" (
		echo.
		echo.
		echo.The preview thumbnails will be created and displayed.  Once they
		echo.appear, scroll through the thumbnails and write down a time that
		echo.seems like a clear part of the night for calibration.  Then close
		echo.the thumbnail viewer when you've done that...
		echo.
		echo.Please wait...
		!bat_logexec! call "!bat_exedir!\ftp_thumbnails.exe" "!bat_capturedfilesdir!" 2 17
		
		set bat_thumbnailname=
		set bat_thumbnailfull=
		for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\Thumbnails!bat_camera!_*.bmp" /b /a-d /on`) do (
			set bat_thumbnailname=%%a
			set bat_thumbnailfull=!bat_capturedfilesdir!\%%a
		)
		
		if defined bat_thumbnailfull (
			!bat_echolog! start /w "" "!bat_thumbnailfull!"
			              start /w "" "!bat_thumbnailfull!"
			!bat_echo!
			!bat_echo! Back from Thumbnail Viewer
			!bat_echo!
		) else (
			!bat_echo! ERROR - No Thumbnail file produced.
		)

		start /w wait 3
		for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\Thumbnails*.bmp" /b /a-d /on`) do (
			!bat_logexeclog! del /q !bat_capturedfilesdir!\%%a
		)
		
		goto :CAL_TIMESTAMP
	)

	if defined bat_choice (
		set bat_cal_FF_time=!bat_choice!
		!bat_echolog! call :CALC_CAL_VALUES "!bat_retval1!" "!bat_retval2!" "!bat_choice!" "!bat_retval3!" "!bat_detectcalfile!"
		              call :CALC_CAL_VALUES "!bat_retval1!" "!bat_retval2!" "!bat_choice!" "!bat_retval3!" "!bat_detectcalfile!"
	)

	call :CAL_INSTRUCTIONS
	!bat_echo!


	if defined  bat_cal_FF_time (
		!bat_echo! '     Now, considering the new FF file with a time segment value
		!bat_echo! '     of !bat_choice!, you will want to enter the following values:
		!bat_echo! '        FOV = !bat_cal.fov!
		!bat_echo! '        RA  = !bat_ranew:~0,-4!.!bat_ranew:~-4!
		!bat_echo! '        DEC = !bat_retval2!
		!bat_echo! '
		!bat_echo! '        FF!bat_camera!_!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!_!bat_cal_FF_time!...
		!bat_echo! '

				echo     Then, considering the new FF file with a time segment value>>"!bat_cal_instructionfile!"
				echo     of !bat_choice!, you will want to enter the following values:>>"!bat_cal_instructionfile!"
				echo        FOV = !bat_cal.fov!>>"!bat_cal_instructionfile!"
				echo        RA  = !bat_ranew:~0,-4!.!bat_ranew:~-4!>>"!bat_cal_instructionfile!"
				echo        DEC = !bat_retval2!>>"!bat_cal_instructionfile!"
				echo.>>"!bat_cal_instructionfile!"
				echo     FF!bat_camera!_!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!_!bat_cal_FF_time!...>>"!bat_cal_instructionfile!"
				echo.>>"!bat_cal_instructionfile!"
	)
	goto :CAL04

:CAL02
	!bat_log! :CAL02
	!bat_echo!
	CALL :CAL_INSTRUCTIONS
	goto :CAL04

:CAL04
	!bat_log! :CAL04
	!bat_logexeclog! copy /y "!windir!\system32\cmd.exe" "!bat_exedir!\cmd_meteorcal_instructions.exe"
	!bat_log! start "FTP_MeteorCal.exe Instructions" "!bat_exedir!\cmd_meteorcal_instructions.exe" /t:f0 /k "type "!bat_cal_instructionfile!""
	          start "FTP_MeteorCal.exe Instructions" "!bat_exedir!\cmd_meteorcal_instructions.exe" /t:f0 /k "type "!bat_cal_instructionfile!""
	!bat_echo!
	!bat_echo!
	!bat_echo! Move the instructions window to a location where you can use it as a reference.
	set bat_choice=
	          set /p bat_choice=Press Enter to continue or [Q]uit: 
	!bat_log! set /p bat_choice=Press Enter to continue or [Q]uit: !bat_choice!
	if /i "!bat_choice!" equ "q" goto :CAL_END

	!bat_echolog! call "!bat_exedir!\FTP_MeteorCal.exe" !bat_camera! "!bat_caldir!"
	              call "!bat_exedir!\FTP_MeteorCal.exe" !bat_camera! "!bat_caldir!"
	rem set bat_returncode=!errorlevel!
	
	!bat_echolog!
	
	set bat_manualcalfile=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_caldir!\CAL!bat_camera!_*.txt" /b /a-d /on`) do (
		set bat_temp=%%a
		set bat_caldate=!bat_temp:~7,8!
		set bat_caltime=!bat_temp:~16,10!
		set bat_caldatetime=!bat_temp:~7,18!

		set bat_tempCapturedDate=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

		if "!bat_caldate!" LEQ "!bat_tempCapturedDate!" (
			set bat_manualcalfile=!bat_caldir!\%%~a
		)
	)

	!bat_echo!
	!bat_echo!
	set bat_choice=
	!bat_logexeclog! call process.exe -k "cmd_meteorcal_instructions.exe"
	!bat_logexeclog! del /q "!bat_exedir!\cmd_meteorcal_instructions.exe"


:CAL05
	if /i "!bat_prevcalfile!" neq "!bat_manualcalfile!" (
		call :CAL_SUCCESS
	) else (
		set bat_recent_error_msg=ERROR - 7d. The calibration failed - "!bat_prevcalfile!"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog! '    We're assuming this is in error because this routine generated a cal file that 
		!bat_echolog! '    is the same name as the previous cal file or that it did not generate a cal
		!bat_echolog! '    file at all.
		!bat_echolog!
		!bat_echolog! '    This can be a valid outcome if you chose the same FF file as a previous 
		!bat_echolog! '    calibration attempt.  If you believe that this attempt generated a 
		!bat_echolog! '    better outcome, then...
		set bat_choice=
		          set /P bat_choice=Press [Enter] to continue, or [Q]uit: 
		!bat_log! set /P bat_choice=Press [Enter] to continue, or [Q]uit: !bat_choice!
		if not defined bat_choice (
			set bat_prevcalfile=!bat_prevcalfile!
			!bat_echolog!
			call :CAL_SUCCESS
			goto :CAL_END
		)
		if /i "!bat_choice!" equ "q" goto :CAL_END
		
		goto :CAL_END
	)
	
	!bat_echolog!

:CAL_END
	!bat_logexec! set bat_camera=!bat_cal.camera.save!
!bat_poplog! [RETURN !bat_batchfile!:CAL] [before:!bat_prevcalfile!, after:!bat_manualcalfile!]
	if exist "!bat_cal_instructionfile!" (del /q "!bat_cal_instructionfile!")
!bat_log!
!bat_return!


:CAL_INSTRUCTIONS
!bat_pushlog! [CALL !bat_batchfile!:CAL_INSTRUCTIONS] %*
	echo.
	echo     In the MeteorCal program:
	echo       - Press ESC to re-enter FOV, RA, and DEC at any time during star matching
	echo       - Do the manual star matching from right to left
	echo       - Press Enter after each match
	echo       - Press F and B to skip forward or backward
	echo       - When you have matched about 80 or more stars, press "C"
	echo       - Then press "1" to discard outliers until the star count gets 
	echo         between 50 and 60.  
	echo       - Finally, press Ctrl+P to complete the calibration and return to the menu.
	echo.
			echo.>>"!bat_cal_instructionfile!"
			echo     When the File chooser dialog appears, navigate to and select an FF file >>"!bat_cal_instructionfile!"
			echo     named something like this: >>"!bat_cal_instructionfile!"
			echo        FF!bat_camera!_!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!_!bat_cal_FF_time!...>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			echo     After that, you will be asked for the FOV, RA, and DEC of the >>"!bat_cal_instructionfile!"
			echo     new FF file.  >>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			echo     In the MeteorCal program:>>"!bat_cal_instructionfile!"
			echo       - Press ESC to re-enter FOV, RA, and DEC at any time during star matching>>"!bat_cal_instructionfile!"
			echo       - Do the manual star matching from left to right>>"!bat_cal_instructionfile!"
			echo       - Press Enter after each match>>"!bat_cal_instructionfile!"
			echo       - Press F and B to skip forward or backward [ordered by brightness]>>"!bat_cal_instructionfile!"
			echo       - When you have matched about 80 or more stars, press "C">>"!bat_cal_instructionfile!"
			echo       - Then press "1" to discard outliers until the star count gets >>"!bat_cal_instructionfile!"
			echo         between 50 and 60.  >>"!bat_cal_instructionfile!"
			echo       - Finally, press Ctrl+P to complete the calibration and return to the menu.>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			echo   If the calibration is successful...>>"!bat_cal_instructionfile!"
			echo     Next steps are:>>"!bat_cal_instructionfile!"
			echo       1^) Run AutoCams option "7b. Auto Calibration Update" to fine tune this manual calibration>>"!bat_cal_instructionfile!"
			echo       2^) Run AutoCams option "9. Apply Cal to Archived" once you have a good calibration>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
:CAL_INSTRUCTIONS_END
!bat_poplog! [RETURN !bat_batchfile!:CAL_INSTRUCTIONS] ["!bat_cal_instructionfile!"]
!bat_return!



:CALC_CAL_VALUES
!bat_pushlog! [CALL !bat_batchfile!:CALC_CAL_VALUES] %*
	set bat_calra=%~1
	set bat_caldec=%~2
	set bat_choice=%~3
	set bat_time=%~4
	set bat_CCV_filefull=%~5
	set bat_CCV_file=%~n5
	set bat_CCV_yy=!bat_CCV_file:~7,4!
	set bat_CCV_mm=!bat_CCV_file:~11,2!
	set bat_CCV_dd=!bat_CCV_file:~13,2!
	
	set bat_CCV_capyy=!bat_captureddate:~0,4!
	set bat_CCV_capmm=!bat_captureddate:~5,2!
	set bat_CCV_capdd=!bat_captureddate:~8,2!

	rem get the julian cal date and captured date
	call :date2jdate bat_CCV_jd_detcal %bat_CCV_yy% %bat_CCV_mm% %bat_CCV_dd%
	call :date2jdate bat_CCV_jd_cap %bat_CCV_capyy% %bat_CCV_capmm% %bat_CCV_capdd%

	rem Calculate the new RA offset by subtracting the cal date from the captured date
	rem and 
	set /a "bat_CCV_ra_offset=(bat_CCV_jd_cap - bat_CCV_jd_detcal)*3650000/360"


	rem calculate the ENTERED TIME in hours [outputs to the provided variables]
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~0,2! bat_hh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~2,2!00 bat_mm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~4,2!00 bat_ss

	!bat_log! set /a "bat_hour=((!bat_ss! / 60) + !bat_mm!) / 60) + !bat_hh!00"
	          set /a "bat_mmdecimal=((!bat_ss! / 60) + !bat_mm!) / 60"
	set /a bat_hour=!bat_hh!00 + !bat_mmdecimal!
	set bat_hourdisplay=!bat_hh!.!bat_mmdecimal!


	rem calculate the OLD CAL FILE TIME in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~0,2! bat_timehh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~3,2!00 bat_timemm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~6,2!00 bat_timess

	set /a "bat_timemmdecimal=((!bat_timess! / 60) + !bat_timemm!) / 60"
	set /a bat_timetotal=!bat_timehh!00+!bat_timemmdecimal!
	set bat_timemmdecimal=!bat_timemmdecimal!0000
	set bat_timemmdecimal=!bat_timemmdecimal:~0,4!
	set bat_timetotal=!bat_timehh!!bat_timemmdecimal!

	set /a bat_timediff=!bat_hour!00 - !bat_timetotal!
	set /a "bat_diffdegrees=(bat_timediff * 15)"
	rem echo       bat_diffdegrees=!bat_diffdegrees!
	rem echo       bat_CCV_RA_offset=!bat_CCV_RA_offset!
	set /a "bat_diffdegrees=bat_diffdegrees+bat_CCV_RA_offset


	rem Caluclate the new RA value based on the difference in hours
	set bat_temp2=
	call "!bat_exedir!\STRIPZEROS.bat" !bat_calra! bat_calra
	for /f "usebackq tokens=1,2 delims=." %%a in ('!bat_calra!') do (
		set bat_radeg=%%a
		set bat_radegdecimal=%%b

		set bat_temp2=!bat_radegdecimal!0000
		set bat_temp2=!bat_temp2:~0,4!
		set bat_ratotal=!bat_radeg!!bat_temp2!

		set /a bat_ranew=!bat_ratotal! + !bat_diffdegrees!
		if !bat_ranew! GEQ 3600000 (
			set /a "bat_ranew=!bat_ranew! - 3600000"
		)
	)
	
	call :CAL_GETFOV  "!bat_detectcalfile!"
	call :CAL_GETAZ   "!bat_detectcalfile!"
	call :CAL_GETALT  "!bat_detectcalfile!"

	!bat_log!
	!bat_log! '     Data from current calibration file: !bat_detectcalfile!
	!bat_log! '        time=!bat_time!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!
	!bat_log! '        RA  =!bat_retval1!, !bat_ratotal!
	!bat_log! '        DEC =!bat_retval2!
	!bat_log! '        AZ  =!bat_cal.az!
	!bat_log! '        ALT =!bat_cal.alt! 
	!bat_log!
	rem echo     bat_timediff=!bat_timediff!
	rem echo     bat_diffdegrees=!bat_diffdegrees!
	rem echo.
	call "str_math.bat" !bat_timediff! / 100
	set bat_timediff_decimal=!bat_retval!
	call "str_math.bat" !bat_diffdegrees! / 100
	set bat_diffdegrees_decimal=!bat_retval!
	!bat_log! '     Data from the FF file based on the entered time segment: !bat_choice!
	!bat_log! '        time=!bat_hour:~0,-2!.!bat_hour:~-2!   time difference: !bat_timediff_decimal!  degrees: !bat_diffdegrees_decimal!
	!bat_log! '        RA  =!bat_ranew:~0,-4!.!bat_ranew:~-4!
	!bat_log! '        DEC =!bat_caldec!
	!bat_log!
	!bat_log! '     When the File chooser dialog appears, navigate to and select an FF file 
	!bat_log! '     named something like this: 
	!bat_log! '        FF!bat_camera!_!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!_!bat_cal_FF_time!...

			echo.>>"!bat_cal_instructionfile!"
			echo     Data from current calibration file: !bat_detectcalfile!>>"!bat_cal_instructionfile!"
			echo        time=!bat_time!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!>>"!bat_cal_instructionfile!"
			echo        RA  =!bat_retval1!, !bat_ratotal!>>"!bat_cal_instructionfile!"
			echo        DEC =!bat_caldec!>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"

		
:CALC_CAL_VALUES_END
!bat_poplog! [RETURN !bat_batchfile!:CALC_CAL_VALUES] [in=%*] [!bat_timetotal!, !bat_hour!, !bat_ranew!, !bat_diffdegrees!]
!bat_log!
!bat_return!


:CAL_SUCCESS
	!bat_echolog!
	!bat_echolog! '   SUCCESS
	!bat_echolog! '   Be sure to write down the date/time of the FF file used for calibration. 
	!bat_echolog!
	!bat_echolog! '    call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!"
	call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!"

	!bat_echolog!
	!bat_echolog!
	!bat_echolog! '    Next steps are:
	!bat_echolog! '      1^) Run AutoCams option "7b. Auto Calibration Update" to fine tune this manual calibration
	!bat_echolog! '      2^) Run AutoCams option "9. Apply Cal to Archived" once you have a good calibration
	!bat_echolog!
	!bat_echolog!
	pause
	call :CREATECALFILELIST "!bat_detectfile!"
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
	set bat_recent_error_msg=SUCCESS - 7d. "!bat_manualcalfile!"
	set bat_retval=success


!bat_return!

:CAL_GETFOV
!bat_pushlog! [CALL !bat_batchfile!:CAL_GETFOV] %*
	set bat_cal.file=%~1
	set bat_cal.fov=
	if exist "!bat_cal.file!" (
		for /f "usebackq tokens=1-8 skip=2" %%a in (`find /i "fov dimension" "!bat_cal.file!"`) do (
			set bat_cal.fov=%%h
		)
	)
:CAL_GETFOV_END
!bat_poplog! [RETURN !bat_batchfile!:CAL_GETFOV] [!bat_cal.fov!]
!bat_return!

:CAL_GETAZ [in] calfile
!bat_pushlog! [CALL !bat_batchfile!:CALL_GETAZ] %*
	set bat_cal.file=%~1
	set bat_cal.az=
	if exist "!bat_cal.file!" (
		for /f "usebackq tokens=1-8 skip=2" %%a in (`find /i "Cal center Azim " "!bat_cal.file!"`) do (
			set bat_cal.az=%%f
		)
	)
:CAL_GETAZ_END
!bat_poplog! [RETURN !bat_batchfile!:CAL_GETAZ] [!bat_cal.az!]
!bat_return!


:CAL_GETALT [in] calfile
!bat_pushlog! [CALL !bat_batchfile!:CALL_GETALT] %*
	set bat_cal.file=%~1
	set bat_cal.alt=
	if exist "!bat_cal.file!" (
		for /f "usebackq tokens=1-8 skip=2" %%a in (`find /i "Cal center Elev " "!bat_cal.file!"`) do (
			set bat_cal.alt=%%f
		)
	)

:CAL_GETALT_END
!bat_poplog! [RETURN !bat_batchfile!:CAL_GETALT] [!bat_cal.alt!]
!bat_return!





:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=!MM:~-2!
	set DD=!DD:~-2!
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0











	rem 9. Apply cal to detectinfo *******************************
:APPLY
!bat_pushlog! [CALL !bat_batchfile!:APPLY] %*

	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echo!
		          set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=You probably don't want to do this - you have already run Submission: !bat_choice!
		goto :APPLY_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_echo!
		          set /p bat_choice=You need to Choose ArchivedFiles first: 
		!bat_log! set /p bat_choice=You need to Choose ArchivedFiles first: !bat_choice!
		goto :APPLY_END
	)
	
	set bat_temp=!bat_detectfile!
	if not exist "!bat_temp!" (
		set bat_recent_error_msg=9.APPLY - Not exist: "!bat_temp!"
		goto :APPLY_END
	)
	
	!bat_echolog! call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	              call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	set bat_returncode=!errorlevel!
	!bat_echolog! !bat_batchfile!:APPLY bat_returncode=!bat_returncode!
	
	if /i "!bat_returncode!" equ "9" (
		!bat_echolog! !bat_batchfile!:APPLY bat_returncode=!bat_returncode!
		!bat_echolog! Manually aborting apply...
		goto :APPLY_END
	)


		rem Sets the bat_latestcal variable to the newest Cal file in the Cal dir
		rem that is the same or newer than the captured date.  This is later compared 
		rem with the date of the file currently being used in the detect file
		rem [which we call 'bat_detectcal']. 
	call :GETLATESTCAL

	set bat_detectcal=
	!bat_pushecho! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_temp!"`^) do...
	for                /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_temp!"`) do (
		if not defined bat_detectcal (
			set bat_temp1=%%a
			if /i "!bat_temp1:~3,3!" equ "!bat_camera!" (
				set bat_detectcal=%%a
				!bat_echolog!
				!bat_echolog! '   Reading the current "!bat_temp!" file and scanning for the cal
				!bat_echolog! '   file now in use...
				!bat_echolog! '      "!bat_detectcal!"
				!bat_echolog!
				set bat_recent_error_msg=9.APPLY "!bat_detectcal!"
			)
		)
	)

	!bat_echolog!
	!bat_echolog! '    Cal file in "!bat_temp!" is:
	!bat_echolog! '        "!bat_detectcal!"
	!bat_echolog!

	if defined bat_latestcal (
		set bat_recent_error_msg=SUCCESS - 9.APPLY - "!bat_detectcal!"  in  "!bat_detectfile2!". Latest cal is "!bat_latestcal!".
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=0
		set bat_retval=success
		
		call :CREATECALFILELIST "!bat_detectfile!"
		call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
		call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"

	) else (
		set bat_recent_error_msg=ERROR - 9.APPLY [%*] failed to determine latest cal file.
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYAUTOEND
	)


	!bat_popecho!


:APPLY_END
!bat_poplog! [RETURN !bat_batchfile!:APPLY] [bat_returncode=!bat_returncode!, !bat_recent_error_msg!]
	if not defined bat_autonomous (pause)
!bat_log!
!bat_return!





	rem 9.a. Apply cal to detectinfo *******************************
:APPLYAUTO
!bat_pushlog! [CALL !bat_batchfile!:APPLYAUTO] %*
	set bat_retval=failed
	set bat_returncode=0
	set bat_latestcal=
	set bat_detectcal=

	set bat_recent_error_msg=FAILED - 9.a.APPLYAUTO - "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!

	if "!bat_archivedmeteorcount!" equ "0" (
		set bat_recent_error_msg=ERROR - 9.a.APPLYAUTO [%*] failed. Meteor Count is 0. Nothing to calibrate.
		!bat_log! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYAUTO_END
	)

	set bat_temp=!bat_detectfile!
	if not exist "!bat_temp!" (
		set bat_returncode=1
		set bat_recent_error_msg=9.APPLY - ERROR - Not exist: "!bat_temp!"
		goto :APPLYAUTO_END
	)

	!bat_echolog! call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
				  call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
	set bat_returncode=!errorlevel!
	!bat_echolog! !bat_batchfile!:APPLYAUTO bat_returncode=!bat_returncode!

	!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]

	if /i "!bat_returncode!" equ "9" (
		!bat_echolog! !bat_batchfile!:APPLY bat_returncode=!bat_returncode!
		!bat_echolog! Manually aborting apply...
		goto :APPLYAUTO_END
	)


	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=ERROR failed - 9.a.APPLYAUTO "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
		!bat_echolog! '    !bat_recent_error_msg!
		goto :APPLYAUTO_END
	)

	set bat_temp=!bat_detectfile!
	if not exist "!bat_temp!" (
		set bat_returncode=1
		goto :APPLYAUTO_END
	)

		rem Sets the bat_latestcal variable to the newest Cal file in the Cal dir
		rem that is the same or newer than the captured date.  This is later compared 
		rem with the date of the file currently being used in the detect file
		rem [which we call 'bat_detectcal']. 
	call :GETLATESTCAL

	set bat_detectcal=
	!bat_pushecho! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_temp!"`^) do...
	for                /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_temp!"`) do (
		if not defined bat_detectcal (
			set bat_temp=%%a
			if /i "!bat_temp:~3,3!" equ "!bat_camera!" (
				set bat_detectcal=%%a
				!bat_echolog!
				!bat_echolog! '   Reading the current "!bat_temp!" file and scanning for the cal
				!bat_echolog! '   file now in use...
				!bat_echolog! '      "!bat_detectcal!"
				!bat_echolog!
				set bat_recent_error_msg=9.a.APPLYAUTO "!bat_detectcal!"
			)
		)
	)

	!bat_echolog!
	!bat_echolog! '    Cal file in "!bat_temp!" is:
	!bat_echolog! '        "!bat_detectcal!"
	!bat_echolog!

	if defined bat_latestcal (
		set bat_recent_error_msg=SUCCESS - 9.a.APPLYAUTO - "!bat_detectcal!"  in  "!bat_detectfile2!". Latest cal is "!bat_latestcal!".
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=0
		set bat_retval=success
		
		call :CREATECALFILELIST "!bat_detectfile!"
		call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
		call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"

	) else (
		set bat_recent_error_msg=ERROR - 9.a.APPLYAUTO [%*] failed to determine latest cal file.
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYAUTOEND
	)
	
	!bat_popecho!

:APPLYAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:APPLYAUTO] [!bat_retval!, bat_returncode=!bat_returncode!, bat_detectcal=!bat_detectcal!, bat_latestcal=!bat_latestcal!, !bat_recent_error_msg=!]
!bat_log!
!bat_return!




:WAITFORMULTISCAN
!bat_pushlog! [CALL !bat_batchfile!:WAITFORMULTISCAN] %*
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`) do (
		!bat_echolog! Waiting for FTP_Reprocess to release the file: "!bat_archivedfilesdir!\%%a"
		!bat_logexec! call WaitForFile rw "!bat_archivedfilesdir!\%%a"
	)
	!bat_poplog!

:WAITFORMULTISCAN_END
!bat_poplog! [RETURN !bat_batchfile!:WAITFORMULTISCAN] []
!bat_log!
!bat_return!





	rem 10. Confirmation ***********************************************
:CONFIRM
!bat_pushlog! [CALL !bat_batchfile!:CONFIRM] %*

%BAT_COMMENT_BEGIN%
	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echo!
		!bat_echo! You probably don't want to do this - you have already run Confirm and Submit.  
		!bat_echo! Choose "Undo submission" if you need to perform confirmation. 
		          set /p bat_choice=.!bat_pushstring!Press [enter] to go back to the menu. 
		!bat_log! set /p bat_choice=.!bat_pushstring!Press [enter] to go back to the menu. !bat_choice!
		goto :CONFIRM_END
	)
%BAT_COMMENT_END%

	set bat_confirmdetect=!bat_detectfile2!
	if not exist "!bat_detectfile!" (
		!bat_echolog! '    ERROR - Not exist: "!bat_detectfile!"
		goto :CONFIRM_END
	)

:CONFIRM2
	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_echo!
		          set /p bat_choice=.!bat_pushstring!You need to Choose ArchivedFiles first: 
		!bat_log! set /p bat_choice=.!bat_pushstring!You need to Choose ArchivedFiles first: !bat_choice!
		goto :CONFIRM_END
	)
	
	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"

	call :EDITCOMMENTS

	!bat_logexeclog! call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"
	!bat_echolog!
	
	!bat_echolog! If asked to "Navigate to FTP Detection File to Process 
	!bat_echolog! for Coincidence", navigate to and select instead:
	!bat_echolog!   "!bat_detectfile!". 
	!bat_echolog!

	!bat_echolog! start /w !bat_exedir!\FTP_Confirmation.exe "!bat_detectfile!"
	              start /w !bat_exedir!\FTP_Confirmation.exe "!bat_detectfile!"

:CONFIRM3

	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"

    call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"

	!bat_logexeclog! call "!bat_exedir!\FixDetectPaths.bat" "!bat_confirmedfilesdir!" "!bat_detectfileconf!"

	call :SAVECONFIG

	if "!bat_submissionfilesdir!" neq "" (
		set bat_detectfileconf_name=!bat_detectfileconf:~0,-4!
		!bat_logexeclog! copy /y "!bat_detectfileconf!" "!bat_submissionfilesdir!\!bat_camera!\EmailFiles\!bat_detectfile3!_confirmed.txt"
		!bat_logexeclog! copy /y "!bat_confirmedfilesdir!\comments_!bat_camera!.txt" "!bat_submissionfilesdir!\!bat_camera!\EmailFiles"
	)

	!bat_pushecho! if exist "!bat_confirmedfilesdir!\RadiantAssoc.txt" ^(
	if exist "!bat_confirmedfilesdir!\RadiantAssoc.txt" (
		echo.  Total   !bat_confirmedmeteorcount!>>"!bat_confirmedfilesdir!\RadiantAssoc.txt"
		
		!bat_logexec! move /y    "!bat_confirmedfilesdir!\RadiantAssoc.txt" "!bat_confirmedfilesdir!\RadiantAssoc_!bat_camera_list!_!bat_captureddate!_!bat_capturedtime!.txt"
		!bat_logexec! type "!bat_confirmedfilesdir!\RadiantAssoc_!bat_camera_list!_!bat_captureddate!_!bat_capturedtime!.txt"
	)
	!bat_popecho! ^)

	set bat_recent_error_msg=10. Confirmation 

		!bat_echolog!
		!bat_echolog!  Total Confirmed:   !bat_confirmedmeteorcount!
		!bat_echolog!

	!bat_echolog! CALL "!bat_exedir!\thumbnails.bat" /confirmeddir="!bat_confirmedfilesdir!" skip=1 /factor=7 /delete=no /interactive=no
	              CALL "!bat_exedir!\thumbnails.bat" /confirmeddir="!bat_confirmedfilesdir!" skip=1 /factor=7 /delete=no /interactive=no
	set bat_returncode=!errorlevel!
	if !bat_returncode! neq 0 (
		goto :CONFIRM_END
	)


	set bat_recent_error_msg=10. Confirmation 


:CONFIRM_END
!bat_popecho! [RETURN !bat_batchfile!:CONFIRM] [bat_returncode=!bat_returncode!] [!bat_confirmedmeteorcount!, !bat_recent_error_msg!]
!bat_log!
	if not defined bat_autonomous (
		pause
	)
!bat_return!





:GETCONFIRMEDCOUNT
!bat_pushlog! [CALL !bat_batchfile!:GETCONFIRMEDCOUNT] %*
	set bat_confirmedmeteorcount=0
	set bat_confirmedcal=
	set bat_confirmedetect=
	set bat_detectfileconf=

	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_log! '    bat_archivedfilesdir=blank
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	!bat_log! '    bat_confirmedfilesdir="!bat_confirmedfilesdir!"
	if /i "!bat_confirmedfilesdir!" equ "" (
		!bat_log! '    bat_confirmedfilesdir=blank
		goto :GETCONFIRMEDCOUNT_END
	)

	call :FINDDETECT "bat_detectfileconf" "bat_confirmedfilesdir"
	!bat_log! '    bat_detectfileconf=!bat_detectfileconf!
	
	
	if not exist "!bat_detectfileconf!" (
		!bat_log! '    Detect file not found in: "!bat_confirmedfilesdir!"
		set /a bat_confirmedmeteorcount=0
		goto :GETCONFIRMEDCOUNT_END
	)
	
	if /i "!bat_detectfileconf!" equ "!bat_confirmedfilesdir!\" (
		!bat_log! '    Blank detect file: !bat_detectfileconf!
		!bat_log! '    No detect file found...
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_pushlog! '    for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_detectfileconf!"`^) do ...
	for                    /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_detectfileconf!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_tempcal=%%a
		if /i "!bat_tempcal:~3,3!" equ "!bat_camera!" (
			set bat_confirmedcal=%%a
		)
	)
	!bat_poplog!

	set bat_confirmeddetect=!bat_detectfileconf!
	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_poplog! [RETURN !bat_batchfile!:GETCONFIRMEDCOUNT] [bat_confirmedmeteorcount=!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, !bat_confirmedfilesdir!\!bat_confirmdetect!]
set bat_tempcal=
!bat_log!
!bat_return!




	rem 11. Edit comments.txt file *****************************************
:EDITCOMMENTS
!bat_pushlog! [CALL !bat_batchfile!:EDITCOMMENTS] %*
	if not defined bat_archivedfilesdir (
		!bat_echolog! '    ERROR - Not defined: bat_archivedfilesdir - ["!bat_archivedfilesdir!"]
		pause
		goto :EDITCOMMENTS_END
	)
	
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	
	if not exist "!bat_confirmedfilesdir!" (
		!bat_logexeclog! md "!bat_confirmedfilesdir!"
	)

	!bat_echolog! start notepad.exe "!bat_confirmedfilesdir!\comments_!bat_camera!.txt"
	              start notepad.exe "!bat_confirmedfilesdir!\comments_!bat_camera!.txt"

	if defined bat_submissionfilesdir (
		!bat_logexeclog! copy /y "!bat_confirmedfilesdir!\comments_!bat_camera!.txt" "!bat_submissionfilesdir!\!bat_camera!\EmailFiles"
	)

:EDITCOMMENTS_END
!bat_poplog! [RETURN !bat_batchfile!:EDITCOMMENTS] ["!bat_confirmedfilesdir!\comments_!bat_camera!.txt"]
!bat_log!
!bat_return!






	rem 12. Apply cal to ConfirmedFiles *************************************
:APPLYCONFIRMED
!pushlog! [CALL !bat_batchfile!:APPLYCONFIRMED] %*
	set bat_retval=failed
	set bat_returncode=0
	set bat_latestconfcal=

	set bat_recent_error_msg=12.APPLYAUTO - "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog! '    ERROR - 12.Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		set bat_returncode=1
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		!bat_echolog!
		!bat_echolog! '    ERROR - 12.You need to Choose ArchivedFiles first:
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)
	
	!bat_log! bat_archivedfilesdir="!bat_archivedfilesdir!"
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	!bat_log! bat_confirmedfilesdir="!bat_confirmedfilesdir!"

	rem set bat_temp=!bat_detectfile2!
	if not exist "!bat_confirmedfilesdir!\!bat_temp!" (
		rem
	)
		

	if "!bat_confirmedmeteorcount!" equ "0" (
		set bat_recent_error_msg=NOTE - 12.Confirmed Meteor Count is 0. Nothing to calibrate.
		!bat_log! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYCONFIRMED_END
	) else (
		!bat_log! call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
		         call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
		set bat_returncode=!errorlevel!

		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			set bat_recent_error_msg=ERROR - 12.APPLYCONFIRMED "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous! failed
			!bat_echolog! '    !bat_recent_error_msg!
			goto :APPLYAUTO_END
		)

		!bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\!bat_temp!"`^) do ...
		for               /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_temp!"`) do (
			if not defined bat_latestconfcal (
				set bat_latestconfcal=%%a
			)
		)
		!bat_popecho!
	)


	!bat_echolog!
	!bat_echolog! '    Cal file in "!bat_confirmedfilesdir!\!bat_temp!":
	!bat_echolog! '    "!bat_latestconfcal!"
	!bat_echolog!
	if defined bat_latestconfcal (
		set bat_recent_error_msg=SUCCESS - 12a. Applied "!bat_latestconfcal!" to "!bat_confirmedfilesdir!\!bat_temp!"
		set bat_returncode=0
		set bat_retval=success
	) else (
		set bat_recent_error_msg=ERROR - 12a.APPLYCONFIRMED unable to define the confirmed calfile.
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYCONFIRMED_END
	)

	
:APPLYCONFIRMED_END
!poplog! [RETURN !bat_batchfile!:APPLYCONFIRMED] [!bat_retval!, !bat_returncode!, "!bat_latestcal!", !bat_recent_error_msg!]
	if not defined bat_autonomous (pause)
!bat_log!
!bat_return!




	rem 13. Submission ********************************************
	rem 13. StageFromConfirmed.bat ********************************
:SUBMIT
!bat_pushlog! [CALL !bat_batchfile!:SUBMIT] %*
	set bat_returncode=0

	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog!
		          set /p bat_choice=Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		!bat_log! set /p bat_choice=Not supported from SubmissionFiles. Use "Undo Submission" if necessary: !bat_choice!
		goto :SUBMIT_END
	)
	
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :SUBMIT
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_echolog!
		          set /p bat_choice=You need to Choose ArchivedFiles first: 
		!bat_log! set /p bat_choice=You need to Choose ArchivedFiles first: !bat_choice!
		goto :SUBMIT_END
	)

	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		!bat_echolog!
		!bat_echolog! '    ERROR - 13. "!bat_archivedfilesdir!" is missing dir name
		          set /p bat_choice=Press Enter to quit  
		!bat_log! set /p bat_choice=Press Enter to quit  !bat_choice!
		goto :SUBMIT_END
	)

	if not exist "!bat_confirmedfilesdir!" (
		!bat_echolog! '     WARNING - ConfirmedFiles does not exist ["!bat_confirmedfilesdir!"]
	)


	if /i "!bat_camera!" neq "!bat_camera_list" (
		set bat_camera_temp=!bat_camera_list!
	) else (
		set bat_camera_temp=!bat_camera!
	)

	set bat_camera_temp=!bat_camera!
	!bat_echolog! ' call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera_temp!
	                call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera_temp!
	set bat_returncode=!errorlevel!
	!bat_echolog! '    bat_returncode=!bat_returncode! [from StageFromConfirmed.bat]


	set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	!bat_pushlog! ' for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!_!bat_capturedtime!*" /b /ad`^) do ...
	for                 /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!_!bat_capturedtime!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
					set bat_capturedtime=!bat_capdirname:~-8!
					set bat_captureddatetime=!bat_capdirname!
					set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
					
					!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
							  call "!bat_exedir!\RedirectLogs.bat" "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
				)
			)
		)
	)
	!bat_popecho!
	
	
	!bat_pushlog! ' for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_archdirname!*" /b /ad`^) do ...
	for                 /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_archdirname!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
					set bat_archivedtime=!bat_archdirname:~11,8!
				)
			)
		)
	)
	!bat_popecho!

	call :FINDDETECT "bat_detectfile" "bat_archivedfilesdir"

	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	rem call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	call :GETCAMERAFROMCAPTURED
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount  "!bat_archivedfilesdir!"
	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"
:SUBMIT_END
	if /i !bat_returncode! neq 0 (
		set bat_recent_error_msg=ERROR - FAILED.2 - 13. StageFromConfirmed.bat "!bat_archivedfilesdir!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_recent_error_msg=SUCCESS - 13. StageFromConfirmed.bat "!bat_archivedfilesdir!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)

:SUBMIT_END
!bat_poplog! [RETURN !bat_batchfile!:SUBMIT] [!bat_returncode!, !bat_submissionfilesdir!]
	pause
!bat_log!
!bat_return!




	rem 13a. Submission ********************************************
	rem 13a. StageFromConfirmed.bat ********************************
:SUBMITAUTO
!bat_pushlog! [CALL !bat_batchfile!:SUBMITAUTO] %*
	set bat_returncode=0

	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		set bat_returncode=1
		set bat_recent_error_msg=ERROR - 13a. "!bat_archivedfilesdir!" is missing dir name
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :SUBMITAUTO_END
	)
	

	!bat_echolog! call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
	              call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
	set bat_returncode=!errorlevel!
	!bat_echolog! '    errorlevel=[!bat_returncode!]
	if /i "!bat_returncode!" neq "0" (
		set bat_recent_error_msg=ERROR - 13a. Failed: call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
		!bat_echolog! '    !bat_recent_error_msg!
		goto :SUBMITAUTO_END
	)
	
	set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	set /a bat_count=0
	!bat_pushlog! ' for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!_!bat_capturedtime!*" /b /ad`^) do ...
	for                 /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!_!bat_capturedtime!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
					set bat_capturedtime=!bat_capdirname:~-8!
					set bat_captureddatetime=!bat_capdirname!
					set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
					
					!bat_log! call "!bat_exedir!\RedirectLogs.bat"  "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
							  call "!bat_exedir!\RedirectLogs.bat"  "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
				)
			)
		)
	)
	!bat_popecho!

	if !bat_count! GEQ 1 (
		!bat_log! call :CHOOSECAP
		          call :CHOOSECAP
	)
	
	set /a bat_count=0
	!bat_pushlog! ' for /f "usebackq tokens=*" ..a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_archdirname!*" /b /ad`^) do ...
	for                 /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_archdirname!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_count+=1
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
					set bat_archivedtime=!bat_archdirname:~11,8!
				)
			)
		)
	)
	!bat_popecho!

	if !bat_count! GEQ 1 (
		!bat_log! call :CHOOSEarch2
		          call :CHOOSEarch2
	)

	!bat_pushecho! Reading the new directories, please wait... [!time!]
		call :FINDDETECT "bat_detectfile" "bat_archivedfilesdir"
		rem call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"

		if defined bat_capturedfilesdir (
			set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
			!bat_echolog! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
						  call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

			call :GETCAMERAFROMCAPTURED
			call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
			if defined bat_detectfile (
				if exist "!bat_detectfile!" (
					if not exist "!bat_archivedfilesdir!\CalFileList.log" (
						call :CREATECALFILELIST "!bat_detectfile!"
					)
					call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
					call :GETCONFIRMEDCOUNT
				)
			)
		)
	!bat_popecho!

:SUBMITAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:SUBMITAUTO] %* [bat_returncode=!bat_returncode!, !bat_submissionfilesdir!\!bat_camera!]
rem exit /b !bat_returncode!
!bat_log!
!bat_return!





	rem 14. Choose SubmissionFiles directory *********************
:CHOOSESUBMISSION
!bat_pushlog! [CALL !bat_batchfile!:CHOOSESUBMISSION] %*
!bat_echolog!

	!bat_echolog! '    bat_captureddate="!bat_captureddate!"
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :CHOOSESUBMISSION
	)

	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=%^ ^|find /i "!bat_captureddate!_!bat_camera!_!bat_capturedtime!"
	)


	set /a bat_counter=0
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on][!bat_finddate!`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					!bat_echo! !bat_counter!. %%a
				)
			)
		)
	)
	!bat_popecho!

	if !bat_counter! equ 0 (
		          set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. 
		!bat_log! set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. !bat_choice!
		goto :CHOOSESUBMISSION_END
	)

	set bat_choice=
	          set /P bat_choice=Select the SubmissionFiles directory to work with: 
	!bat_log! set /P bat_choice=Select the SubmissionFiles directory to work with: !bat_choice!
	if "!bat_choice!" equ "" goto :CHOOSESUBMISSION_END

	!bat_echo!
	set /a bat_counter=0
	set bat_found=false
	!bat_echo! Listing of SubmissionFiles:
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\%%a
						set bat_found=true
						set bat_dirname=%%~nxa
						set bat_submissiondirname=%%~nxa
						set bat_Submissiondate=!bat_dirname:~0,10!
					)
				)
			)
		)
	)
	
:CHOOSESUBMISSION1
	!bat_log! '  :CHOOSESUBMISSION1
	if /i !bat_found! equ false goto :CHOOSEARCH
	
	
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
		set bat_capturedtime=!bat_dirname:~-8!
		set bat_captureddatetime=!batZ_dirname!
		
		!bat_log! call "!bat_exedir!\RedirectLogs.bat"  "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
				  call "!bat_exedir!\RedirectLogs.bat"  "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
	)

:CHOOSESUBMISSION2
	!bat_log! :CHOOSESUBMISSION2
	!!bat_pushlog! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`^) do ...
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
					set bat_capturedtime=!bat_capdirname:~-8!
					set bat_captureddatetime=!bat_capdirname!
					set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
					
					!bat_log! call "!bat_exedir!\RedirectLogs.bat"  "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
							  call "!bat_exedir!\RedirectLogs.bat"  "!bat_logdir!" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!"
				)
			)
		)
	)
	!bat_poplog!
	rem  bat_capturedcount "!bat_capturedfilesdir!"
	call :GETCAMERAFROMCAPTURED 
	
	
	!!bat_pushlog! for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`^) do ...
	for                /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
					set bat_archivedtime=!bat_archdirname:~11,8!
				)
			)
		)
	)
	!bat_poplog!

	!bat_pushecho! Reading the new directories, please wait... [!time!]
		call :FINDDETECT "bat_detectfile" "bat_archivedfilesdir"

		if defined bat_capturedfilesdir (
			set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
			!bat_echolog! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
						  call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

			call :GETCAMERAFROMCAPTURED
			call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
			if defined bat_detectfile (
				if exist "!bat_detectfile!" (
					rem if not exist "!bat_archivedfilesdir!\CalFileList.log" (
						call :CREATECALFILELIST "!bat_detectfile!"
					rem )
				)
				call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount "!bat_archivedfilesdir!"
				call :GETCONFIRMEDCOUNT
			)
		)
	!bat_popecho!

	set bat_recent_error_msg=14. [!bat_capturedfilesdir!]
:CHOOSESUBMISSION_END
!bat_poplog! [RETURN !bat_batchfile!:CHOOSESUBMISSION] [!bat_capturedfilesdir!]
pause
!bat_log!
!bat_return!




:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_pushlog! [CALL !bat_batchfile!:GETFILECOUNT] "%~1"  "%~2"
	set /a %~1=0
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
	!bat_pop!

!bat_poplog! [RETURN !bat_batchfile!:GETFILECOUNT] [%~1=!%1!]
!bat_log!
!bat_return!




:GETCAMERAFROMSUBMISSION
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
	!bat_pop!
!bat_log!
!bat_return!



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%~2
	set %~1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
	!bat_echolog! %~1=!%~1!
!bat_log!
!bat_return!




	rem 15. Undo Submission ***************************************
	rem Restore the Archived, Captured, and Confirmed files from 
	rem the SubmissionFiles directory to the basic CAMS subdirs
	rem
	rem This routine's workflow as follows...
	rem  - Move the ..\SubmisionsFiles\..\CapturedFiles\[date/time] to ..\CapturedFiles
	rem  - Remove the ..\SubmissionFiles\..\CapturedFiles dir
	rem
	rem  - Move the ..\SubmisionsFiles\..\ArchivedFiles\[date/time] to ..\ArchivedFiles
	rem  - Remove the ..\SubmissionFiles\..\ArchivedFiles dir
	rem
	rem  - Move the ..\SubmisionsFiles\..\ConfirmedFiles\[date/time] to ..\ConfirmedFiles
	rem  - Remove the ..\SubmissionFiles\..\ConfirmedFiles dir
	rem
	rem  - Move the ..\SubmisionsFiles\..\EmailFiles\Thumbnails???_????????_??????.bmp to ..\ConfirmedFiles
	rem
	rem  - Clear out and remove the ..\SubmissionFiles\..\Cal dir
	rem  - Clear out and remove the ..\SubmissionFiles\..\EmailFiles dir
	rem
	rem  - Copy the zip files for the [date] from the Transmitted dir back to Submitted
	rem
	rem  - Delete the Submitted dir and remove it
	rem
	rem  - 
:RESTORESUBMIT
!bat_pushlog! [CALL !bat_batchfile!:RESTORESUBMIT] [%*]

	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog! Error - SubmissionFiles not set. Use "Package Working dirs into SubmissionFiles dirs" first: 
		          set /p bat_choice=Press Enter to continue 
		!bat_log! set /p bat_choice=Press Enter to continue !bat_choice!
		goto :RESTORESUBMIT_END
	)
	
	if /i "!bat_capturedfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog! ERROR - bat_capturedfilesdir is blank
		          set /p bat_choice=Press Enter to continue 
		!bat_log! set /p bat_choice=Press Enter to continue !bat_choice!
		goto :RESTORESUBMIT_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog! ERROR - bat_archivedfilesdir is blank
		          set /p bat_choice=Press Enter to continue 
		!bat_log! set /p bat_choice=Press Enter to continue !bat_choice!
		goto :RESTORESUBMIT_END
	)

	set bat_temp_cap=!bat_capturedfilesdir!
	set bat_temp_arch1=!bat_archivedfilesdir!
	set bat_temp_conf=!bat_confirmedfilesdir!
	set bat_temp_sub=!bat_submissionfilesdir!
	!bat_logexeclog! set bat_temp

		rem CAPTUREDFILES dir ********************************
	!bat_pushecho!
		call :SEARCHFORDIR "!bat_capturedfilesdir!"
		if defined bat_retval (
			set bat_capturedfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\!bat_retval3!
			set bat_capdirname=!bat_retval3!
			set bat_capbasedir=!bat_retval2!
			set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log

			!bat_logexec! move /y "!bat_retval!" "!bat_targetlocation!\CAMS\CapturedFiles"

		) else (
			!bat_echolog!
			!bat_echolog! '    No CapturedFiles dir found - "!bat_capturedfilesdir!"
			!bat_echolog!
			
			!bat_pause!
			
			set bat_capturedfilesdir=
			set bat_capdirname=
			set bat_GCFC_tempfile=
		)

			rem This section removes the remaining directory if it is still there and
			rem it's empty.  If it is not empty, an error message is displayed instead.
		set bat_temp=!bat_temp_cap!
		!bat_pushecho! if exist "!bat_temp!" ...
		if                exist "!bat_temp!" (
			echo !bat_pushstring!dir "!bat_temp!" 2>&1^|find /i "File Not Found"
			echo !bat_pushstring!dir "!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile!"
			dir "!bat_temp!"2>&1|find /i "File Not Found"
			set bat_returncode=!errorlevel!
			if !bat_returncode! equ 0 (
				!bat_logexeclog! rd /S /Q "!bat_temp!" 
				!bat_logexec! rd /q "!bat_retval2!"
				
			) else (
				!bat_echolog!
				!bat_echolog! '    ERROR - Seems that the dir didn't get completely moved back:
				!bat_echolog! '            The following number of files remain in
				!bat_echolog! '            "!bat_temp!"
				!bat_echolog!
				dir "!bat_temp!" 2>&1|find /i " File(s)"
				dir "!bat_temp!" 2>&1|find /i " File(s)">>!bat_logfile!
			
				!bat_pause!
			
			)
		) else (
			!bat_echolog! '    OK - "!bat_temp!" no longer exists...
			!bat_logexec! rd /q "!bat_retval2!"
		)
		!bat_pop!
	!bat_popecho!

		rem ARCHIVEDFILES DIR ********************************
	!bat_pushecho!
	   call :SEARCHFORDIR "!bat_archivedfilesdir!"
		if defined bat_retval (
			set bat_archivedfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\!bat_retval3!
			set bat_temp_arch2=!bat_retval3!
			set bat_archdirname=!bat_retval3!

			!bat_logexec! move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ArchivedFiles"
		) else (
			!bat_echolog!
			!bat_echolog! '    NO ArchivedFiles dir found. "!bat_archivedfilesdir!"
			!bat_echolog!
			set bat_archivedfilesdir=
			set bat_temp_arch2=
			set bat_archdirname=
		)

		set bat_temp=!bat_temp_arch1!
		if exist "!bat_temp!" (
			echo !bat_pushstring!dir "!bat_temp!" 2>&1^|find /i "File Not Found"
			echo !bat_pushstring!dir "!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile!"
			dir "!bat_temp!"2>&1|find /i "File Not Found"
			set bat_returncode=!errorlevel!

			if !bat_returncode! equ 0 (
				!bat_logexeclog! rd /S /Q "!bat_temp!" 
				!bat_logexec! rd /q "!bat_retval2!"

			) else (
				!bat_echolog!
				!bat_echolog! '    ERROR - Seems that the dir didn't get completely moved back:
				!bat_echolog! '            The following number of files remain in
				!bat_echolog! '            "!bat_temp!"
				!bat_echolog!
				dir "!bat_temp!" 2>&1|find /i " File(s)"
				dir "!bat_temp!" 2>&1|find /i " File(s)">>!bat_logfile!
			
				!bat_pause!
			
			)
		) else (
			!bat_echolog! '    OK - "!bat_temp!" no longer exists...
			!bat_logexec! rd /q "!bat_retval2!"
		)
	!bat_popecho!

		rem CONFIRMEDFILES dir ********************************
	!bat_pushecho!
		call :SEARCHFORDIR "!bat_confirmedfilesdir!"
		if defined bat_retval (
			set bat_confirmedfilesdir=!bat_targetlocation!\CAMS\ConfirmedFiles\!bat_retval3!
			set bat_confdirname=!bat_retval3!	
			!bat_logexec! move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ConfirmedFiles"
		) else (
			!bat_echolog!
			!bat_echolog! '    NOT FOUND - "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles\!bat_captureddate!*"
			!bat_echolog!
			set bat_confirmedfilesdir=
			set bat_confdirname=
		)

		rem set bat_temp=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!\!bat_camera!\ConfirmedFiles
		set bat_temp=!bat_temp_conf!
		if exist "!bat_temp!" (
			echo !bat_pushstring!dir "!bat_temp!" 2>&1^|find /i "File Not Found"
			echo !bat_pushstring!dir "!bat_temp!" 2>&1^|find /i "File Not Found">>"!bat_logfile!"
			dir "!bat_temp!"2>&1|find /i "File Not Found"
			set bat_returncode=!errorlevel!
			echo !bat_returncode!
			if !bat_returncode! equ 0 (
				!bat_logexeclog! rd /S /Q "!bat_temp!" 
				!bat_logexec! rd /q "!bat_retval2!"

			) else (
				!bat_echolog!
				!bat_echolog! '    ERROR - Seems that the dir didn't get completely moved back:
				!bat_echolog! '            The following number of files remain in
				!bat_echolog! '            "!bat_temp!"
				!bat_echolog!
				dir "!bat_temp!" 2>&1|find /i " File(s)"
				dir "!bat_temp!" 2>&1|find /i " File(s)">>!bat_logfile!
			
				!bat_pause!
			
			)
		) else (
			!bat_echolog! '    OK - "!bat_temp!" no longer exists...
			!bat_logexec! rd /q "!bat_retval2!"
		)
		
		rem THUMBNAILS dir ******************************************
		set bat_temp_emailfiles=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!_!bat_camera!_!bat_capturedtime!\!bat_camera!\EmailFiles
		!bat_logexec! move /y "!bat_temp_emailfiles!\Thumbnails???_????????_??????.bmp" "!bat_confirmedfilesdir!"

	!bat_popecho!


	
		rem LOGS dir ******************************************
	!bat_pushecho!
		!bat_echolog! Working on Logs next...
		call :SEARCHFORDIR "!bat_submissionfilesdir!\!bat_camera!\Logs"
		if defined bat_retval (
			if exist "!bat_submissionfilesdir!\!bat_camera!\Logs\*.*" (
		!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_submissionfilesdir!\!bat_camera!\Logs" "!bat_exedir!\Logs\!bat_captureddatetime!"
				  call "!bat_exedir!\RedirectLogs.bat" "!bat_submissionfilesdir!\!bat_camera!\Logs" "!bat_exedir!\Logs\!bat_captureddatetime!"
		!bat_log! call "!bat_exedir!\RedirectLogs.bat" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!" "!bat_exedir!\Logs\!bat_captureddatetime!"
				  call "!bat_exedir!\RedirectLogs.bat" "!bat_submissionfilesdir!\!bat_camera!\Logs\!bat_captureddatetime!" "!bat_exedir!\Logs\!bat_captureddatetime!"

			)
		)
	!bat_popecho!

	
	!bat_pushecho! Deleting SubmissionFiles\EmailFiles...
		if not exist "!bat_temp_cap!" (
			if not exist  "!bat_temp_arch1!" (
				if not exist "!bat_temp_conf!" (
					!bat_logexec! del /q /s "!bat_temp_sub!"
					!bat_logexec! rd /q /s "!bat_temp_sub!"

					!bat_logexec! del /q /s "!bat_temp_sub!\!bat_camera!\EmailFiles"
					!bat_logexec! rd /q /s "!bat_temp_sub!\!bat_camera!\EmailFiles"

					!bat_logexec! del /q /s "!bat_temp_sub!\!bat_camera!\Cal"
					!bat_logexec! rd /q /s "!bat_temp_sub!\!bat_camera!\Cal"

					!bat_logexec! del /q /s "!bat_startlocation!\Submitted\!bat_captureddate!_!bat_camera!_!bat_capturedtime!"
					!bat_logexec! rd /q /s "!bat_startlocation!\Submitted\!bat_captureddate!_!bat_camera!_!bat_capturedtime!"
				)
			)
		)
	!bat_popecho!

	!bat_logexeclog! set bat_zipfile_spec=!bat_captureddate!_!bat_camera!_!bat_capturedtime!*.zip
	!bat_logexec! copy /y "!bat_targetlocation!\CAMS\Transmitted\!bat_zipfile_spec!" "!bat_targetlocation!\CAMS\Submitted"

	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=

	call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
	!bat_echolog! bat_detectfile=!bat_detectfile!
	if defined bat_detectfile (
		if exist "!bat_detectfile!" (
			if not exist "!bat_archivedfilesdir!\CalFileList.log" (
				call :CREATECALFILELIST "!bat_detectfile!"
			)
		)
	)

	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount  "!bat_archivedfilesdir!"
	!bat_echolog! bat_archivedmeteorcount=!bat_archivedmeteorcount!

	call :GETDETECTFILE "bat_detectfileconf" "bat_confirmedfilesdir"
	!bat_echolog! bat_detectfileconf=!bat_detectfileconf!

	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"
	!bat_echolog! bat_confirmedmeteorcount=!bat_confirmedmeteorcount!

	rem This section checks to ensure that the source SubmissionFiles directory
	rem is empty of files, indicating that the move was successful.  If there 
	rem aren't " 0 File(s)", then it displays a message.


	set bat_recent_error_msg=15. [!bat_capturedfilesdir!]

:RESTORESUBMIT_END
!bat_poplog! [RETURN !bat_batchfile!:RESTORESUBMIT_END] [!bat_capturedfilesdir!, 
!bat_log! '                                      !bat_archivedfilesdir!,
!bat_log! '                                      !bat_confirmedfilesdir!,
!bat_log! '                                      !bat_detectfile!]
!bat_log!
	set bat_temp_cap=
	set bat_temp_arch1=
	set bat_temp_conf=
	set bat_temp_sub=
	set bat_temp_arch1=
	set bat_detectfileconf_name=
	set bat_capbasedir=
!bat_return!





	rem Search for the matching directory "...\ArchivedFiles\2012_08_11*"
	rem and parse it into the following three return values:
	rem RETURNS:
	rem 1} bat_retval
	rem    The fully qualified dir name   "...\ArchivedFiles\2012_08_12_03_35_00"
	rem 2} bat_retval2
	rem    The base path                  "...\ArchivedFiles"
	rem 3} bat_retval3  bat_basedir
	rem    The last dir name in the path  "2012_08_12_03_35_00"
:SEARCHFORDIR 
!bat_pushlog! [CALL !bat_batchfile!:SEARCHFORDIR] [%~1]
	rem [in] 
	rem	"!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ArchivedFiles\!bat_captureddate!*"
	rem [out] bat_retval 				is a fully qualified directory name
	rem [out] bat_retval2				is that path not including the last dir name of the path	
	rem [out] bat_retval3 bat_basedir	is the last directory name in the path


	set bat_retval=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "%~1*" /s/b /ad`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "%~1*" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					!bat_log! '.............%%a
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)
	!bat_poplog!

:SEARCHFORDIR_END
!bat_poplog! [RETURN !bat_batchfile!:SEARCHFORDIR] [bat_retval=!bat_retval!, 
!bat_log! '                                  bat_retval2=!bat_retval2!, 
!bat_log! '                                  bat_retval3=!bat_retval3!]
!bat_log!
!bat_return!



	rem 16. Make Transmit Zip *************************************
:MAKEZIP
!bat_pushlog! [CALL !bat_batchfile!:MAKEZIP] %*
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!
		set bat_recent_error_msg=16.ERROR - Run Submission before zipping.
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		if "!bat_autonomous!" neq "autonomous" (
			pause 
		)
		goto :MAKEZIP_END
	)
	
	rem This requires 7za
	if not defined bat_camera (
		set bat_recent_error_msg=16.ERROR - Missing camera number
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAKEZIP_END
	)
	
	!bat_logexeclog! set bat_tempdir=!bat_captureddate!_!bat_camera!_!bat_capturedtime!
	!bat_logexeclog! set bat_tempsrc=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\!bat_camera!
	!bat_logexeclog! set bat_tempdest=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!
	
	call :PREZIPMOVE "!bat_tempsrc!" "!bat_tempdest!\!bat_camera!"
	if "!bat_returncode2!" neq "0" (
		goto :MAKEZIP_END
	)

	set bat_tempcounter=

	goto :MZ_SEVENZIP


:MZ_SEVENZIP
	!bat_pushecho! Checking if zip file already exists, increment counter of so...

:MZ_SEVENZIP2
	if exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" (
		!bat_echolog! Already exists: "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
		if not defined bat_tempcounter (
			set /a bat_tempcounter=2
			set bat_tempdir=!bat_tempdir!_
		) else (
			set /a bat_tempcounter+=1
		)

		goto :MZ_SEVENZIP2
	)
	!bat_popecho!

	set bat_zipfile=
	call :SEVENZIP
	call :POSTZIPMOVE  "!bat_tempsrc!" "!bat_tempdest!\!bat_camera!"

		rem SEVENZIP returns bat_returncode, not POSTZIPMOVE, therefore,
		rem This responds to a failed SEVENZIP...since whether SEVENZIP 
		rem was successful or not, POSTZIPMOVE still has to be run...

	if /i "!bat_returncode!" neq "0" (
		goto :MAKEZIP_END
	)

	if not exist "!bat_zipfile!" (
		set bat_retval=failed
		set bat_recent_error_msg=16.ERROR - Failed to create zip file: "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_retval=success
		set bat_recent_error_msg=16.SUCCESS - "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)
	
:MAKEZIP_END
!bat_poplog! [RETURN !bat_batchfile!:MAKEZIP] [!bat_retval!, "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"]
	if not defined autonomous (pause)
!bat_log!
!bat_return!


:PREZIPMOVE
!bat_pushlog! [CALL !bat_batchfile!:PREZIPMOVE] %*
	set bat_returncode2=0
	set bat_tempsrc1=%~1
	set bat_tempdest1=%~2
	
	!bat_log! bat_camera=!bat_camera!
	!bat_log! bat_camera_list=!bat_camera_list!
	!bat_log! bat_tempsrc1=!bat_tempsrc1!
	!bat_log! bat_tempdest1=!bat_tempdest1!

	if defined bat_confirmedfilesdir (
		!bat_logexeclog! copy /y "!bat_confirmedfilesdir!\comments_!bat_camera!.txt" "!bat_submissionfilesdir!\!bat_camera!\EmailFiles"
	)

	if not exist "!bat_tempsrc1!" (
		set bat_returncode2=1
		set bat_recent_error_msg=ERROR - Source dir doesn't exist [!bat_tempsrc1!]
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :PREZIPMOVE_END
	) else (
		!bat_pushlog! Moving old format just in case...
			!bat_logexeclog! move /y "!bat_tempsrc1!\EmailFiles\FTPdetectinfo_*-*-*.txt" "!bat_tempdest1!"
		!bat_pop!

		!bat_pushlog! Moving current format...
			!bat_logexeclog! move /y "!bat_tempsrc1!\EmailFiles\FTPdetectinfo_0*_scanned.txt" "!bat_tempdest1!"
		!bat_pop!

		!bat_pushlog! Copying the cal files to the base directory for compatibility with coincidence.
			!bat_logexeclog! move /y "!bat_tempsrc1!\Cal\*.*" "!bat_tempdest1!"
		!bat_pop!

		!bat_pushlog! Copying the .bin files to the base directory for validation.
			!bat_logexeclog! move /y "!bat_tempsrc1!\Cal\*.*" "!bat_tempdest1!"
		!bat_pop!

		!bat_pushlog! Copying the Thumbnails*.bmp files to the base directory.
			!bat_logexeclog! move /y "!bat_tempsrc1!\EmailFiles\Thumbnails???_????????_??????.bmp" "!bat_tempdest1!"
		!bat_pop!

		!bat_pushlog! Copying the comments files to the base directory.
			for /f "usebackq tokens=*" %%a in (`dir "!bat_tempsrc1!\EmailFiles\*.bin" /s/b /a-d /on`) do (
				!bat_logexeclog! move /y "%%a" "!bat_tempdest1!"
			)
		!bat_pop!
	)

	if defined bat_confirmedfilesdir (
		!bat_logexeclog! copy /y "!bat_confirmedfilesdir!\comments_!bat_camera!.txt" "!bat_submissionfilesdir!\!bat_camera!\EmailFiles"
	)

	set bat_returncode=0

:PREZIPMOVE_END
!bat_poplog! [RETURN !bat_batchfile!:PREZIPMOVE] [!bat_returncode2!, "!bat_tempsrc1!\EmailFiles\FTPdetectinfo_*-!bat_camera!-*.txt"]
!bat_log!
!bat_return!





:POSTZIPMOVE
!bat_pushlog! [CALL !bat_batchfile!:POSTZIPMOVE] %*
	set bat_returncode2=0
	set bat_tempsrc1=%~1
	set bat_tempdest1=%~2

	!bat_log! bat_tempsrc1=!bat_tempsrc1!
	!bat_log! bat_tempdest1=!bat_tempdest1!

	if not exist "!bat_tempsrc1!" (
		set bat_returncode2=1
		set bat_recent_error_msg=ERROR - Source dir doesn't exist [!bat_tempsrc1!]
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :POSTZIPMOVE_END
	)

	if not exist "!bat_tempdest1!" (
		set bat_returncode2=2
		set bat_recent_error_msg=ERROR - Destination dir doesn't exist [!bat_tempdest1!]
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :POSTZIPMOVE_END
	)

	!bat_logexeclog! md "!bat_tempsrc1!\Cal"
	!bat_logexeclog! move /y "!bat_tempdest1!\FTPdetectinfo*.txt" "!bat_tempsrc1!\EmailFiles"
	!bat_logexeclog! move /y "!bat_tempdest1!\comments_*.txt" "!bat_tempsrc1!\EmailFiles"
	!bat_logexeclog! move /y "!bat_tempdest1!\*.bin" "!bat_tempsrc1!\EmailFiles"
	!bat_logexeclog! move /y "!bat_tempdest1!\CAL*.txt" "!bat_tempsrc1!\Cal"
	!bat_logexeclog! move /y "!bat_tempdest1!\CameraSites*.txt" "!bat_tempsrc1!\Cal"
	!bat_logexeclog! move /y "!bat_tempsrc1!\Thumbnails???_????????_??????.bmp" "!bat_tempdest1!\EmailFiles"




:POSTZIPMOVE_END
!bat_poplog! [RETURN !bat_batchfile!:POSTZIPMOVE] [bat_returncode2, "!bat_tempdest1!\FTPdetectinfo*.txt"]
!bat_log!
!bat_return!



	rem 16. Make Transmit Zip *************************************
:MAKEZIPAUTO
!bat_pushlog! [CALL !bat_batchfile!:MAKEZIPAUTO] %*
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!
		set bat_recent_error_msg=16.a.ERROR - Run Submission before zipping.
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAKEZIPAUTO_END
	)
	
	rem This requires 7za
	if not defined bat_camera (
		set bat_recent_error_msg=16.a.ERROR - Missing camera number
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAKEZIPAUTO_END
	)

	set bat_tempdir=!bat_captureddate!_!bat_camera!_!bat_capturedtime!
	set bat_tempsrc=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\!bat_camera!
	set bat_tempdest=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!
	
	call :PREZIPMOVE "!bat_tempsrc!" "!bat_tempdest!\!bat_camera!"
	if "!bat_returncode2!" neq "0" (
		goto :MAKEZIPAUTO_END
	)
	
	set bat_tempcounter=
	
	goto :MZA_SEVENZIP
	

:MZA_SEVENZIP
	!bat_pushecho! Checking if zip file already exists, increment counter of so...
:MZA_SEVENZIP2
	if exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" (
		!bat_echolog! Already exists: Exists: "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
		if not defined bat_tempcounter (
			set /a bat_tempcounter=2
			set bat_tempdir=!bat_tempdir!_
		) else (
			set /a bat_tempcounter+=1
		)

		goto :MZA_SEVENZIP2
	)
	!bat_popecho!

	set bat_zipfile=
	call :SEVENZIP
	call :POSTZIPMOVE  "!bat_tempsrc!" "!bat_tempdest!\!bat_camera!"

		rem SEVENZIP returns bat_returncode, not POSTZIPMOVE, therefore,
		rem This responds to a failed SEVENZIP...since whether SEVENZIP 
		rem was successful or not, POSTZIPMOVE still has to be run...

	if /i "!bat_returncode!" neq "0" (
		goto :MAKEZIPAUTO_END
	)

	if not exist "!bat_zipfile!" (
		set bat_retval=failed
		set bat_recent_error_msg=16.a.ERROR - Failed to create zip file: "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_retval=success
		set bat_recent_error_msg=16.a.SUCCESS - "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)

:MAKEZIPAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:MAKEZIPAUTO] [!bat_retval!, "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"]
!bat_log!
!bat_return!




:SEVENZIP
!bat_pushlog! [CALL !bat_batchfile!:SEVENZIP
	set bat_returncode=0
	set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip
	set bat_zipsrc=!bat_tempsrc!\*.*

	!bat_echolog! Going to use zip file: !bat_zipfile!
	!bat_echolog!

	if not exist "!bat_zipsrc!" (
		set bat_returncode=99
		set bat_recent_error_msg=16.ERROR - Source dir does not exist ["!bat_zipsrc!"].
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :SEVENZIP_END
	)

	!bat_logexec! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
	set bat_returncode=!bat_logexec_returncode!


	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=16.ERROR - Failed to create the zip file using: "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog! '    errorlevel=!bat_returncode!
		!bat_echolog!
		!bat_logexec! del /q "!bat_zipfile!"
		goto :SEVENZIP_END
	)


	if exist "!bat_zipfile!" (
			rem Test for empty zip file
		call :FTPHASH "!bat_zipfile!"
		if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
			set bat_returncode=3
			set bat_recent_error_msg=16.ERROR - Empty zip file: "%~1" - deleting the zip file...
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog! '    errorlevel=!bat_returncode!
			!bat_echolog!
		!bat_logexec! del /q "!bat_zipfile!"
			!bat_logexeclog! del /q "!bat_zipfile!"
		) else (
			set bat_recent_error_msg=16.SUCCESS - created "!bat_zipfile!"
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    Not a blank zip file...
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		)
	)

:SEVENZIP_END
!!bat_poplog! [RETURN !bat_batchfile!:SEVENZIP] [errorlevel=!bat_returncode! !bat_recent_error_msg!]
!bat_logexec! dir "!bat_zipfile!"
!bat_log!
!bat_return!




	rem 17. Upload Zip via FTP ************************************
:UPLOADFTP
!bat_pushlog! [CALL !bat_batchfile!:UPLOADFTP] %*
	set bat_retval=failed

	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog!     Run Submission before zipping: 
		goto :UPLOADFTP_END
	)

		rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
		rem and the question won't be asked again.
	if /i "!bat_ftppassword!" equ "" (
		!bat_echolog!
		!bat_echolog!
		set bat_choice=
		          set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: 
		!bat_log! set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: !bat_choice!
		set bat_ftppassword=!bat_choice!
		!bat_log! set bat_ftppassword=!bat_ftppassword!
		call :SAVECONFIG
	)

	!bat_echolog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	              set bat_ftpfile=!bat_exedir!\ftp.temp.txt

		rem Handle the case where an existing FTP with the same name has already been
		rem uploaded.  Since the users won't typically have delete rights, they will
		rem need to load a different file.  So, we need to list all the existing 
		rem zip files (in ascending date order), add a sequence number to the file name,
		rem and upload the newly sequenced file.  Of course, there is the likelihood that
		rem no file exists.
	set bat_zipfile=
	set bat_zip=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
		set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\%%~a
		set bat_zip=%%~a
	)
	!bat_poplog!
	
	if defined bat_zipfile (
		set bat_recent_error_msg=17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_recent_error_msg=17.ERROR - no matching zip file found.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :UPLOADFTP_END
	)
	
	call :FTPTRANSFER
	
:UPLOADFTP_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADFTP] [!bat_retval!, !bat_returncode!, "!bat_zipfile!" !bat_recent_error_msg!]
	if not defined autonomous (pause)
!bat_log!
!bat_return!







	rem 17. Upload Zip via FTP ************************************
:UPLOADFTPAUTO
!bat_pushlog! [CALL !bat_batchfile!:UPLOADFTPAUTO] %*
	set bat_retval=failed

	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog!     Run Submission before zipping: 
		if not defined bat_autonomous (
			pause 
			goto :UPLOADFTPAUTO_END
		)
	)

		rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
		rem and the question won't be asked again.
	if /i "!bat_ftppassword!" equ "" (
		!bat_echolog!
		!bat_echolog!
		set bat_choice=
		          set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: 
		!bat_log! set /P bat_choice=.!bat_pushstring!Enter your email address as the anonymous FTP password: !bat_choice!
		set bat_ftppassword=!bat_choice!
		!bat_log! set bat_ftppassword=!bat_ftppassword!
		call :SAVECONFIG
	)

	!bat_echolog! set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	              set bat_ftpfile=!bat_exedir!\ftp.temp.txt
	
		rem Handle the case where an existing FTP with the same name has already been
		rem uploaded.  Since the users won't typically have delete rights, they will
		rem need to load a different file.  So, we need to list all the existing 
		rem zip files (in ascending date order), add a sequence number to the file name,
		rem and upload the newly sequenced file.  Of course, there is the likelihood that
		rem no file exists.
	set bat_zipfile=
	set bat_zip=
	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
		set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\%%~a
		set bat_zip=%%~a
	)
	!bat_poplog!

	if defined bat_zipfile (
		set bat_recent_error_msg=17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_recent_error_msg=17.ERROR - no matching zip file found.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :UPLOADFTP_END
	)

	call :FTPTRANSFER
	

:UPLOADFTPAUTO_END
!bat_poplog! [RETURN !bat_batchfile!:UPLOADFTPAUTO] [!bat_retval!, !bat_returncode!, "!bat_zipfile!" !bat_recent_error_msg!]
!bat_log!
!bat_return!





	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_pushlog! [CALL !bat_batchfile!:FTPHASH] %*
	set bat_retval=
	set bat_hash=

	if not exist "%~1" (
		set bat_retval=1
		goto :FTPHASH_END
	)

	!bat_logexeclog! call md5 -o"!bat_exedir!\Logs\md5.output.log" "%~1"
	set bat_retval=!bat_logexec_returncode!
	
	if !bat_retval! equ 0 (
		for /f "usebackq tokens=1,*" %%X in ("!bat_exedir!\Logs\md5.output.log") do (
			set bat_hash=%%X
		)
		
		if not defined bat_RetVal1 (
			set bat_retval=3
		)
	)

	if exist "!bat_exedir!\Logs\md5.output.log" (
		!bat_logexeclog! del /q "!bat_exedir!\Logs\md5.output.log"
	)

:FTPHASH_END
!bat_poplog! [RETURN !bat_batchfile!:FTPHASH] [bat_retval=!bat_retval!, bat_hash=!bat_hash!]
!bat_log!
!bat_return!




:FTPTRANSFER
!bat_pushlog! [CALL !bat_batchfile!:FTPTRANSFER
	set bat_retval=failed

		rem Part of the FTP transfer session uploads with a PUT and then
		rem immediately downloads with a GET.  The downloaded file is
		rem temporarily placed in the Temp dir, so the dir needs to be there.
	if not exist "!bat_exedir!\Temp!" (
		!bat_logexeclog! md "!bat_exedir!\Temp!"
	)

		rem Test the zip before uploaded to ensure that it's good...
	call :FTP_TESTZIP "!bat_zipfile!"
	if /i "!bat_returncode!" neq "0" (
		goto :FTPTRANSFER_END
	)

	!bat_echolog! Now upload the file and then download it to .\Temp to test it 
	!bat_echolog! for validity...
	!bat_pushecho!

		echo user !bat_ftpuser!>"!bat_ftpfile!"
		echo !bat_ftppassword!>>"!bat_ftpfile!"
		echo bin>>"!bat_ftpfile!"
		echo cd !bat_ftpdir!>>"!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo put "!bat_zipfile!">>"!bat_ftpfile!"
		echo lcd "!bat_exedir!\Temp">>!bat_ftpfile!"
		echo literal pasv>>"!bat_ftpfile!"
		echo get "!bat_zip!">>!bat_ftpfile!"
		echo quit>>"!bat_ftpfile!"

		!bat_logexec! type "!bat_ftpfile!"
	                   
		!bat_echolog! '..............................................
	!bat_popecho!

	if /i "!bat_SIMULATION.ftp!" equ "true" (
		!bat_pushecho! SIMULATION - 
			!bat_logexeclog! md "!bat_exedir!\Temp\SimulatedFTP"
			!bat_logexeclog! copy /y "!bat_zipfile!" "!bat_exedir!\Temp\SimulatedFTP"
			!bat_logexeclog! copy /y "!bat_exedir!\Temp\SimulatedFTP\!bat_zip!" "!bat_exedir!\Temp"
		!bat_popecho!
		set bat_returncode=0
	) else (
		!bat_logexec! call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
		set bat_returncode=!bat_logexec_returncode!
	)

	!bat_echolog!
	!bat_echolog! '    FTP exit code=!bat_returncode!
	!bat_echolog!

::CHECK_GET
	if not exist "!bat_exedir!\Temp\!bat_zip!" (
		set bat_recent_error_msg=17.ERROR - Failed FTP upload of "!bat_zipfile!" - can't find it in "!bat_exedir!\Temp".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	) else (
		call :FTPHASH "!bat_zipfile!"
		set bat_hash_before=!bat_hash!
		
		call :FTPHASH "!bat_exedir!\Temp\!bat_zip!"
		set bat_hash_after=!bat_hash!
		
		if /i "!bat_hash_after!" neq "!bat_hash_before!" (
			set bat_recent_error_msg=17.FAILED - target is different from the source. Something went wrong between uploading the file and downloading it again to check.  The file exists on the FTP server, but when it is downloaded from the FTP server it is different from the original.
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		) else (
			set bat_recent_error_msg=17.SUCCESS - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		)
		
		!bat_pushecho! Deleting the test download...
		!bat_logexec! del /q "!bat_exedir!\Temp\!bat_zip!"
		!bat_popecho!

		call :MOVETRANSMIT

		if /i "!bat_hash_after!" neq "!bat_hash_before!" (
			goto :FTPTRANSFER_END
		)

		!bat_log!
		!bat_logexec! copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"

		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - "!bat_zipfile!" - Target is validated as the same on the FTP server as a test download of the same file via MD5 hash check.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)

:FTPTRANSFER_END
!bat_poplog! [RETURN !bat_batchfile!:FTPTRANSFER] [!bat_retval!, !bat_recent_error_msg!]
!bat_log!
!bat_return!




	rem Move to Transmitted
:MOVETRANSMIT
!bat_pushecho! [CALL !bat_batchfile!:MOVETRANSMIT] %*
	!bat_logexec! move /y "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Transmitted"

:MOVETRANSMIT_END
!bat_popecho! [RETURN !bat_batchfile!:MOVETRANSMIT] ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]
!bat_log!
!bat_return!




:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_pushlog! [CALL !bat_batchfile!:FTP_TESTZIP] %*

	!bat_echolog! 'Test the zip file before uploading to ensure that it's good.
	!bat_echolog! 'The test involves:
	!bat_echolog! '  - The zip file must exist;
	!bat_echolog! '  - The hash code must not be the empty zip file hash
	!bat_echolog! '    If so, the zip file will be deleted.
	!bat_echolog! '  - The zip file is unzipped to Temp\Zip.  [The Temp\Zip dir
	!bat_echolog! '    is cleaned out before unzipping]
	!bat_echolog! '  - The Temp\Zip dir is cleaned up and the Temp\Zip dir is removed.
	!bat_echolog! '  - If there are no other errors, the 

	if not exist "%~1" (
		set bat_returncode=98
		set bat_recent_error_msg=17.ERROR - Not found: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

	call :FTPHASH "%~1"
	if /i "!bat_hash!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
		set bat_returncode=99
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_logexec! del /q "%~1"
		goto :FTP_TESTZIP_END
	) else (
		!bat_echolog! '    not a blank zip file...
	)
	
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_log! // Cleaning up before unzipping...
		!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
		!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
	)

	!bat_log! // Unzip the file to "..\Temp\Zip" and check for errorlevel

	!bat_logexeclog! call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\Zip" "%~1" "*.*"
	set bat_returncode=!bat_logexec_returncode!

	!bat_log! // Cleanup after unzipping...
	if exist "!bat_exedir!\Temp\Zip" (
		!bat_logexeclog! del /s /q "!bat_exedir!\Temp\Zip"
		!bat_logexeclog! rd /s /q "!bat_exedir!\Temp\Zip"
	)

	!bat_log! // Comparing the hash codes...
	if /i !bat_returncode! equ 0 (
		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - Zip file is OK and ready to upload: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
	) else (
		set bat_retval=failed
		set bat_recent_error_msg=17.ERROR - Corrupt zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

:FTP_TESTZIP_END
!bat_poplog! [RETURN !bat_batchfile!:FTP_TESTZIP] [!bat_retval!, !bat_returncode!, %~1]
!bat_log!
!bat_return!









	rem 18. Email notice ******************************************
:EMAILTEXT
!bat_log!
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	echo.
	echo Email the following text to your central coordinator:
	echo.
	echo     Subject: CAMS submission for Camera !bat_camera! for !bat_captureddate!
	echo.

	echo     The CAMS files for Camera !bat_camera! for Capture Date of !bat_captureddate! 
	echo     have been processed.  
	echo.
	echo     Please let me know if anything of significance was found using this data.
	echo.
	echo     Details for the submission follow...
	echo.
	echo     Scanning for zip files in ["!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"]...
	set bat_zipfile=
	if exist "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" (
		!bat_push!
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
			set bat_zipfile=!bat_targetlocation!\CAMS\Transmitted\%%~a
		)
		!bat_pop!
		
		if defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS been uploaded 
			echo       to the FTP server.  The file name is:
			echo          "!bat_zipfile!"
		)
	) else (
		if not defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS NOT been  
			echo       uploaded.  The file name should have been:
			echo          "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"

			echo.
			if exist "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" (
				echo       Scanning for zip files in ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]...
				set bat_zipfile2=
				!bat_push!
				for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
					set bat_zipfile2="!bat_targetlocation!\CAMS\Submitted\%%~a"
				)
				!bat_pop!

				if defined bat_zipfile2 (
					echo         The zip file was created here, but was not uploaded:
					echo            "!bat_zipfile2!"
				)
			)
		)
	)
	
	echo.
	echo.
	set bat_emailfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles
	!bat_push!
	for /f "usebackq tokens=*" %%h in (`dir "!bat_emailfilesdir!\!bat_camera!_arch*.txt" /b`) do (
		!bat_push!
		for /f "tokens=1-6 delims=.,=" %%i in ("!bat_emailfilesdir!\%%h") do (
			!bat_echo! Archived    Confirmed
			!bat_echo! Meteor Count    %%j          %%l
		)
		!bat_pop!
	)
	!bat_pop!

	!bat_pushecho!
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt" /b /od /a-d`) do (
		set bat_calfilename=!bat_submissionfilesdir!\!bat_camera!\Cal\%%h
	)
	!bat_pop!
	!bat_echo!

	!bat_pushecho!
	for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt"`) do (
		set bat_found=0
		if "%%h" equ " Camera number            " (set bat_found=1)
		if "%%h" equ " Calibration date         " (set bat_found=1)
		if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
		if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
		if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
		if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
		if "%%h" equ " Mean O-C " (set bat_found=1)
		if !bat_found! equ 1 (
			set bat_temp=%%~h                              
			set bat_temp=!bat_temp:~0,27!
			echo  !bat_temp! =%%i
		)
	)
	!bat_popecho!



	
::GETCALFILENSTARS	
	set /a bat_calfilestars=0
	!bat_push!
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	!bat_pop!
	echo   Cal stars used             = !bat_calfilestars!

::SHOWSKIPPEDFRAMES
	!bat_pushecho!
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
						 call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
				)
			)
		)
	)
	!bat_popecho!

:EMAILTEXT_END
!bat_pushlog! [RETURN !bat_batchfile!:EMAILTEXT] %*
	set bat_temp=
	set bat_calfilestars=
!bat_popecho! [RETURN !bat_batchfile!:EMAILTEXT] [!bat_calfilestars!]
	pause
!bat_log!
!bat_return!



:GETCALFILEINFO
!bat_pushlog! [CALL !bat_batchfile!:GETCALFILEINFO] %*
	call GetCalfileInfo.bat "!bat_calfilename!"
	set bat_returncode=!errorlevel!
!bat_poplog! [!bat_returncode!]
!bat_log!
!bat_return!



:CHECKBINFILESIZE
!bat_pushlog! call :!bat_batchfile!:CHECKBINFILESIZE %*
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	set bat_returncode=!errorlevel!
	cd /d !bat_exedir
!bat_popecho! [RETURN !bat_batchfile!:CHECKBINFILESIZE] [!bat_returncode!]
	pause
!bat_log!
!bat_return!






















rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
:UTILSMENU
	call :CLEARSCREEN
	color !bat_color!
	if not defined bat_captureddate (
		set bat_titlebar=CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
	)
	rem TITLE !bat_titlebar!
	TITLE %~dpnx0 - CAMS UTILITY MENU

	echo  !bat_titlebar!
	echo.
	echo 31. Command Prompt                    [ !bat_exedir!^> ]
	echo 32. Check for bad FF*.bin files       [CheckBinFileSize.bat]
	echo 33.    Delete bad FF*.bin files       [CheckBinFileSize.cleanup.bat]
	echo 34. Check free disk space             [CheckFreeSpace.bat !bat_targetlocation:~0,2!]
	echo 35. List all drives                   [ListDrives.bat]
	echo 36. Validate Calibration files for "!bat_captureddate!" [ValidateCal.bat]
	echo 37. Meteor Count Working dirs         [MeteorCount.presubmission.bat ]
	echo 38. Meteor Count Submitted dirs       [MeteorCount.submitted.bat ]
	echo 39. Display CapturedFiles info        [GetFFDirectoryListing.bat]
	echo 40. Display 3 days' CapturedFiles     [GetCaptured.bat]
	echo 41. Display 3 days' ArchivedFiles     [GetArchived.bat]
	echo 42. CheckTwilight for "Captured Date" [CheckTwilight.bat]
	echo 43. Launch Capture Script             [LaunchCapture.bat]
	echo 44. Multi-tasked Meteor Scan          [MakeCaseListing.bat]
	echo 44b. Merge Multi-tasked Meteor Scan Files [MergeCaseFiles.bat]
	echo 45. Single-threaded Meteor Scan       [FTP_Reprocess.exe]
	echo 45b. Post MultiScan Processing        [PostMultiScanCalibration.bat]
	echo.
	echo 47. Calculate Day Of Week for "!bat_captureddate!"
	echo 48. Save Configuration                ["%~dpnx0.ini"]
	echo 49. Night Mode                        [!bat_color_on!]
	echo 50. List dates that need processing   [Working CapturedFiles dir]
	echo 51. List Unzipped Nights              [Not zipped]
	echo 52. List Untransmitted Zips           [Not transmitted]
	echo 53. Make Movie from ConfirmedFiles    [MovieFromDetect.bat]
	echo 54. Coincidence                       [Coincidence.bat "!bat_captureddate!"]
	echo.
	echo 55. Single Camera Live Viewer     59. Adjust FF timestamp (extreme caution)
	echo 56. Single FF movie               60. Cal Summary
	echo 57. Camera Movies [deprecated]    61. Pre-DVD Archive
	echo.58. Mosaic                        62. Split dual capture
	echo.
	echo.69. Fireball Scan (Low-res skip=0)72. Single File Viewer (first file)
	echo.70. Thumbnails                    73. Single File Viewer (Choose starting file)
	echo 71. Spectral Prescreen            
	echo.
	echo  M. Main Menu
	echo  Q. Quit
	echo                Last error msg: !bat_recent_error_msg!
	echo.

	set bat_choice=none
	          set /P bat_choice=Enter choice: 
	!bat_log! set /P bat_choice=Enter choice: !bat_choice!
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE
	!bat_log! !bat_batchfile!:UTILSMENU "!bat_choice!"
	!bat_log!
	!bat_log!

	if /i "!bat_choice!" equ "debug" (
		if /i "!bat_indent_log_debug!" equ "REM " (
			!bat_echolog! Toggling debugging to ON
			set bat_indent_log_debug=
		) else (
			!bat_echolog! Toggling debugging to OFF
			set bat_indent_log_debug=REM 
		)
		goto :UTILSMENU
	)
	

	call :READPARAMS
	
	if /i "!bat_choice!" equ "r" (
		CALL :RESET
	)
	if /i "!bat_choice!" equ "u" goto :UTILSMENU
	if /i "!bat_choice!" equ "30" goto :UTILSMENU
	
	if /i "!bat_choice!" equ "1"  call :CHOOSETARGETDRIVE&goto :MENU
	if /i "!bat_choice!" equ "2"  call :CHOOSECAMERA&goto :MENU
	if /i "!bat_choice!" equ "3"  call :CHOOSEDATE&goto :MENU
	if /i "!bat_choice!" equ "3s"  (
		set bat_choice=s
		call :CHOOSEDATESUB&goto :MENU
	)
	
	if /i "!bat_choice!" equ "4"  call :CHOOSECAP&goto :MENU
	if /i "!bat_choice!" equ "5"   call :CHOOSEARCH&goto :MENU
	if /i "!bat_choice!" equ "5a"  call :DETECTFILE_GET&goto :MENU
	if /i "!bat_choice!" equ "6"  call :SKIPPEDFRAMES&GOTO :MENU
	if /i "!bat_choice!" equ "7a"  call :CALUPDATE&goto :MENU
	if /i "!bat_choice!" equ "7b"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "7c"  call :CALUPDATEAUTOPROMPT&goto :MENU
	if /i "!bat_choice!" equ "7d"  call :CAL&goto :MENU
	if /i "!bat_choice!" equ "9"  call :APPLY&goto :MENU
	if /i "!bat_choice!" equ "10" call :CONFIRM&goto :MENU
	if /i "!bat_choice!" equ "11" call :EDITCOMMENTS&goto :MENU
	if /i "!bat_choice!" equ "12" call :APPLYCONFIRMED&goto :MENU
	if /i "!bat_choice!" equ "13" call :SUBMIT&goto :MENU
	if /i "!bat_choice!" equ "14" call :choosesubmission&goto :MENU
	if /i "!bat_choice!" equ "15" call :RESTORESUBMIT&goto :MENU
	if /i "!bat_choice!" equ "16" call :MAKEZIP&goto :MENU
	if /i "!bat_choice!" equ "17" call :UPLOADFTP&goto :MENU
	if /i "!bat_choice!" equ "18" call :EMAILTEXT&goto :MENU
	
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "m" goto :MENU
	if /i "!bat_choice!" equ "none" (
		goto :MENU
	)
	
	if /i "!bat_choice!" equ "31" call :CMDPROMPT&					goto :UTILSMENU
	if /i "!bat_choice!" equ "32" call :CHECKBINFILESIZE&			goto :UTILSMENU
	if /i "!bat_choice!" equ "33" call :CHECKBINCLEANUP&			goto :UTILSMENU
	if /i "!bat_choice!" equ "34" call :CHECKFREESPACE&				goto :UTILSMENU
	if /i "!bat_choice!" equ "35" call :LISTDRIVES&					goto :UTILSMENU
	if /i "!bat_choice!" equ "36" call :VALIDATECAL&				goto :UTILSMENU
	if /i "!bat_choice!" equ "37" call :METEORCOUNTPRE&				goto :UTILSMENU
	if /i "!bat_choice!" equ "38" call :METEORCOUNTSUBMITTED&		goto :UTILSMENU
	if /i "!bat_choice!" equ "38b" call :METEORCOUNTSUBMISSION&		goto :UTILSMENU
	if /i "!bat_choice!" equ "39" call :GETFFDIRLIST&				goto :UTILSMENU
	if /i "!bat_choice!" equ "40" call :GETCAPTURED&				goto :UTILSMENU
	if /i "!bat_choice!" equ "41" call :GETARCHIVED&				goto :UTILSMENU
	if /i "!bat_choice!" equ "42" call :GETTWILIGHT&				GOTO :UTILSMENU
	if /i "!bat_choice!" equ "43" call :LAUNCHCAPTURE&				GOTO :UTILSMENU
	if /i "!bat_choice!" equ "44"  call :REPROCESSMULTI&			goto :UTILSMENU
	if /i "!bat_choice!" equ "44b" call :MERGECASE&					goto :UTILSMENU
	if /i "!bat_choice!" equ "45"  call :REPROCESS&					goto :UTILSMENU
	if /i "!bat_choice!" equ "45b" call :POSTMULTI "!bat_captureddate!"&goto :UTILSMENU
	if /i "!bat_choice!" equ "47" call :DAYOFWEEK&					goto :UTILSMENU
	if /i "!bat_choice!" equ "48" call :SAVECONFIG&					goto :UTILSMENU
	if /i "!bat_choice!" equ "49" call :NIGHTMODE&					goto :UTILSMENU
	if /i "!bat_choice!" equ "50" call :LISTFAILED&					goto :UTILSMENU
	if /i "!bat_choice!" equ "51" call :LISTUNZIPPED&				goto :UTILSMENU
	if /i "!bat_choice!" equ "52" call :LISTUNTRANSMITTED&			goto :UTILSMENU
	if /i "!bat_choice!" equ "53" call :METEORMOVIES&				goto :UTILSMENU
	if /i "!bat_choice!" equ "54" call :COINCIDENCE&				goto :UTILSMENU

	if /i "!bat_choice!" equ "55" call :CAMERALIVEVIEWER&			goto :UTILSMENU
	if /i "!bat_choice!" equ "56" call :SINGLEFFMOVIE&				goto :UTILSMENU
	if /i "!bat_choice!" equ "57" call :CAMERAMOVIES&				goto :UTILSMENU
	if /i "!bat_choice!" equ "58" call :MOSAIC&						goto :UTILSMENU
	if /i "!bat_choice!" equ "59" call :ADJUSTFFTIMESTAMP&			goto :UTILSMENU
	if /i "!bat_choice!" equ "60" call :CALSUMMARY&					goto :UTILSMENU

	
	if /i "!bat_choice!" equ "61" call :MAKEARCHIVEDATEZIP&			goto :UTILSMENU
	if /i "!bat_choice!" equ "62" call :SPLITDUALCAPTURE&			goto :UTILSMENU
	
	if /i "!bat_choice!" equ "69" call :THUMBNAILSa&				goto :UTILSMENU
	if /i "!bat_choice!" equ "70" call :THUMBNAILS&					goto :UTILSMENU
	if /i "!bat_choice!" equ "71" call :PRESCREEN&					goto :UTILSMENU
	if /i "!bat_choice!" equ "72" call :SPFF_SINGLEFILEVIEWER&		goto :UTILSMENU
	if /i "!bat_choice!" equ "73" call :SPFF_SINGLEVIEWER_CHOICE&	goto :UTILSMENU
	
	if /i "!bat_choice!" equ "?" set bat_&pause&					goto :UTILSMENU

	rem Hidden extras
	if /i "!bat_choice!" equ "v"  call :VARIABLES&goto :UTILSMENU
	if /i "!bat_choice!" equ "a"  call :AUTO&goto :UTILSMENU
	if /i "!bat_choice!" equ "cls" cls&:goto :UTILSMENU
	if /i "!bat_choice!" equ "fa" call :FIXDETECTPATHS "!bat_archivedfilesdir!" !bat_detectfile!&goto :UTILSMENU
	if /i "!bat_choice!" equ "fc" call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfile!&goto :UTILSMENU
	if /i "!bat_choice!" equ "clearerror" call :CLEARERROR&goto :UTILSMENU
	if /i "!bat_choice!" equ "edit" call :EDITAUTOCAMS&goto :UTILSMENU
	if /i "!bat_choice!" equ "ziplogs" call :ZIPLOGS&goto :UTILSMENU
	if /i "!bat_choice!" equ "del logs" (
		del /q "!bat_exedir!\Logs\*.log"
		goto :MENU
	)

	if /i "!bat_choice!" equ "dd"  call :DAILYDOWNLOAD&goto :MENU

	echo.!bat_choice!|find /i "notepad "
	if !errorlevel! equ 0 (
		echo %cd%
		start "" !bat_choice!
	)
	
	goto :UTILSMENU

	set bat_choice=
!bat_log!
!bat_return!



	rem 31u. Command Prompt *****************************************
:CMDPROMPT
	echo start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	     start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"

!bat_log!
!bat_return!



	rem 32. CheckBinFileSize **************************************
:CHECKBINFILESIZE
	!bat_logexec! call "!bat_exedir!\CheckBinFileSize.bat"
	set bat_returncode=!bat_logexec_returncode!

:CHECKBINFILESIZE_END
!bat_log!
!bat_return!



	rem 33. CheckBinCleanUp **************************************
:CHECKBINCLEANUP
echo NOT IMPLEMENTED
goto :CHECKBINCLEANUP_END
	echo Warning, this script can delete ff*.bin files! 
	set bat_choice=
	          set /P bat_choice=Are you sure? Y/N 
	!bat_log! set /P bat_choice=Are you sure? Y/N !bat_choice!
	if "!bat_choice!" equ "" goto :CHECKBINCLEANUP_END
	if /i "bat_choice!" neq "y" goto :CHECKBINCLEANUP_END

	!bat_logexec! call CheckBinFileSize.cleanup.bat
	set bat_returncode=!bat_logexec_returncode!

:CHECKBINCLEANUP_END
	set bat_choice=
!bat_log!
!bat_return!



	rem 34. CheckFreeSpace *****************************************
:CHECKFREESPACE
!bat_pushlog! [CALL !bat_batchfile!:CHECKFREESPACE] %*
	set bat_choice=
	          set /P bat_choice=Enter drive [!bat_targetlocation:~0,2!]: 
	!bat_log! set /P bat_choice=Enter drive [!bat_targetlocation:~0,2!]: !bat_choice!
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive:~0,2!)
	set bat_choice=!bat_choice::=!
	set bat_choice=!bat_choice!:

	!bat_logexec! call "!bat_exedir!\CheckFreeSpace.bat" !bat_choice!
	set bat_returncode=!bat_logexec_returncode!

	set bat_choice=

:CHECKFREESPACE_END
!bat_popecho! [RETURN !bat_batchfile!:CHECKFREESPACE] [!bat_returncode!]
!bat_log!
	pause
!bat_return!



	rem 35. ListDrives *********************************************
:LISTDRIVES
!bat_pushlog! [CALL !bat_batchfile!:LISTDRIVES] %*

	!bat_logexec! call "!bat_exedir!\ListDrives.bat"
	set bat_returncode=!bat_logexec_returncode!

:LISTDRIVES_END
!bat_popecho! [RETURN !bat_batchfile!:LISTDRIVES] [!bat_returncode!]
!bat_log!
	pause
!bat_return!



	rem 36. ValidateCal ********************************************
:VALIDATECAL
!bat_pushecho! [CALL !bat_batchfile!:VALIDATECAL] %*
	set bat_temp2=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

	!bat_pushecho! Validating the cal files using the CalFileList.log file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%x in (`type "!bat_archivedfilesdir!\CalFileList.log"`) do (
		set /a bat_counter=0
		set bat_temp=%%x
		!bat_log! set bat_temp=%%x, "!bat_caldir!"
		
		if exist "!bat_caldir!\%%x" (
			!bat_echolog!
			!bat_echolog! call "!bat_exedir!\ValidateCal.bat" /cal "!bat_caldir!\%%x"
			              call "!bat_exedir!\ValidateCal.bat" /cal "!bat_caldir!\%%x"
			set bat_returncode=!bat_errorlevel!
		)
	)
	!bat_popecho!

:VALIDATECAL_END
!bat_popecho! [RETURN !bat_batchfile!:VALIDATECAL] [bat_RetVal1=!bat_RetVal1!, bat_RetVal2=!bat_RetVal2!, bat_RetVal3=!bat_RetVal3!, bat_caldir=!bat_caldir!]
set bat_temp=
!bat_log!
pause
!bat_return!



	REM CAREFUL - There could be multiple cal files in the detect file
:VALIDATECALLOG
!bat_pushlog! [CALL !bat_batchfile!:VALIDATECALLOG] %*
	set bat_detectcal=
	set bat_temp=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

	rem set bat_targetfilespec=!bat_caldir!\CAL???_*.txt
	set bat_targetfilespec=!bat_caldir!\!bat_detectcal!

	if not defined bat_latestcal (
		if defined bat_captureddate (
			set bat_targetfilespec=!bat_caldir!\CAL!bat_camera!_!bat_temp!*.txt
		)
	)

	!bat_pushlog! for /f "usebackq tokens=* skip=2" ..a in ^(`call "!bat_exedir!\ValidateCal.bat" /cal "!bat_targetfilespec!"`^) do ...
	for               /f "usebackq tokens=* skip=2" %%a in  (`call "!bat_exedir!\ValidateCal.bat" /cal "!bat_targetfilespec!"`) do (
		set bat_detectcal=%%a
		!bat_echolog! %%a
	)
	!bat_popecho!

:VALIDATECALLOG_END
!bat_poplog! [RETURN !bat_batchfile!:VALIDATECALLOG] [!bat_detectcal!]
	set bat_temp=
!bat_log!
!bat_return!



	rem 37. Meteor Count Presubmission *****************************
:METEORCOUNTPRE

	echo call "!bat_exedir!\MeteorCount.presubmission.bat"
		 call "!bat_exedir!\MeteorCount.presubmission.bat"
	set bat_returncode=!errorlevel!

	
:METEORCOUNTPRE_END
	!bat_pause!
!bat_log!
!bat_return!



	rem 38. Meteor Count Submitted ********************************
:METEORCOUNTSUBMITTED
	set bat_tempdir=
	if defined bat_captureddate (
		set bat_tempdir=!bat_captureddate!
	)
	!bat_echolog! call "!bat_exedir!\MeteorCount.submitted.bat" !bat_tempdir!
		          call "!bat_exedir!\MeteorCount.submitted.bat" !bat_tempdir!
	set bat_returncode=!errorlevel!
	!bat_pause!
!bat_log!
!bat_return!



	rem 38. Meteor Count Submitted ALL ********************************
:METEORCOUNTSUBMITTED2
	!bat_echolog! call "!bat_exedir!\MeteorCount.submitted.bat"
		      call "!bat_exedir!\MeteorCount.submitted.bat"
	set bat_returncode=!errorlevel!
	!bat_pause!
!bat_log!
!bat_return!



	rem 38b. Meteor Count Submission ********************************
:METEORCOUNTSUBMISSION
	set bat_tempdir=
	if defined bat_captureddate (
		set bat_tempdir=!bat_captureddate!
	)
	!bat_echolog! call "!bat_exedir!\MeteorCount.submission.bat" "!bat_tempdir!"
		          call "!bat_exedir!\MeteorCount.submission.bat" "!bat_tempdir!"
	set bat_returncode=!errorlevel!
	!bat_pause!
!bat_log!
!bat_return!



	rem 39. GetFFDirectoryListing **********************************
:GETFFDIRLIST
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\GetFFDirectoryListing.bat" !bat_dateinput!
	     call "!bat_exedir!\GetFFDirectoryListing.bat" !bat_dateinput!
	set bat_returncode=!errorlevel!
	cd /d !bat_exedir!
	pause
!bat_log!
!bat_return!



	rem 40. GetCaptured *******************************************
:GETCAPTURED
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\GetCaptured.bat" !bat_dateinput!
	     call "!bat_exedir!\GetCaptured.bat" !bat_dateinput!
	set bat_returncode=!errorlevel!
	cd /d !bat_exedir!
	pause
!bat_log!
!bat_return!



	rem 41. GetArchived *******************************************
:GETARCHIVED
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\GetArchived.bat" !bat_dateinput!
	     call "!bat_exedir!\GetArchived.bat" !bat_dateinput!
	set bat_returncode=!errorlevel!
	cd /d !bat_exedir!
	pause
!bat_log!
!bat_return!



	rem 42. CheckTwilight  *****************************************
:GETTWILIGHT
	rem get twilight for today or the CapturedFiles date
	set bat_twilightdate=
	if defined bat_captureddate (
		set bat_twilightdate=!bat_dateinput!
	)
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\CheckTwilight.bat" !bat_twilightdate!
	     call "!bat_exedir!\CheckTwilight.bat" !bat_twilightdate!
	set bat_returncode=!errorlevel!
	echo.
	cd /d !bat_exedir!
	pause
!bat_log!
!bat_return!





	rem 43. LaunchCapture  *****************************************
:LAUNCHCAPTURE
!bat_pushlog! call :!bat_batchfile!:LAUNCHCAPTURE %*
	echo.
	echo WARNING - This routine will start the capture process and it will kill
	echo           any existing running capture instances.  If capture
	echo           has already happened for this date and/or if you don't want to
	echo           start it again, you may want to quit, otherwise continue.
	echo.
:LAUNCHCAPTURE2
	          set /p bat_choice=[Q]uit now.  Otherwise, [C]ontinue: 
	!bat_log! set /p bat_choice=[Q]uit now.  Otherwise, [C]ontinue: !bat_choice!
	if /i "!bat_choice!" equ "q" goto :LAUNCHCAPTURE_END
	if /i "!bat_choice!" neq "c" goto :LAUNCHCAPTURE2
	
	echo.
	echo Notice -  You have the option to run capture in autonomous mode. In 
	echo           autonomous mode, it will complete the capture, perform a
	echo           automatic Meteor Cal Update, Apply the Cal to the detect
	echo           file, run the submission script, create a zip file, and
	echo           upload the zip file to the ftp server.
	echo.
	echo           If you choose to not run in autonomous mode, it will only
	echo           run the capture and then stop.
	echo.
	set bat_choice=
	set bat_autonomous=
	          set /p bat_choice=Do you want to run in autonomous mode [Y/N] or [Q]uit? 
	!bat_log! set /p bat_choice=Do you want to run in autonomous mode [Y/N] or [Q]uit? !bat_choice!
	if /i "!bat_choice!" equ "q" goto :LAUNCHCAPTURE_END
	if /i "!bat_choice!" equ "y" (set bat_autonomous=autonomous)
	echo.

	if not defined bat_targetlocation (
		call :CHOOSETARGETDRIVE
	)
	
	if not defined bat_camera (
		call :CHOOSECAMERA
	)
	
	!bat_echolog! start "LaunchCapture !bat_camera! 1 !bat_targetlocation!\" LaunchCapture !bat_camera! 1 "!bat_targetlocation!\" !bat_autonomous!
	              start "LaunchCapture !bat_camera! 1 !bat_targetlocation!\" LaunchCapture !bat_camera! 1 "!bat_targetlocation!\" !bat_autonomous!
:LAUNCHCAPTURE_END
!bat_popecho! [RETURN !bat_batchfile!:LAUNCHCAPTURE] []
	set bat_choice=
!bat_log!
!bat_return!



	rem 44. Reprocess Multi-tasking **********************************************
:REPROCESSMULTI
!bat_pushecho! call :!bat_batchfile!:REPROCESSMULTI %*
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		          set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=You probably don't want to do this - you have already run Submission: !bat_choice!
		goto :REPROCESSMULTI_END
	)
	
	echo.
	echo WARNING - This routine will start the meteor scan.  It will 
	echo           delete the collection of "ftpdetectinfo.txt" like 
	echo           files that may have already been created in the 
	echo           ArchivedFiles directory from a previous run.  If 
	echo           you do NOT wish to delete and overwrite those files, 
	echo.
:REPROCESSMULTI2
	set bat_choice=
	          set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: 
	!bat_log! set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: !bat_choice!
	if /i "!bat_choice!" equ "q" goto :REPROCESSMULTI_END
	if /i "!bat_choice!" neq "c" goto :REPROCESSMULTI2
	
	echo.

	!bat_echolog! call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	              call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	set bat_returncode=!errorlevel!
	
	if "!bat_returncode!" neq "0" (
		!bat_echolog! ERROR - return code from MakeCaseListing.bat is: [!bat_returncode!]
	) else (
		!bat_echolog! OK - return code from MakeCaseListing.bat is: [!bat_returncode!]
	)
	
	!bat_echolog! [!date! !time!] start /w wait 60
	                              start /w wait 60

	!bat_echolog! call :CHOOSEARCH
	              call :CHOOSEARCH

	!bat_echolog! call :MERGECASE
	              call :MERGECASE

:REPROCESSMULTI_END
!bat_popecho! return-!bat_batchfile.REPROCESSMULTI [!bat_returncode!]
	set bat_choice=
!bat_log!

!bat_return!



	rem 44b. MergeCaseFiles ****************************************
:MERGECASE
!bat_pushecho! call :!bat_batchfile!:MERGECASE %*
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		          set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=You probably don't want to do this - you have already run Submission: !bat_choice!
		goto :MERGECASE_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		          set /p bat_choice=You need to Choose ArchivedFiles first: 
		!bat_log! set /p bat_choice=You need to Choose ArchivedFiles first: !bat_choice!
		goto :MERGECASE_END
	)
	
	!bat_echolog! call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	              call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	set bat_returncode=!errorlevel!

	if not defined bat_autonomous (pause)

	call :CHOOSEARCH2
	rem call :GETDETECTFILE "bat_detectfile" "bat_archivedfilesdir"
	set bat_temp=!bat_detectfile!
	if defined bat_detectfile (
		if exist "!bat_detectfile!" (
			call :CREATECALFILELIST "!bat_detectfile!"
		)
	)

	rem Get latest cal file
	set bat_detectcal=
	!bat_push!
	for /f "usebackq tokens=* skip=2" %%a in (`find /i "CAL!bat_camera!_" "!bat_temp!"`) do (
		set bat_temp=%%a
		if /i "!bat_temp:~3,3!" equ "!bat_camera!" (
			set bat_detectcal=%%a
		)
	)
	!bat_pop!


:MERGECASE_END
!bat_popecho! [RETURN !bat_batchfile!:MERGECASE] [!bat_returncode!, !bat_detectfile!, bat_latestcal=!bat_latestcal!, bat_detectcal=!bat_detectcal!]
	set bat_temp=
!bat_log!
!bat_return!



	rem 45. Reprocess Single **********************************************
:REPROCESS
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		          set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=You probably don't want to do this - you have already run Submission: !bat_choice!
		goto :REPROCESS_END
	)
	
	echo.
	echo WARNING - This routine will start the meteor scan.  It will 
	echo           delete the collection of "ftpdetectinfo.txt" like 
	echo           files that may have already been created in the 
	echo           ArchivedFiles directory from a previous run.  If 
	echo           you do NOT wish to delete and overwrite those files, 
	echo.
:REPROCESS2
	set bat_choice=
	          set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: 
	!bat_log! set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: !bat_choice!
	if /i "!bat_choice!" equ "q" goto :REPROCESS_END
	if /i "!bat_choice!" neq "c" goto :REPROCESS2
	
	echo.

	echo call "!bat_exedir!\FTP_Reprocess.exe" "!bat_capturedfilesdir!"
	     call "!bat_exedir!\FTP_Reprocess.exe" "!bat_capturedfilesdir!"
	set bat_returncode=!errorlevel!
	pause
:REPROCESS_END
!bat_log!
!bat_return!





	rem 45b. Post Multiscan ***************************************
:POSTMULTI
!bat_pushecho! call :!bat_batchfile!:POSTMULTI %*
	rem [in] "!bat_captureddate!"
	rem [out]	bat_submissionfilesdir
	rem [out]	bat_hasrun_post

	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set bat_choice=
		          set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		!bat_log! set /p bat_choice=You probably don't want to do this - you have already run Submission: !bat_choice!
		if /i "!bat_choice!" equ "force" (goto :POSTMULTI2)
		goto :POSTMULTI_END
	)

:POSTMULTI2
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		          set /p bat_choice=You need to Choose ArchivedFiles first: 
		!bat_log! set /p bat_choice=You need to Choose ArchivedFiles first: !bat_choice!
		goto :POSTMULTI_END
	)
	
	!bat_echolog! start "!bat_exedir!\PostMultiScanCalibration.bat !bat_archivedfilesdir!" /i cmd /c ""!bat_exedir!\PostMultiScanCalibration.bat" "!bat_archivedfilesdir!""
	              start "!bat_exedir!\PostMultiScanCalibration.bat !bat_archivedfilesdir!" /i cmd /c ""!bat_exedir!\PostMultiScanCalibration.bat" "!bat_archivedfilesdir!""
	set bat_returncode=!errorlevel!

	set bat_temp=!bat_archivedfilesdir:ArchivedFiles=SubmissionFiles\%~1!
	if exist "!bat_temp!" (
		set bat_hasrun_post=true

		set bat_submissionfilesdir=!bat_archivedfilesdir:ArchivedFiles=SubmissionFiles\%~1!
		call :SAVECONFIG
	) else (
		!bat_echolog!
		!bat_echolog! '  WARNING - "!bat_temp!" does not exist
	)
:POSTMULTI_END
!bat_popecho [RETURN !bat_batchfile!:POSTMULTI] []
	set bat_temp=
	pause
!bat_log!
!bat_return!



	rem 47. DayOfWeek *********************************************
:DAYOFWEEK
	echo call DayOfWeek.bat !bat_capturedDate!
	call DayOfWeek.bat !bat_capturedDate!
	pause
!bat_log!
!bat_return!



	rem 48. Save Configuration ************************************
:SAVECONFIG
!bat_pushlog! [CALL !bat_batchfile!:SAVECONFIG] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
	echo bat_recent_error_msg=!bat_recent_error_msg!>>"!bat_configfile!"
:SAVECONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:SAVECONFIG] []
!bat_log!
!bat_return!





:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_retval=failed
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_push!
	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		set bat_retval=success
		set bat_temp=%%x
							rem if /i "%%x" neq "[CAMSMENU]" (
							rem      set %%x
							rem )

		if /i "!bat_temp!" neq "" (
			if /i "!bat_temp:~0,1!" neq " " (
				if /i "!bat_temp:~0,1!" neq "	" (
					if /i "!bat_temp:~0,2!" neq "//" (
						rem It's not a single-line comment "//"

						if /i "!bat_temp:~0,3!" neq "rem" (
							rem It's not a single line comment "rem"

							if /i "!bat_temp:~0,4!" neq "rem " (
								rem It's not a comment "rem "

								if /i "!bat_temp:~0,1!" equ "[" (
									rem It's a [section]
									set bat_temp=!bat_temp:~1,99!
									set bat_inisection=bat_!bat_temp:~0,-1!
								) else (
									rem It's a bat_key=value
									if "!bat_temp:~0,4!" equ "bat_" (
									rem !bat_log! '    set !bat_temp!
												   set !bat_temp!
									) else (
											rem It's a key=value
											set !bat_inisection!.!bat_temp!
									)
								)
							)
						)
					)
				)
			)
		)
	)
	!bat_pop!

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!

%bat_COMMENT_BEGIN%
	set bat_GCFC_tempfile=!bat_capturedfilesdir!\GCFC.log
	!bat_echolog! call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"
	              call "!bat_exedir!\CreateCameraListFile.bat" "!bat_capturedfilesdir!"

	call :GETDETECTFILE  "bat_detectfile" "bat_archivedfilesdir"
	if defined bat_detectfile (
		if exist "!bat_detectfile!" (
			if not exist "!bat_archivedfilesdir!\CalFileList.log" (
				call :CREATECALFILELIST "!bat_detectfile!"
			)
		)
	)

	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount  "!bat_archivedfilesdir!"

	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount "!bat_confirmedfilesdir!"
%bat_COMMENT_END%

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [AutoCams.bat.ini=!bat_retval!, "!bat_capturedfilesdir!"]
!bat_log!
!bat_return!




:READCONFIGVAR
!bat_pushlog! [CALL !bat_batchfile!:READCONFIGVAR] %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	set bat_tempvar=%~1

	!bat_push!
	for /f "usebackq tokens=* skip=2" %%x in (`find /i "!bat_tempvar!" "!bat_configfile!"`) do (
		!bat_log! set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)
	!bat_pop!

	
!bat_poplog! [RETURN !bat_batchfile!:READCONFIGVAR] [!bat_capturedfilesdir!]
	set bat_tempvar=
!bat_log!
!bat_return!



	rem 49. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
		color 07
	)
!bat_log!
!bat_return!



	rem 50. LIST FAILED processing **************************
:LISTFAILED
!bat_pushlog! [CALL !bat_batchfile!:LISTFAILED
	rem This routine lists the dates that still need to be processed.
	rem The list is derived from listing the CapturedFiles directory.
	rem Some other methods to determine if they failed processing are:
	rem   1. Their AutoCalUpdate.log file shows an error (but what if it
	rem      was manually calibrated?)
	rem   2. If the calibration file values are sub-par
	rem   3. If the most recent calibration file for the date
	rem      is not the one used in the detect file
	rem   4. If the CapturedFiles directory still exists in the 
	rem      working area instead of SubmissionFiles

	set bat_tempdir=!bat_targetlocation!\CAMS\CapturedFiles
	
	echo.
	echo     List of dates that haven't been packaged for SubmissionFiles 
	echo     ^(These are a list of dirs under "!bat_tempdir!"^)
	set /a bat_count=0
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempdir!" /b /ad /on`) do (
		set /a bat_count+=1
		!bat_echolog!     !bat_count!.	%%~nxa
	)
	!bat_popecho!

:LISTFAILED_END
!bat_poplog! [RETURN !bat_batchfile!:LISTFAILED] []
	set bat_tempdir=
	set bat_count=
	pause
!bat_log!
!bat_return!



	rem 51u. LIST Unzipped processing **************************
:LISTUNZIPPED
!bat_pushlog! [CALL !bat_batchfile!:LISTUNZIPPED] %*

	!bat_echo! This routine lists the dates that need to be zipped. 
	!bat_echo! The list is derived as follows:
	!bat_echo! .  1] Check the SubmissionFiles directory.  For each date:
	!bat_echo! .     a] Check the Transmitted dir for a matching zip
	!bat_echo! .     b] Check the Submitted dir for a matching zip
	!bat_echo! .     c] Check the SubmissionFiles dir for any files newer
	!bat_echo! .        than the newest existing zip file in Transmitted
	!bat_echo! .     d] Check the SubmissionFiles dir for any files newer
	!bat_echo! .        than the newest existing zip in Submitted

	set bat_tempsubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles
	set bat_tempsubmitteddir=!bat_targetlocation!\CAMS\Submitted
	set bat_temptransmitteddir=!bat_targetlocation!\CAMS\Transmitted

	echo.
	echo     Report of unzipped submission dirs...
	echo     [Lists each dir in the SubmissionFiles dir that does not have a 
	echo     corresponding zip file with the same date_camera file name... ]
	echo.
	set /a bat_count=0
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempsubmissiondir!" /b /ad /on`) do (
		set bat_temp_dirname=%%~nxa_!bat_camera!
		
		if not exist "!bat_temptransmitteddir!\!bat_temp_dirname!*.zip" (
			set /a bat_count+=1
			!bat_echo! !bat_count!.	!bat_tempsubmissiondir!\%%~nxa
		)
	)
	!bat_popecho!

:LISTUNZIPPED_END
!bat_poplog! [RETURN !bat_batchfile!:LISTUNZIPPED] []
	set bat_tempsubmissiondir=
	set bat_tempsubmitteddir=
	set bat_temptransmitteddir=
	set bat_temp_dirname=
	set bat_count=
	pause
!bat_log!
!bat_return!



	rem 52u. LIST Untransmitted processing **************************
:LISTUNTRANSMITTED
!bat_pushlog! call :!bat_batchfile!:LISTUNTRANSMITTED %*
	set bat_tempsubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles
	set bat_tempsubmitteddir=!bat_targetlocation!\CAMS\Submitted
	set bat_temptransmitteddir=!bat_targetlocation!\CAMS\Transmitted

	echo.
	echo     Report of untransmitted zip files...
	set /a bat_count=0
	!bat_push!
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempsubmissiondir!" /b /ad /on`) do (
		set bat_temp_dirname=%%~nxa_!bat_camera!
		
		if not exist "!bat_temptransmitteddir!\!bat_temp_dirname!*.zip" (
			set /a bat_count+=1
			!bat_echo!     !bat_count!.	!bat_tempsubmissiondir!\%%~nxa
		)
	)
	!bat_pushecho!

:LISTUNTRANSMITTED_END
!bat_poplog! [RETURN !bat_batchfile!:LISTUNTRANSMITTED] []
!bat_log!
	set bat_tempsubmissiondir=
	set bat_tempsubmitteddir=
	set bat_temptransmitteddir=
	pause
!bat_return!




	rem 53. FTP_MeteorMovies **************************
:METEORMOVIES
	rem set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	!bat_echolog! if not exist "!bat_detectfileconf!" 
	if not exist "!bat_detectfileconf!" (
			!bat_echolog! '    ERROR - Can't find: 
			!bat_echolog! '            "!bat_detectfileconf!"
			goto :METEORMOVIES_END
		)
	)

	if exist "!bat_detectfile!" (
		!bat_echolog! call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!
		              call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!
		set bat_returncode=!errorlevel!

		!bat_echolog! call "!bat_exedir!\MovieFromDetect.bat" "!bat_detectfileconf!"
		              call "!bat_exedir!\MovieFromDetect.bat" "!bat_detectfileconf!"
		set bat_returncode=!errorlevel!
	) else (
		!bat_echolog! '    ERROR - Can't find: "!bat_detectfileconf!"
		goto :METEORMOVIES_END
	)

:METEORMOVIES_END
	pause
!bat_echolog!
!bat_return!



	rem 54u. Coincidence ******************************************
:COINCIDENCE

%bat_COMMENT_BEGIN%
	set bat_confirmdetect=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_confirmedfilesdir!\!bat_confirmdetect!" (
		!!bat_echolog!! '    ERROR - Not exist "!bat_confirmedfilesdir!\!bat_confirmdetect!"
		goto :COINCIDENCE_END
	)
%bat_COMMENT_END%

:COINCIDENCE2
	

	!bat_echo!
	!bat_echo! When asked to "Navigate to FTP Detection File to Process 
	!bat_echo! for Coincidence", instead navigate to and select:
	!bat_echo!   "!bat_archivedfilesdir!\!bat_confirmdetect!". 
	!bat_echo!
	!bat_echolog! call  "!bat_exedir!\Coincidence.bat" "!bat_captureddate!"
	              call  "!bat_exedir!\Coincidence.bat" "!bat_captureddate!"
	set bat_returncode=!errorlevel!

:COINCIDENCE_END
!bat_return!



	rem 55u. CameraLiveViewer ****************************
:CAMERALIVEVIEWER
!bat_pushlog! [CALL !bat_batchfile!:CAMERALIVEVIEWR]
	!bat_echo!
	!bat_echo! 1. CameraLiveViewer.exe    [live viewer for focusing,positioning, etc.]
	if !bat_CAPTURE.number.of.cameras! GTR 1 (
		!bat_echo! 2. Camera2LiveViewer.exe   [8.54 second viewer]
	)
	
	if !bat_CAPTURE.number.of.cameras! GTR 2 (
		!bat_echo! 3. Camera3LiveViewer.exe   [8.54 second viewer]
	)
	!bat_echo!
	set bat_choice=
	set /p bat_choice='!bat_pushstring!Which viewer would you like to test or [Q]uit? 

	if /i "!bat_choice!" equ "q" goto CAMERALIVEVIEWER_END
	!bat_log! !bat_batchfile!:CAMERALIVEVIEWR "!bat_choice!"
	!bat_log!
	!bat_log!
	
	if /i !!bat_choice!" equ "1" (
		!bat_echolog! call  "!bat_exedir!\CameraLiveViewer.exe"
					  call  "!bat_exedir!\CameraLiveViewer.exe"
		set bat_returncode=!errorlevel!
		goto :CAMERALIVEVIEWER_END
	)

	if /i !!bat_choice!" equ "2" (
		!bat_echolog! call  "!bat_exedir!\Camera2LiveViewer.exe"
					  call  "!bat_exedir!\Camera2LiveViewer.exe"
		set bat_returncode=!errorlevel!
		goto :CAMERALIVEVIEWER_END
	)

	if /i !!bat_choice!" equ "4" (
		!bat_echolog! call  "!bat_exedir!\Camera4LiveViewer.exe"
					  call  "!bat_exedir!\Camera4LiveViewer.exe"
		set bat_returncode=!errorlevel!
		goto :CAMERALIVEVIEWER_END
	)

:CAMERALIVEVIEWER_END
!bat_poplog! [RETURN !bat_batchfile:CAMERALIVEVIEWER] [bat_returncode=!bat_returncode!]
!bat_log!
!bat_return!


	rem 56u. FTP_SingleFFmovie ****************************
:SINGLEFFMOVIE
	!bat_echolog! call  "!bat_exedir!\FTP_SingleFFmovie.exe"
	              call  "!bat_exedir!\FTP_SingleFFmovie.exe"
	set bat_returncode=!errorlevel!

:SINGLEFFMOVIE_END
!bat_echolog!
!bat_return!


	rem 57u. FTP_CameraMovies ****************************
:CAMERAMOVIES
	!bat_echolog! call  "!bat_exedir!\FTP_CameraMovies.exe"
	              call  "!bat_exedir!\FTP_CameraMovies.exe"
	set bat_returncode=!errorlevel!

:CAMERAMOVIES_END
!bat_echolog!
!bat_return!


	rem 58u. FTP_Mosaic ****************************
:MOSAIC
	!bat_echolog! call  "!bat_exedir!\FTP_Mosaic.exe"
	              call  "!bat_exedir!\FTP_Mosaic.exe"
	set bat_returncode=!errorlevel!
:MOSAIC_END
!bat_echolog!
!bat_return!


	rem 59u. FTP_AdjustFFtimestamp ****************************
:ADJUSTFFTIMESTAMP
!bat_pushecho! call :!bat_batchfile!:ADJUSTFFTIMESTAMP %*
	!bat_echolog! call  "!bat_exedir!\FTP_AdjustFFtimestamp.exe"
	              call  "!bat_exedir!\FTP_AdjustFFtimestamp.exe"
	set bat_returncode=!errorlevel!

:ADJUSTFFTIMESTAMP_END
!bat_popecho! [RETURN !bat_batchfile!:ADJUSTFFTIMESTAMP] [!bat_returncode!]
!bat_echolog!
!bat_return!



	rem 60u. FTP_CalSummary ****************************
:CALSUMMARY
!bat_pushecho! call :!bat_batchfile!:CALSUMMARY %*
	!bat_echolog! call  "!bat_exedir!\FTP_CalSummary.exe"
	              call  "!bat_exedir!\FTP_CalSummary.exe"
	set bat_returncode=!errorlevel!

:CALSUMMARY_END
!bat_popecho! [RETURN !bat_batchfile!:CALSUMMARY] [!bat_returncode!]
!bat_echolog!
!bat_return!



	rem 61u. MakeArchiveDateZip.bat ****************************
:MAKEARCHIVEDATEZIP
!bat_pushlog! call :!bat_batchfile!:MAKEARCHIVEDATEZIP] %*
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! Do you want to zip one directory or the entire selected month? 
	!bat_echolog! [O]ne date
	!bat_echolog! [M]onth
	!bat_echolog! [Q]uit
	          set /p bat_choice="  "
	!bat_log! set /p bat_choice="  "!bat_choice!

	if /i "!bat_choice!" equ "q" (goto :MAKEARCHIVEDATEZIP_END)

	if /i "!bat_choice!" equ "o" (
		!bat_logexeclog! set bat_zipdir_filespec=!bat_startlocation!\SubmissionFiles\!bat_captureddate!_*
		goto :MAKEARCHIVEDATEZIP2
	)
	
	if /i "!bat_choice!" neq "m" (
		goto :MAKEARCHIVEDATEZIP_END
	)
	
		rem bat_choice = "m"
	!bat_logexeclog! set bat_zipdir_filespec=!bat_startlocation!\SubmissionFiles\!bat_captureddate:~0,8!??*
	goto :MAKEARCHIVEDATEZIP2

:MAKEARCHIVEDATEZIP2
	set bat_abort=false
	!bat_echolog!
	!bat_echolog! You have the choice of permanently deleting all the FF*.bin files from
	!bat_echolog! all the CapturedFiles directories in this collection.
	!bat_echolog!
	!bat_echolog! Deleting the FF*.bin files from the CapturedFiles directory makes the 
	!bat_echolog! archive much smaller, however, it is a non-reversable procedure.
	!bat_echolog!
	          set /p bat_choice="Do you want to permanently delete all the FF*.bin files from all the CapturedFiles directories under the SubmissionFiles directory for the given date range? [Y/N or Quit] "
	!bat_log! set /p bat_choice="Do you want to permanently delete all the FF*.bin files from all the CapturedFiles directories under the SubmissionFiles directory for the given date range? [Y/N or Quit] "!bat_choice!
	
	if /i "!bat_choice!" equ "q" (
		goto :MAKEARCHIVEDATEZIP_END
	)

	if /i "!bat_choice!" equ "y" (
		!bat_logexeclog! set bat_delete_bin_files=delete
	) else (
		if /i "!bat_choice!" equ "n" (
			!bat_logexeclog! set bat_delete_bin_files=keep
		) else (
			goto :MAKEARCHIVEDATEZIP2
		)
	)

	!bat_pushlog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_zipdir_filespec!" /b /ad /on`^) do ^(
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_zipdir_filespec!" /b /ad /on`) do (
		if /i "!bat_abort!" equ "false" (
			set bat_temp=%%a
			if /i "!bat_temp:~-7!" neq "_zipped" (
				set bat_dir_total=
				!bat_pushecho! for /f "usebackq tokens=*" ..b in ^(`dir "!bat_startlocation!\SubmissionFiles\%%a" /s^|find /i "File(s)"`^) do ^(
				for                /f "usebackq tokens=*" %%b in  (`dir "!bat_startlocation!\SubmissionFiles\%%a" /s^|find /i "File(s)"`) do (
					set bat_dir_total=%%b
				)
				!bat_popecho! ^)
				!bat_echolog! .....................................................
				!bat_echolog! !bat_dir_total!   "!bat_startlocation!\SubmissionFiles\%%a"

				!bat_log! call "!bat_exedir!\ZipDir_7za.bat" "!bat_startlocation!\SubmissionFiles\%%a" !bat_delete_bin_files!
				          call "!bat_exedir!\ZipDir_7za.bat" "!bat_startlocation!\SubmissionFiles\%%a" !bat_delete_bin_files!
				set bat_returncode=!errorlevel!
				!bat_log! bat_returncode=!bat_returncode!

				if "!bat_returncode!" equ "99" (
					!bat_logexeclog! set bat_abort=true
				)

				if "!bat_returncode!" neq "0" (
					!bat_echolog! '    ERROR - failed to zip %a
				)
			) else (
				!bat_echolog! Already zipped: %%a
			)
		)
	)
	!bat_poplog! ^)
	
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! The result of this operation is a zip file for each session matching the
	!bat_echolog! selected date range.  In addition, the original directory is renamed
	!bat_echolog! with a "_zipped" suffix in order to make the ones that have been 
	!bat_echolog! zipped easily identifiable.  
	!bat_echolog!
	!bat_echolog! The next step is to archive to DVD the ZIP files.
	!bat_echolog!
	!bat_echolog! After the ZIP files have been successfully archived is it safe to 
	!bat_echolog! delete the original directories tagged with the "_zipped" suffix. 
	!bat_echolog!

	goto :MAKEARCHIVEDATEZIP_END
	
:MAKEARCHIVEDATEZIP_END
!bat_poplog! [RETURN !bat_batchfile!:MAKEARCHIVEDATEZIP] []
!bat_log!
set bat_abort=
pause
!bat_return!



	rem 62u. SplitDetect.bat *******************************************
:SPLITDUALCAPTURE
!bat_pushecho! [CALL !bat_batchfile!:SPLITDUALCAPTURE] [%*]

	set bat_temp=
	!bat_push!
	for /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_0???0???_*.txt" /b /a-d /o-d`) do (
		set bat_temp=!bat_archivedfilesdir!\%%a
	)
	!bat_pop!

	if defined bat_temp (
		!bat_logexec! call "!bat_exedir!\SplitDetect.bat" "!bat_temp!" "!bat_capturedfilesdir!"
		set bat_returncode=!bat_logexec_returncode!
		call :RESET
		!bat_logexec! set bat_recent_error_msg=62. You need to select option 3 to select which set to work on next...
	)
	
:SPLITDUALCAPTURE_END
!bat_popecho! [RETURN !bat_batchfile!:SPLITDUALCAPTURE] [%*]
	set bat_temp=
!bat_echolog!
!bat_return!






	rem 70u. Thumbnails [Contact Sheet]
:THUMBNAILS
	!bat_pushlog! [CALL :THUMBNAILS] [%*]
	setlocal enableextensions enabledelayedexpansion
	
	call :SAVECONFIG
	!bat_echolog! call "!bat_exedir!\thumbnails.bat"
	              call "!bat_exedir!\thumbnails.bat"
	set bat_returncode=!errorlevel!
	goto :THUMBNAILS_END


:THUMBNAILS_END
!bat_poplog! [RETURN !bat_batchfile!:THUMBNAILS] []
!bat_log!
ENDLOCAL
!bat_return!




	rem 69au. Thumbnails - [low-res FIREBALL CHECK]
:THUMBNAILSA
	!bat_pushlog! [CALL :THUMBNAILS] [%*]
	setlocal enableextensions enabledelayedexpansion
	
	call :SAVECONFIG
	!bat_echolog! call "!bat_exedir!\thumbnails.bat" /skip=1 /factor=7
	              call "!bat_exedir!\thumbnails.bat" /skip=1 /factor=7
	set bat_returncode=!errorlevel!
	goto :THUMBNAILSA_END


:THUMBNAILSA_END
!bat_poplog! [RETURN !bat_batchfile!:THUMBNAILS] []
!bat_log!
ENDLOCAL
!bat_return!





	rem 71u. SP_Prescreen with options  [only for SP files]
:PRESCREEN
	!bat_pushlog! [CALL :PRESCREEN] [%*]

	echo.
	set /p bat_choice=Which directory to process [1]ArchivedFiles, [2]CapturedFiles, [3]ConfirmedFiles, or [Q]uit? 
	if /i "!bat_choice!" equ "q" goto PRESCREEN_END
	if /i "!bat_choice!" equ "1" (
		set bat_choice=!bat_archivedfilesdir! 
	) else (
		if /i "!bat_choice!" equ "2" (
			set bat_choice=!bat_capturedfilesdir!
		) else (
			if /i !bat_choice! equ "3" (
				set bat_choice=!bat_confirmedfilesdir!
			) else (
				goto :PRESCREEN1
			)
		)
	)

	!bat_echolog! start /w "" "!bat_exedir!\SP_Prescreen.exe" "!bat_choice!"
	              start /w "" "!bat_exedir!\SP_Prescreen.exe" "!bat_choice!"

:PRESCREEN_END
!bat_poplog! [RETURN !bat_batchfile!:PRESCREEN] []
!bat_log!
!bat_return!
	




	rem 72u. SPFF_SingleFileViewer (first file)
:SPFF_SINGLEFILEVIEWER
	!bat_pushlog! [CALL :SPFF_SINGLEFILEVIEWER] [%*]
	setlocal enableextensions enabledelayedexpansion
	
:SPFF_SFV_GETCAMERA
	echo.
	set bat_choice=
	set bat_camera_temp=!bat_camera!
	set /p bat_choice=Which camera [!bat_camera!] or [Q]uit? 
	echo.!bat_choice!
	if /i "!bat_choice!" equ "q" (goto :SPFF_SINGLEFILEVIEWER_END)
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_camera!)
	if /i "!bat_choice:~0,1!" equ "0" (goto :SPFF_SFV_GETCAMERA)

	echo.!bat_camera_list!|find /i "!bat_choice!">nul
	set bat_returncode=!errorlevel!
	echo.bat_returncode=!bat_returncode!
	if /i "!bat_returncode!" neq "0" (
		echo.
		echo.ERROR - Camera "!bat_choice!" is not in the camera list [!bat_camera_list!].
		goto :SPFF_SFV_GETCAMERA
	)
	
	set bat_camera_temp=0000!bat_choice!
	set bat_camera_temp=!bat_camera_temp:~-3!
	echo.Camera to process is: [!bat_camera_temp!]
	goto :SPFF_SINGLEFILEVIEWER1
	

:SPFF_SINGLEFILEVIEWER1
	echo.
	set bat_choice=
	set /p bat_choice=Which directory to process [A]rchivedFiles, [C]apturedFiles, Con[f]irmedFiles, or [Q]uit? 
	if /i "!bat_choice!" equ "q" goto SPFF_SINGLEFILEVIEWER_END
	if /i "!bat_choice!" equ "" goto :SPFF_SFV_GETCAMERA
	
	echo.[!bat_choice!]
	set /a bat_count=0
	if /i "!bat_choice!" equ "a" (
		set bat_choice=!bat_archivedfilesdir!
		set /a bat_count=!bat_archivedmeteorcount!
	) else (
		if /i "!bat_choice!" equ "c" (
			set bat_choice=!bat_capturedfilesdir!
			set /a bat_count=!bat_capturedcount!
		) else (
			if /i "!bat_choice!" equ "f" (
				set bat_choice=!bat_confirmedfilesdir!
				set /a bat_count=!bat_confirmedmeteorcount!
			) else (
				goto :SPFF_SINGLEFILEVIEWER1
			)
		)
	)
	
	if not exist "!bat_choice!\FF!bat_camera_temp!_*.bin" (
		echo.
		echo.ERROR - No files exist matching ["!bat_choice!\FF!bat_camera_temp!_*.bin"]
		echo.
		goto :SPFF_SFV_GETCAMERA
	)
	
	echo.
	echo.Please wait while scanning for the first file...
	set /a bat_count=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_choice!\FF!bat_camera_temp!_*.bin" /a-d /b /o-n`) do (
		set /a bat_count+=1
		set bat_SPFF_firstfile=!bat_choice!\%%a
	)

	echo.
	echo.There are [!bat_count!] files matching [!bat_choice!\FF!bat_camera_temp!_*.bin]
	echo.


	!bat_echolog! start /w "" "!bat_exedir!\SPFF_SingleFileViewer.exe" "!bat_SPFF_firstfile!"
	              start /w "" "!bat_exedir!\SPFF_SingleFileViewer.exe" "!bat_SPFF_firstfile!"
	set bat_returncode=!errorlevel!
	!bat_echo! bat_returncode=!bat_returncode!

goto :SPFF_SFV_GETCAMERA

	rem NEEDS:
	rem - Additional processing to determine if there are new .bmp files in the directory.  
	rem   Either that or scan the output and look for "Writing camera" or ".bmp".
	rem   - Check whether there is/are already .bmp files in the directory.  They will be 
	rem     overwritten, so you'll need to check the date/time stamp on the file to determine
	rem     if they are new.
	rem   - Another option is to ask the user if they would like to watch it work or to
	rem     work in the background.  If it uses bat_logexeclog, the user won't see the 
	rem     scrolling output until it is all done.  This may not be a bad thing since a lot
	rem     of text scrolls.  It might be best to filter the output by omitting the individual files
	rem     somehow (omitting "Pulling snapshot for file ...")
	rem - Ask the user if they would like to open the files for viewing?
	rem - Add menu items to open the .bmp files for viewing again after already built. (like 70a or 70v)

:SPFF_SINGLEFILEVIEWER_END
!bat_poplog! [RETURN !bat_batchfile!:SPFF_SINGLEFILEVIEWER] []
!bat_log!
endlocal
!bat_return!




	rem 73u. Single File Viewer with Choice
:SPFF_SINGLEVIEWER_CHOICE
	!bat_pushlog! [CALL :SPFF_SINGLEVIEWER_CHOICE] [%*]

	setlocal enableextensions enabledelayedexpansion

	!bat_echolog! start /w "" "!bat_exedir!\SPFF_SingleFileViewer.exe"
	              start /w "" "!bat_exedir!\SPFF_SingleFileViewer.exe"


:SPFF_SINGLEVIEWER_CHOICE_END
!bat_poplog! [RETURN !bat_batchfile!:SPFF_SINGLEVIEWER_CHOICE] []
!bat_log!
ENDLOCAL
!bat_return!



	rem DD. Single File Viewer with Choice
:DAILYDOWNLOAD
	!bat_pushlog! [CALL :DAILYDOWNLOAD] [%*]

	setlocal enableextensions enabledelayedexpansion

	!bat_echolog! CALL "!bat_exedir!\ftpDAILYDOWNLOAD.bat"
	              CALL "!bat_exedir!\ftpDAILYDOWNLOAD.bat"


:DAILYDOWNLOAD_END
!bat_poplog! [RETURN !bat_batchfile!:DAILYDOWNLOAD] []
!bat_log!
ENDLOCAL
!bat_return!




:VARIABLES
!bat_push!
	call "!bat_exedir!\show_bat_vars.bat"
!bat_pop!
	!bat_echo!
	!bat_echo! Enter [bat_indent_log_debug=REM .] or [bat_indent_log_debug=] to toggle logging details.
	!bat_pause!
!bat_log!
!bat_return!





:ZIPLOGS
!bat_pushecho! [CALL !bat_batchfile!:ZIPLOGS] %*

	call "!bat_exedir!\ZipLogs.bat" "!bat_archivedfilesdir!" "!bat_submissionfilesdir!" "!bat_captureddate!" "!bat_capturedtime!" "!bat_camera!"
	set bat_recent_error_msg=!bat_retval!

:ZIPLOGS_END
!bat_popecho! [RETURN !bat_batchfile!:ZIPLOGS] [!bat_retval!]
pause
!bat_return!




:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_pushecho! [CALL !bat_batchfile!:FIXDETECTPATHS] [%*]
	set bat_retval=0

	if /i "%~1" equ "" (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	)
	
	if /i {%2} equ {} (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	)

	!bat_logexec! call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!bat_logexec_returncode!
	if !bat_retval! lss 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_popecho! [RETURN !bat_batchfile!:FIXDETECTPATHS] [!bat_recent_error_msg!]
!bat_echolog!
!bat_return!














:EDITAUTOCAMS
	!bat_echoonly! !bat_batchfile!:EDITAUTOCAMS
	!bat_echoonly! start notepad autocams.bat
	               start notepad autocams.bat
!bat_log!
!bat_return!





	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed:
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem
:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!












:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0
	echo.
	echo Displays the CAMS menu system to facilitate access to batch scripts
	echo and processing
	echo.
	echo For autonomous mode, use the following command line options:
	echo.
	echo        %~nx0 ^<"capturedfilesdir"^> ^<"archivedfilesdir"^> ^<camera^> autonomous
	echo.
	echo Example:
	echo    %~nx0 "C:\CAMS\CapturedFiles\2011_12_25_01_33_46" "C:\CAMS\ArchivedFiles\2011_12_25_01_35_05" 299 autonomous
	echo.
exit /b 9

Needs:
	- merge all captures for a single date
	- merge all archived for a single date (harder to do)
	- skippedFrames monitoring
	- convert all batch scripts to be able to run at the same time
	
	- 
	Coincidence - increase the ceiling from 140km to max allowable by military
	- Coincidence - use gefdat data to determine which ff files to upload 
      based on the date  time of events 
        see CoincidentMeteorLog.txt for 
           camera, site code, D-Time, Conv, RA, DEC, Drad, Hbeg, Hend, AzimN, Elev
        see SummaryMeteorLog.txt for where "inf" is radiant info:
           Date, TimeUT, TbegSec, TendSec, RAinf, DECinf, Vinf, Acc1, Acc2, 
           LatBeg, LonBeg, Hbeg, LatEnd, LonEnd, Hend, 
           Conv, S-Azim, ZenAng, Hmax, Max-mV, Int-mV, F-skew, Cameras
        see CAMS_nnnnn.cc.txt for (where "cc" is the station code):
           Line 1: Station Name, Station Code, CoincidenceNumber 
           Line 2: FF file name
           Line 3: CAL file name
           Line 4: Site's GPS coords, for example, site 213 in brentwood:
                   Lat= 37 56 53.196  Long= 238 16 30.288  Alt= 26.0  fps= 29.970
           Line 4: YYYY-MM-DD HH:MM:SS.sss  at Peak Frame 174
           Line 5: ----------------------------
           Line 6: Header
           Line 7: ----------------------------
           Remaining lines in the following format:
              Frame  Time(UT)      Range   Height  Vel      IntenR  mV-Vmag  mV-Flux  Lat       Long      AzimS   ZenAng 
			  -----------------------------------------------------------------------------------------------------------
			  164.5  07:11:28.474  094.60  082.16  017.468  001760  0001.57  0001.74  038.1750  -122.1720  122.84  029.95
			  165.0  07:11:28.491  094.50  081.97  017.468  002409  0001.12  0001.28  038.1773  -122.1721  123.08  030.08
			  165.5  07:11:28.508  094.42  081.83  017.468  002852  0000.86  0001.03  038.1792  -122.1716  123.34  030.17
			  166.0  07:11:28.524  094.31  081.63  017.467  002560  0001.05  0001.22  038.1817  -122.1714  123.62  030.30
			  166.5  07:11:28.541  094.23  081.46  017.467  002240  0001.28  0001.44  038.1836  -122.1714  123.84  030.41
			  167.0  07:11:28.558  094.14  081.30  017.466  001988  0001.47  0001.64  038.1857  -122.1709  124.11  030.52
			  167.5  07:11:28.574  094.05  081.15  017.466  002528  0001.12  0001.28  038.1878  -122.1705  124.37  030.61
			  168.0  07:11:28.591  093.96  080.97  017.465  002724  0001.01  0001.18  038.1901  -122.1702  124.64  030.73
			  168.5  07:11:28.608  093.86  080.79  017.464  002600  0001.10  0001.27  038.1924  -122.1699  124.92  030.85
			  169.0  07:11:28.625  093.78  080.62  017.464  002528  0001.16  0001.33  038.1944  -122.1697  125.15  030.97
			  169.5  07:11:28.641  093.71  080.48  017.463  002636  0001.11  0001.27  038.1963  -122.1693  125.37  031.06
			  170.0  07:11:28.658  093.61  080.27  017.461  002525  0001.19  0001.36  038.1988  -122.1692  125.66  031.20
			  170.5  07:11:28.675  093.53  080.12  017.460  002669  0001.12  0001.28  038.2007  -122.1689  125.88  031.31
			  171.0  07:11:28.691  093.45  079.96  017.458  002836  0001.03  0001.19  038.2028  -122.1686  126.14  031.42
			  171.5  07:11:28.708  093.37  079.78  017.457  002773  0001.08  0001.24  038.2050  -122.1684  126.38  031.55
			  172.0  07:11:28.725  093.29  079.62  017.454  002505  0001.26  0001.42  038.2071  -122.1681  126.61  031.66
			  172.5  07:11:28.741  093.20  079.45  017.452  002696  0001.15  0001.32  038.2095  -122.1673  126.91  031.76
			  173.0  07:11:28.758  093.12  079.28  017.449  002804  0001.10  0001.26  038.2115  -122.1674  127.11  031.89
			  173.5  07:11:28.775  093.05  079.13  017.446  003081  0000.95  0001.12  038.2135  -122.1670  127.35  032.00
			  174.0  07:11:28.791  092.97  078.97  017.442  003295  0000.85  0001.01  038.2156  -122.1666  127.60  032.11
			  174.5  07:11:28.808  092.90  078.81  017.437  002923  0001.07  0001.23  038.2176  -122.1664  127.80  032.23
			  175.0  07:11:28.825  092.82  078.63  017.432  003194  0000.93  0001.09  038.2197  -122.1663  128.05  032.36
			  175.5  07:11:28.841  092.75  078.45  017.426  002923  0001.09  0001.25  038.2219  -122.1661  128.27  032.49
			  176.0  07:11:28.858  092.67  078.29  017.419  002968  0001.08  0001.24  038.2241  -122.1657  128.53  032.61
			  176.5  07:11:28.875  092.60  078.12  017.411  002994  0001.07  0001.24  038.2262  -122.1653  128.77  032.73
			  177.0  07:11:28.891  092.53  077.96  017.401  002745  0001.23  0001.39  038.2282  -122.1652  128.97  032.85
			  177.5  07:11:28.908  092.46  077.80  017.390  002446  0001.43  0001.59  038.2304  -122.1646  129.21  032.96
			  178.0  07:11:28.925  092.39  077.63  017.378  002278  0001.55  0001.72  038.2326  -122.1645  129.45  033.09
			  178.5  07:11:28.942  092.33  077.48  017.363  002497  0001.42  0001.58  038.2345  -122.1641  129.66  033.20
			  179.0  07:11:28.958  092.26  077.30  017.345  002611  0001.35  0001.52  038.2366  -122.1641  129.87  033.34
			  179.5  07:11:28.975  092.19  077.15  017.325  002198  0001.64  0001.80  038.2385  -122.1639  130.08  033.46
			  180.0  07:11:28.992  092.13  076.99  017.302  001966  0001.82  0001.98  038.2406  -122.1634  130.30  033.57
			  180.5  07:11:29.008  092.06  076.81  017.275  001693  0002.05  0002.21  038.2429  -122.1631  130.54  033.71
			  181.0  07:11:29.025  092.00  076.67  017.244  001699  0002.05  0002.22  038.2448  -122.1627  130.75  033.82
			  181.5  07:11:29.042  091.93  076.48  017.207  001724  0002.04  0002.21  038.2471  -122.1626  130.99  033.97
			  182.0  07:11:29.058  091.87  076.32  017.165  001762  0002.02  0002.18  038.2492  -122.1622  131.20  034.08
			  182.5  07:11:29.075  091.81  076.16  017.116  001583  0002.18  0002.35  038.2512  -122.1620  131.41  034.21
			  183.0  07:11:29.092  091.75  076.01  017.059  001351  0002.41  0002.58  038.2532  -122.1617  131.61  034.33
			  183.5  07:11:29.108  091.69  075.85  016.992  001320  0002.45  0002.62  038.2552  -122.1615  131.82  034.45
			  184.0  07:11:29.125  091.64  075.68  016.915  001527  0002.26  0002.42  038.2572  -122.1613  132.01  034.58
			  184.5  07:11:29.142  091.58  075.53  016.826  001435  0002.35  0002.52  038.2591  -122.1610  132.21  034.70
			  185.0  07:11:29.158  091.52  075.37  016.722  001228  0002.58  0002.74  038.2613  -122.1607  132.42  034.83
			  185.5  07:11:29.175  091.47  075.19  016.601  000901  0002.99  0003.15  038.2634  -122.1606  132.62  034.97
			  186.0  07:11:29.192  091.42  075.06  016.461  000977  0002.89  0003.06  038.2652  -122.1601  132.82  035.07
			  186.5  07:11:29.208  091.36  074.89  016.299  000619  0003.47  0003.64  038.2674  -122.1596  133.04  035.21
			  187.0  07:11:29.225  091.32  074.76  016.110  000633  0003.45  0003.62  038.2688  -122.1598  133.16  035.31
			  187.5  07:11:29.242  091.26  074.58  015.891  000747  0003.26  0003.42  038.2713  -122.1593  133.41  035.46
			  188.0  07:11:29.259  091.21  074.42  015.636  001841  0002.05  0002.21  038.2732  -122.1591  133.59  035.59
			  188.5  07:11:29.275  091.16  074.27  015.341  001638  0002.23  0002.39  038.2752  -122.1588  133.79  035.71
			  189.0  07:11:29.292  091.12  074.13  014.998  001775  0002.12  0002.28  038.2771  -122.1586  133.97  035.83
			  189.5  07:11:29.309  091.07  073.98  014.599  001902  0002.02  0002.18  038.2790  -122.1581  134.16  035.94
			  190.0  07:11:29.325  091.03  073.84  014.136  001746  0002.15  0002.32  038.2807  -122.1580  134.32  036.06


:DONE
!bat_pop!
	call :SAVECONFIG
	!bat_popecho!
	!bat_echolog! [!date! !time!] !bat_batchfile!:DONE with %0 %* [!bat_returncode!]
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
exit /b !bat_returncode!